$(document).ready(function () {

	$('body').on('click', '.invoice-order-pay', function () {
		var bonus = parseFloat($('option:selected', '#wallets-my').attr('rel'));
		var order_od = $(this).attr('rel');
		var err = '';

		var amount = parseFloat($('.invoice-total-sum').html());

		if (amount < 1 || amount > bonus) {
			err += '<p>На вашем счету недостаточно средств для выполнения операции.</p>';
		}

		if (err == '') {
			BootstrapDialog.show({
				title: 'Информационное сообщение',
				message: 'Вы подтверждаете оплату за данный товар?',
				animate: false,
				buttons: [
					{
						label: 'Подтвердить',
						cssClass: 'btn-success',
						action: function (dialogItself) {
							$.ajax({
								url: '/wallet/setinvoiceorderpay',
								type: 'POST',
								dataType: 'json',
								data: {
									order_id: order_od
								},
								success: function (results) {
									if (results.status == 200) {
										BootstrapDialog.show({
											title: 'Информационное сообщение',
											message: results.message,
											animate: true,
											closable: false,
											buttons: [
												{
													label: 'Закрыть',
													action: function (dialogItself) {
														window.location.replace("/buy");
													}
												}]
										});
									} else {
										message_info(results.message);
									}
								}
							});
							dialogItself.close();
						}
					},
					{
						label: 'Отмена',
						action: function (dialogItself) {
							dialogItself.close();
						}
					}]
			});
		} else {
			message_info(err);
			return false;
		}
	});

	$('body').on('change keyup input click', '#bonus-active-pay-amount', function () {
		if (this.value.match(/[^0-9]/g)) {
			this.value = this.value.replace(/[^0-9]/g, '');
		}
		var value = $(this).val();
		var bonus = parseInt($('.active_bonus').attr('rel'));
		if(value >= bonus) $(this).val(bonus);
	});

	$('body').on('click', '.bonus-active-pay', function () {
		var bonus = parseInt($('.active_bonus').attr('rel'));
		BootstrapDialog.show({
			message:
				'<div class="payment_modal">' +
					'<div class="modal_header">' +
						'<div class="tab">Оплата</div>' +
							'<button aria-hidden="true" data-dismiss="modal" class="close">×</button>' +
						'</div>' +
						'<div class="modal_wrap">' +
							'<div class="payment_modal_in">' +
								'<p>Для  проведения оплаты укажите почту пользователя, сумму и назначение платежа</p>' +
								'<form name="" action="" method="" class="payment_modal_form">' +
									'<div class="form-group">' +
										'<label  class="col-xs-12" for="bonus-active-pay-amount">Сумма перевода:</label>' +
										'<input type="text" class="col-xs-6" id="bonus-active-pay-amount" placeholder="0" required>' +
									'</div>' +
									'<div class="form-group">' +
										'<label for="bonus-active-pay-email">Пользователю:</label>' +
										'<input type="email" class="form-control" id="bonus-active-pay-email" placeholder="Введите E-mail" required>' +
									'</div>' +
									'<div class="form-group">' +
										'<label for="bonus-active-pay-text">Назначение:</label>' +
										'<textarea class="exampletext form-control" id="bonus-active-pay-comment" placeholder="Введите комментарий к оплате"></textarea>' +
									'</div>' +
								'</form>' +
							'</div>' +
						'</div>' +
				'</div>',
			cssClass: 'no-title',
			buttons: [
				{
					label: 'Отправить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						var err = '';

						var amount = $('#bonus-active-pay-amount').val();
						var email = $('#bonus-active-pay-email').val();
						var comment = $('#bonus-active-pay-comment').val();

						if (amount < 1 || amount > bonus) {
							err += '<p>Недопустимая сумма перевода.</p>';
						}
						var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
						if (!regex.test(email)) {
							err += '<p>E-mail указано неверно.</p>';
						}
						if (comment == '') {
							err += '<p>Необходимо указать комментарий к оплате.</p>';
						}

						if (err == '') {
							$.ajax({
								url: '/wallet/setwalletpay',
								type: 'POST',
								dataType: 'json',
								data: {
									amount: amount,
									email: email,
									comment: comment
								},
								success: function (results) {
									if (results.status == 200) {
										dialogRef.close();
										message_info(results.message);
									} else {
										message_info(results.message);
									}
								}
							});
						} else {
							message_info(err);
							return false;
						}
					}
				}]
		});

	});


	$('body').on('click', '.bonus-ref-move', function () {
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);

		BootstrapDialog.show({
			title: 'Информационное сообщение',
			message: 'Вы подтверждаете перевод призовых бонусов в активные?',
			animate: false,
			buttons: [
				{
					label: 'Подтвердить',
					cssClass: 'btn-success',
					action: function (dialogItself) {
						$.ajax({
							url: 'wallet/setbonussendactive',
							type: 'POST',
							dataType: 'json',
							success: function (results) {
								if (results.status == 200 && results.redirect != '') {
									message_info(results.message);
									//getwallets();
									getwallets_potential();
								} else {
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						dialogItself.close();
					}
				},
				{
					label: 'Отмена',
					action: function (dialogItself) {
						dialogItself.close();
					}
				}]
		});
	});
});