$('document').ready(function () {

	$('body').on('change', '.post-category', function (event) {
		event.preventDefault();
		$('.post-category').val($(this).val());
	});

	$(".js-data-ajax-city").select2({
		ajax: {
			url: "/ajax/cities",
			type: 'POST',
			dataType: 'json',
			delay: 250,
			data: function (params) {
				return {
					q: params.term,
					id: $('#filter_country').val()
				};
			},
			processResults: function (data, params) {
				params.page = params.page || 1;
				return {
					results: data.cities,
					pagination: {
						more: (params.page * 30) < data.total_count
					}
				};
			},
			cache: true
		},
		escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
		minimumInputLength: 2,
		templateResult: formatRepo, // omitted for brevity, see the source of this page
		templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
	});

	$('#filter_country').on('change', function() {
		$('#filter_city').val(-1);
		$('#select2-filter_city-container').html('Выберите город...');
	});

	$('.filter_find, #filter_order').on('change', function() {
		feedFilter(1, true);
	});

	$('#filter_text').on('keyup', function() {
		var text = $(this).val();
		if( (text != '' && text.length > 2) || text == ''){
			feedFilter(1, true);
		}
	});

	$('#filter_country, #filter_city').on('change', function() {
		feedFilter(1, true);
	});

	$('body').on('change', '#type', function (event) {
		event.preventDefault();
		var type = $(this).val();

		if(type == 2 || type == 3){
			$('.post-category-wrapper').slideDown(200)
		}else{
			$('.post-category-wrapper').slideUp(100);
		}
		feedFilter(1, true);
	});

    $('body').on('mouseenter', '.filter_tabs ul li.other', function (event) {
        event.preventDefault();

        $( ".filter_tabs ul li.other .other_dropdown" ).show();
    });

    $('body').on('mouseleave', '.filter_tabs ul li.other', function (event) {
        event.preventDefault();

        $( ".filter_tabs ul li.other .other_dropdown" ).hide();
    });

	$('body').on('click', '.user-filter-item', function (event) {
		event.preventDefault();
        var span = $(this).find('span');

		var category_id = $(span).find('span').attr('data-category_id');
		var category_name = $(span).attr('data-category_name');
		var city_id = $(span).attr('data-city_id');
		var city_name = $(span).attr('data-city_name');
		var country_id = $(span).attr('data-country_id');
		var country_name = $(span).attr('data-country_name');
		var type = $(span).attr('data-type');
		var place = $(span).attr('data-place');
		var sort = $(span).attr('data-sort');
		var query_text = $(span).attr('data-query_text');

		$('#filter_text').val(query_text);
		$('.filter_find[value="'+place+'"]').prop("checked", true);

		if(type == 2 || type == 3){
			$('.post-category-wrapper').show();

			$('#filter_category').val(category_id);
			$('[aria-labelledby="select2-filter_category-container"] span').attr('title', category_name);
			$('[aria-labelledby="select2-filter_category-container"] span').html(category_name);
		}else{
			$('.post-category-wrapper').hide();
		}
		$('.user-filter-item').removeClass('active');
		$(this).addClass('active');

		$('.filter_tabs li').removeClass('active');
		$('.filter_tabs li[data-type="'+type+'"]').addClass('active');

		$('#filter_country').append($('<option>', {value: country_id, country_id: country_name}));
		$('#filter_country').val(country_id);
		$('#select2-filter_country-container').attr('title', country_name != '' ? country_name : 'Выберите страну...');
		$('#select2-filter_country-container').html(country_name != '' ? country_name : 'Выберите страну...');

		$('#filter_city').append($('<option>', {value: city_id, country_id: city_name}));
		$('#filter_city').val(city_id);
		$('#select2-filter_city-container').attr('title', city_name != '' ? city_name : 'Выберите город...');
		$('#select2-filter_city-container').html(city_name != '' ? city_name : 'Выберите город...');

		$('#filter_order').val(sort);
		$('#filter_find').val(place);

        $( ".filter_tabs ul li.other .other_dropdown" ).hide();
        feedFilter(1, true);
	});

	$('body').on('click', '.user-filter-delete', function (event) {
		event.preventDefault();
        event.stopPropagation();

		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax", 0);

		var id = $(this).attr('data-id');

		BootstrapDialog.show({
			title: 'Информационное сообщение',
			message: 'Удалить фильтр?',
			animate: true,
			buttons: [
				{
					label: 'Подтвердить',
					cssClass: 'btn-success',
					action: function (dialogRef) {

						$.ajax({
							url: '/user/userfilterdelete',
							type: 'POST',
							dataType: 'json',
							data: {
								id: id
							},
							success: function (results) {
								if (results.status == 200) {
									$(elem).closest('li').remove();
									getFilters();
								}else{
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						dialogRef.close();
					}
				},
				{
					label: 'Отмена',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}
			],
			onhide: function(dialogRef){
				$(elem).attr("data-ajax",1);
			}
		});
	});

	$('body').on('click', '.save-filter-btn', function () {
		event.preventDefault();

		var ajax = 1;
		BootstrapDialog.show({
			title: 'Информационное сообщение',
			message:
			'<p><strong>Введите название фильтра:</strong></p>' +
			'<input type="text" placeholder="" id="user_filter_name" class="modal-input" style="width: 100%; max-width: 300px;">',
			animate: false,
			buttons: [
				{
					label: 'Сохранить',
					cssClass: 'btn-success',
					action: function (dialogItself) {
						if (ajax == 0) return; ajax = 0;

						var err = '';

						var filter_name = $('#user_filter_name').val();
						var type = $('.filter_tabs li.active').attr('data-type');
						var query_text = $('#filter_text').val();
						var category_id = $('#filter_category').val();
						var country_id = $('#filter_country').val();
						var city_id = $('#filter_city').val();
						var place = $("#filter_find").val();
						var sort = $("#filter_order").val();

						if(filter_name == ''){
							err = '<li>Введите название фильтра.</li>';
						}

						if(err == ''){
							$.ajax({
								url: '/user/setuserfilter',
								type: 'POST',
								dataType: 'json',
								data: {
									filter_name: filter_name,
									type: type,
									query_text: query_text,
									category_id: category_id,
									country_id: country_id,
									city_id: city_id,
									place: place,
									sort: sort
								},
								success: function (results) {
									if (results.status == 200) {
										if(results.filter){
											getFilters();
										}
									} else {
										message_info(results.message);
									}
								},
								complete: function () {
									ajax = 1;
								}
							});
							dialogItself.close();
						}else{
							message(err);
						}
					}
				},
				{
					label: 'Отмена',
					action: function (dialogItself) {
						dialogItself.close();
					}
				}]
		});
	});

	getFilters();
});

function getFilters(){
	$.ajax({
		url: '/user/getfilters',
		type: 'POST',
		dataType: 'json',
		data: {
		},
		success: function (results) {
			if (results.status == 200) {
				$('.filters_list').html('');

				if(results.filters.length > 0){
					for (var i = 0; i < results.filters.length; i++) {
						$('.filters_list').append(generateFilter(results.filters[i]));
					}
					$('.filters-my').show();
				}else{
					$('.filters-my').hide();
				}
			}
		}
	});
}

function generateFilter(val){
	var html = '';

	html += '<li class="user-filter-item"><span ' +
		'data-category_id="'+(val.category_id != '0' ? val.category_id : -1) + '"'+
		'data-category_name="'+(val.category_name != '' ? val.category_name : '') + '"'+
		'data-city_id="'+(val.city_id != '0' ? val.city_id : -1) + '"'+
		'data-city_name="'+(val.city_name != '' ? val.city_name : '') + '"'+
		'data-country_id="'+(val.country_id != '0' ? val.country_id : -1) + '"'+
		'data-country_name="'+(val.country_name != '' ? val.country_name : '') + '"'+
		'data-type="'+val.type + '"'+
		'data-place="'+val.place + '"'+
		'data-sort="'+val.sort + '"'+
		'data-query_text="'+val.query_text + '"'+
		' ></span>'+val.name+'<i class="fa fa-times user-filter-delete" data-id="'+val.id+'" aria-hidden="true"></li>';

	return html;
}