/**
 * Emotions is a jQuery plugin that makes it easy to convert some emotion text to images (e.g 8) )
  *
 * @name emotions
 * @version 0.0.1
 * @requires jQuery v1.2.3+
 * @license MIT License - http://www.opensource.org/licenses/mit-license.php
 *
 * For usage and examples, visit:
 * http://www.itlessons.info/javascript/facebook-or-icq-jquery-emotions-plugin/
 *
 * Copyright (c) 2013, www.itlessons.info
 */
(function ($) {

    $.emotions = function (text) {
        return $.emotions.parse(text);
    };

    var $t = $.emotions;

    $.extend($.emotions, {


        settings: {
            replacement: '<img title="(eId)" data-smile="(eId)" src="/images/smile-images/smile(eId).jpg" class="emotions emo-(eId)">',
            map: {
                "(s:1)": "1",
                "(s:2)": "2",
                "(s:3)": "3",
                "(s:4)": "4",
                "(s:5)": "5",
                "(s:6)": "6",
                "(s:7)": "7",
                "(s:8)": "8",
                "(s:9)": "9",
                "(s:10)": "10",
                "(s:11)": "11",
                "(s:12)": "12",
                "(s:13)": "13",
                "(s:14)": "14",
                "(s:15)": "15",
                "(s:16)": "16",
                "(s:17)": "17",
                "(s:18)": "18",
				"(s:19)": "19",
				"(s:20)": "20",
				"(s:21)": "21",
				"(s:22)": "22",
				"(s:23)": "23",
				"(s:24)": "24",
				"(s:25)": "25",
				"(s:26)": "26",
				"(s:27)": "27",
				"(s:28)": "28",
				"(s:29)": "29",
				"(s:30)": "30",
				"(s:31)": "31",
				"(s:32)": "32",
				"(s:33)": "33",
				"(s:34)": "34",
				"(s:35)": "35",
				"(s:36)": "36",
				"(s:37)": "37",
				"(s:38)": "38",
				"(s:39)": "39",
				"(s:40)": "40",
				"(s:41)": "41",
				"(s:42)": "42",
				"(s:43)": "43",
				"(s:44)": "44"
            }
        },
        shortcode: function(eId){
            var $s = $t.settings;
            for (var pattern in $s.map) {
                if($s.map[pattern] == eId)
                    return pattern;
            }

            return "";
        },
        parse: function (text) {

            var $s = $t.settings;

            for (var pattern in $s.map) {

                var encPattent = $t.encode(pattern);

                if (text.indexOf(pattern) < 0 && text.indexOf(encPattent) < 0) {
                    continue;
                }

                var rep = $s.replacement
                    .replace(/\(eId\)/g, $s.map[pattern]);

                text = text
                    .replace(new RegExp($t.quote(pattern), "g"), rep)
                    .replace(new RegExp($t.quote(encPattent), "g"), rep);
            }

            return text;
        },
        encode: function (str) {
            return (str + '')
                .replace(/&/g, '&amp;')
                .replace(/</g, '&lt;')
                .replace(/>/g, '&gt;')
                .replace(/"/g, '&quot;');
        },
        quote: function (str) {
            return (str + '').replace(/([.?*+^$[\]\\(){}|-])/g, "\\$1");
        }
    });

    $.fn.emotions = function (action, options) {
        this.each(function () {
            var el = $(this);
            el.html($.emotions(el.html()));
        });
    };
})(jQuery);