$('document').ready(function () {

	$('body').on('click', '.comment-answer', function () {
		event.preventDefault();
		var name = $(this).data('name');
		var post_id = $(this).data('post-id');
		var comment_id = $(this).data('answer');

		$('#reply_field_'+post_id).attr('data-answer', comment_id);
		$('#reply_field_'+post_id).empty().show().html(name+',&nbsp;').focus();
		f_caret(document.getElementById('reply_field_'+post_id));
	});

	$('body').on('click', '.post_delete', function () {
		event.preventDefault();
		var elem = $(this);
		var id = $(this).attr('data-id');

		BootstrapDialog.show({
			title: 'Сообщение',
			message: 'Удалить данную публикацию?',
			animate: false,
			buttons: [
				{
					label: 'Подтвердить',
					cssClass: 'btn-success',
					action: function (dialogItself) {
						$.ajax({
							url: '/post/delete',
							type: 'POST',
							dataType: 'json',
							data: {
								id: id
							},
							success: function (results) {
								if (results.status == 200) {
									elem.closest('.push-down-30').remove();
								} else {
									error(results.message);
								}
							}
						});
						dialogItself.close();
					}
				},
				{
					label: 'Отмена',
					action: function (dialogItself) {
						dialogItself.close();
					}
				}]
		});
		return false;
	});


	$('body').on('click', '.post_dislike', function () {
		event.preventDefault();
		var id = $(this).attr('data-id');

		BootstrapDialog.show({
			title: 'Сообщение',
			message: 'Пожаловаться на содержимое данного поста ?',
			animate: false,
			buttons: [
				{
					label: 'Пожаловаться',
					cssClass: 'btn-success',
					action: function (dialogRef) {

						$.ajax({
							url: '/post/dislike',
							type: 'POST',
							dataType: 'json',
							data: {
								post: id
							},
							success: function (results) {
								if (results.status == 200) {
									message(results.message);
								}else{
									message(results.message);
								}
							}
						});

						dialogRef.close();

					}//
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						dialogItself.close();
					}
				}]
		});
	});

	$('body').on('click', '.filter_tabs li', function () {
		var type = $(this).attr('data-type');

		$('.filter_tabs li').removeClass('active');
		$(this).addClass('active');
		if(type == 2 || type == 3){
			$('.create_post .post-category-wrapper').show();
		}else{
			$('.create_post .post-category-wrapper').hide();
		}
	});

	$('body').on('click', '.video', function () {
		event.preventDefault();
		isAttaching = true;
		var elem = $(this);
		var post_id = $(elem).data("post-id");
		var str = decodeURIComponent(elem.attr('data-value'));
		var media = jQuery.parseJSON(str);

		if (media.items.length + 1 > 1) {
			error('<p>Вы не можете добавить более 1 видео в одном сообщении.</p>');
			return false;
		}

		BootstrapDialog.show({
			title: 'Загрузка новой видеозаписи',
			message: '<div class="download_video_modal"><div class="download_video_modal_header"><div class="tab">Загрузка новой видеозаписи</div><button aria-hidden="true" data-dismiss="modal" class="close">×</button></div><div class="download_video_modal_wrap"><div class="download_video_modal_wrap_in"><p>Вы можете указать ссылку видиозаписи на Youtube:</p><form name="" action="" method=""><input type="text" placeholder="https://"></form></div></div></div>',
			animate: false,
			cssClass: 'no-title',
			buttons: [
				{
					label: 'Добавить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						var key = f_youtube_id(dialogRef.getModalBody().find('input').val());
						if (key) {
							media.items.push(key);
							var stringData = encodeURIComponent(JSON.stringify(media));
							elem.attr('data-value', stringData);
							var txt = '<div class="thumb_wrap"><img width="80px" height="60px" src="http://img.youtube.com/vi/' + key + '/0.jpg"/><a href="#" class="thumb_xvid_button" data-key="' + key + '" data-postid="' + post_id + '">×</a></div>';
							$('#post-form').append(txt);
							dialogRef.close();
						} else {
							error('<p>YouTube гиперссылка не действительна.</p>');
							return false;
						}
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						dialogItself.close();
					}
				}]
		});
		$('.video_pop_up input').focus();
	});

	$('body').on('click', '.post-like[data-load=1]', function (event) {
		access_control();
		event.preventDefault();
		var elem = $(this);
		elem.attr('data-load', 0);
		var id = $(this).data("id");
		$.ajax({
			url: '/ajax/postlike',
			type: 'POST',
			dataType: 'json',
			data: {
				post: id
			},
			success: function (results) {
				if (results.status == 200) {
					$(elem).closest('.post').find('.post_likes p:first span').html(results.like_count);
                    $(elem).closest('.post').find('.post-like-title').html('Нравится <span>'+results.like_count+'</span> '+strToNum(results.like_count, ['человеку', 'людям', 'людям']));
                    if(results.like_my){
                        $(elem).closest('.post').find('.like-my').show();
                    }else{
                        $(elem).closest('.post').find('.like-my').hide();
                    }
				}
				elem.attr('data-load', 1);
			}
		});
		return false;
	});

	$('body').on('click', '.make-comment', function () {
		event.preventDefault();
		$(this).closest('.post').find('.message-content').focus();
		f_caret(document.getElementById('reply_field_'+$(this).closest('.boxed').attr('data-post-id')));
		$('html, body').animate({
			scrollTop: $(this).closest('.post').find('.message-content').offset().top-150
		}, 200);
	});

	$('body').on('click', '.re-post[data-reposted=1]', function () {
		event.preventDefault();
		message_info('Запись уже на Вашей странице.');
	});

	$('body').on('click', '.re-post[data-reposted=0]', function (event) {
		access_control();
		event.preventDefault();
		var elem = $(this);
		var id = $(this).data("id");

		elem.attr('data-reposted', 1);
		$.ajax({
			url: '/post/repost',
			type: 'POST',
			dataType: 'json',
			data: {
				post: id
			},
			success: function (results) {
				if (results.status == 200) {
					message_info(results.message);
					$(elem).closest('.post').find('.post_likes p:eq(2) span').html(results.post.repost_count);
				}else{
					message_info(results.message);
				}
			}
		});
		return false;
	});

	$('body').on('click', '.media-cover', function () {
		$('.post-content--front-page iframe').each(function() {
			var id = $(this).attr('data-id');
			html = '<div class="media-cover" data-id="'+id+'" style="position: relative; left: 0; top: 0;"><img src="http://img.youtube.com/vi/'+id+'/sddefault.jpg" style="position: relative;"/><img src="/images/youtube-play.png" style="position: absolute;"/></div>';
			$(this).replaceWith(html);
		});

		var id = $(this).data('id');
		var width = $(this).width();
		var height = $(this).height();
		var html = '<iframe data-id="'+id+'" class="post-media" width="'+width+'px" height="'+height+'px" src="//www.youtube.com/embed/'+id+'?autoplay=1" frameborder="0" allowfullscreen></iframe>';
		$(this).replaceWith(html);
	});

	$('body').on('click', '.post-like .read-more__like_popup', function (event) {
		access_control();
		event.preventDefault();

		var elem = $(this);
		var modal = elem.parent().find('.modal_wrap');
		var likes_tab = elem.parent().find('.likes-content');
		var post_id = modal.attr('data-post-id');
		modal.show();

		if($(likes_tab).attr('data-modal-loaded') == '0'){
			$.ajax({
				url: '/ajax/postgetlikes',
				type: 'POST',
				dataType: 'json',
				data: {
					post_id: post_id
				},
				success: function (results) {
					if (results.status == 200) {
						$(likes_tab).attr('data-modal-loaded', '1');
						var reposts = parseInt($('.read-more__repost[data-id='+post_id+'] span').html());

						var repost_text = reposts == 1 ? '<span>1</span> поделился' : '<span>'+reposts+'</span> поделились';
						var text = results.count == 1 ? '<span>1</span> оценил' : '<span>'+results.count+'</span> оценили';
						var html = '';
						if(results.likes){
							for(var i = 0; i < results.likes.length; i++){
								html += '<div><a href="/'+results.likes[i].alias+'"><img src="http://'+results.likes[i].photo+'_sm.jpg" alt="'+results.likes[i].name+'"></a><a href="/'+results.likes[i].alias+'"><span style="font-size: 9.5px;">'+results.likes[i].name+'</span></a></div>';
							}
							likes_tab.empty().append(html);
						}
						modal.find("[rel=likes-content]").empty().append(text);
						modal.find("[rel=shares-content]").empty().append(repost_text);
					}
				}
			});
		}
	});

	$('body').on('click', '.add-wall-post-btn', function () {
		event.preventDefault();
		var form = $(this).closest('form');

		var text = editableVal($('.add-wall-post-text')[0]);
		var type = $('.filter_tabs .active').attr('data-type');
		var category = $('.post-category').val();
		var post_show = $('#post_show').val();
		var media_str = $('#attaches_').val();
		var media_vid_str = $('#media_vid_0').attr('data-value');
		var media = jQuery.parseJSON(decodeURIComponent(media_str));
		var media_vid = jQuery.parseJSON(decodeURIComponent(media_vid_str));
		var fuid = $(this).attr('data-fuid');

		if (text || media.items.length > 0 || media_vid.items.length > 0  || text != '') {
			if (text.length <= 5000) {
				$.ajax({
					url: '/post/postadd',
					type: 'POST',
					dataType: 'json',
					data: {
						text: text,
						type: type,
						post_show: post_show,
						category: category,
						media: media.items.join(','),
						media_vid: media_vid.items.join(','),
						fuid: fuid
					},
					success: function (results) {
						if (results.status == 200 && results.post) {
							
							$('.add-wall-post-text').val();
							
							var html = '<div class="boxed boxed_post_with_single_image  push-down-30" data-load=' + (results.post.comment == 0 ? 1 : 0) + ' data-post-id="' + results.post.id + '"><section class="post repost">';
							html += generatePost(results.post, false);
							html += '</section></div>';

							$('.wall-posts').prepend(html);
							$($('.wall-posts').find('.boxed')[0]).slideDown(300);
							$('.add-wall-post-text').html('');

							$(form).find('div.thumb_wrap').remove();
							$('#attaches_').val('%7B%22items%22%3A%5B%5D%7D');
							$('#media_vid_0').attr('data-value', '%7B%22items%22%3A%5B%5D%7D');
						} else {
							error(results.message);
							return false;
						}
					}
				});
				isAttaching = false;
			} else {
				BootstrapDialog.show({
					title: 'Предупреждение',
					message: 'Длина текста не должна превышать 5000 символов.',
					animate: false,
					type: BootstrapDialog.TYPE_WARNING,
					closable: true,
					draggable: false,
					buttons: [
						{
							label: 'Закрыть',
							action: function (dialogItself) {
								dialogItself.close();
							}
						}]
				});
			}
		}
	});
	
	
	//LIKES START
    $('body').on('mouseenter', '.post_likes_amount, .post_likes_popover' , function(){
        var elem = $(this);
        if(parseInt(elem.html()) == 0) return;
        $(elem).closest('.post_likes').find('.post_likes_popover').css('display', 'block');
    });
    $('body').on('mouseleave', '.post_likes_amount, .post_likes_popover' , function(){
        var elem = $(this);
        $(elem).closest('.post_likes').find('.post_likes_popover').css('display', 'none');
    });

    //LIKES END
	
	
	$('body').on('click', '.post_edit', function (event) {
        event.preventDefault();
        var elem = $(this);
        var container = $(elem).closest('.post');

        $(container).find('.message-content-footer').show();
        $(container).find('.post_content .message-content').attr('contenteditable', 'true');
        $(container).find('.post_content .message-content').addClass('active');
        $(container).find('.post_content .message-content').css('overflow-y', 'auto');
    });

    $('body').on('click', '.post-edit-cancel', function (event) {
        event.preventDefault();
        var elem = $(this);
        var container = $(elem).closest('.post');

        $(container).find('.message-content-footer').hide();
        $(container).find('.post_content .message-content').attr('contenteditable', 'false');
        $(container).find('.post_content .message-content').removeClass('active');
        $(container).find('.post_content .message-content').css('overflow-y', 'hidden');
    });

    $('body').on('click', '.post-edit', function (event) {
        event.preventDefault();
        var elem = $(this);
        var container = $(elem).closest('.post');

        var id = $(elem).attr('data-id');
        var text = editableVal($(container).find('.post_content .message-content')[0]);

        var regex = /<br\s*[\/]?>/gi;
        text = text.replace(regex, "\n");

        if (text != '') {
            if (text.length <= 5000) {
                $.ajax({
                    url: '/post/postedit',
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        id: id,
                        text: text
                    },
                    success: function (results) {
                        if (results.status == 200) {
                            $(container).find('.message-content-footer').hide();
                            $(container).find('.post_content .message-content').attr('contenteditable', 'false');
                            $(container).find('.post_content .message-content').removeClass('active');
                        } else {
                            error(results.message);
                            return false;
                        }
                    }
                });
                isAttaching = false;
            } else {
                BootstrapDialog.show({
                    title: 'Предупреждение',
                    message: 'Длина текста не должна превышать 5000 символов.',
                    animate: false,
                    type: BootstrapDialog.TYPE_WARNING,
                    closable: true,
                    draggable: false,
                    buttons: [
                        {
                            label: 'Закрыть',
                            action: function (dialogItself) {
                                dialogItself.close();
                            }
                        }]
                });
            }
        }
    });
	

});

function loadComments(uid){
	var posts = $(".wall-posts, .post_modal").find('[data-load="0"]');
	$.each(posts, function(i) {
		if($(posts[i]).visible(true)){
			var post_id = $(posts[i]).data('post-id');
			$(posts[i]).attr('data-load', 1);
			$.ajax({
				url: '/ajax/postgetcomments',
				type: 'POST',
				dataType: 'json',
				data: {
					post_id: post_id,
					part: 1
				},
				success: function (results) {
					if (results.status == 200) {
						if(results.comments.length > 0){
							results.comments.reverse();
							var html = '';

							if(results.count > 3){
								html += '<div class="comment_block_header"><div class="number_of_comments"><span class="from">3</span> из <span class="to">'+results.count+'</span></div><a href="#" class="replies-manager" onclick="showComments('+post_id+', '+results.count+', this, '+uid+');">Показать предыдущие комментарии</a></div>';
							}
							for(var m = 0; m <= results.comments.length-1; m++){
								html += generateComment(results.comments[m], uid);
							}


							$('.comment-posted-block-'+post_id).closest('.post').find('.post_likes p:eq(1) span').html(results.count);
							$('.comment-posted-block-'+post_id).empty().append(html).show();
							$('.comment-posted-block-'+post_id+' .comment p').linkify();
							
						}
					}
				}
			});
		}
	});
}

function postModalShow(post_id, uid) {
	$.ajax({
		url: '/post/getpost',
		type: 'POST',
		dataType: 'json',
		data: {
			post_id: post_id
		},
		success: function (results) {
			if (results.status == 200) {

				var html = '<div class="boxed boxed_post_with_single_image  push-down-30" data-load=' + (results.post.comment == 0 ? 1 : 0) + ' data-post-id="' + results.post.id + '"><section class="post repost"><button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>';
				html += generatePost(results.post, true);
				html += '</section></div>';

				BootstrapDialog.show({
					message: '<div class="post_modal">' + html + '</div>',
					cssClass: 'no-title',
					animate: false
				});
				loadComments(uid);
			}
		}
	});
}

function hideComments(post_id, count, obj, uid){
	event.preventDefault();

	var comments = $('.comment-posted-block-'+post_id+' .comment');
	for(var i = 0; i < comments.length-3; i++){
		$(comments[i]).hide();
	}

	$(obj).closest('.comment_block_header').find('.from').html('3');
	$(obj).attr("onclick","showComments("+post_id+", "+count+", this, "+uid+");");
	$(obj).html('Показать предыдущие комментарии');
}

function showLikePopUp(elem) {
	var obj = $(elem);
	var post_id = obj.data('id');

	$.ajax({
		url: '/ajax/postgetlikes',
		type: 'POST',
		dataType: 'json',
		data: {
			post_id: post_id,
			part: 1
		},
		success: function (results) {
			if (results.status == 200) {
				var text = results.count > 1 ? 'Понравилось '+results.count+' людям' : 'Понравилось 1 человеку';
				var html = '';
				if(results.likes){
					for(var i = 0; i < results.likes.length; i++){
						html += '<a href="/'+results.likes[i].alias+'"><img class="page-avatar" src="http://'+results.likes[i].photo+'_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';" alt="'+results.likes[i].fio+'" title="'+results.likes[i].fio+'" width="30" height="30"></a>';
					}
				}
				$(obj).find('.read-more__like_popup_text').empty().html(text);
				$(obj).find('.read-more__like_popup').append(html);
				$(obj).attr('data-like-load', 1);
				if(parseInt(results.count) > 0){
					$(obj).find('.read-more__like_popup').removeAttr("style");
				}
			}
		}
	});
}

function showRepostPopUp(elem) {
	var obj = $(elem);
	var post_id = obj.data('id');

	$.ajax({
		url: '/ajax/postgetreposts',
		type: 'POST',
		dataType: 'json',
		data: {
			post_id: post_id,
			part: 1
		},
		success: function (results) {
			if (results.status == 200) {
				var lastNum = results.count.slice(-1);
				var text = $.inArray(lastNum, ['2', '3', '4']) != -1 ? 'Поделились ' + results.count + ' человека' : 'Педелился ' + results.count + ' человек';
				var html = '';
				if (results.reposts) {
					for (var i = 0; i < results.reposts.length; i++) {
						html += '<a href="/' + results.reposts[i].alias + '"><img class="page-avatar" src="http://' + results.reposts[i].photo + '_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';" alt="' + results.reposts[i].fio + '" title="' + results.reposts[i].fio + '" width="30" height="30"></a>';
					}
				}
				$(obj).find('.read-more__repost_popup_text').empty().html(text);
				$(obj).find('.read-more__repost_popup a').not(':first').remove();
				$(obj).find('.read-more__repost_popup').append(html);
				$(obj).attr('data-repost-load', 1);
				if(parseInt(results.count) > 0){
					$(obj).find('.read-more__repost_popup').removeAttr("style");
				}
			}
		}
	});
}

function showComments(post_id, count, obj, uid){
	event.preventDefault();

	if(count <= 3){
		$('.comment-posted-block-'+post_id+' .comment_posted').show();
	}else{
		$.ajax({
			url: '/ajax/postgetcomments',
			type: 'POST',
			dataType: 'json',
			data: {
				post_id: post_id,
				part: 0
			},
			success: function (results) {
				if (results.status == 200) {
					if(results.comments.length > 0){
						var html = '';
						html += '<div class="comment_block_header"><div class="number_of_comments"><span class="from">'+results.count+'</span> из <span class="to">'+results.count+'</span></div><a href="#" class="replies-manager" onclick="hideComments('+post_id+', '+results.count+', this, '+uid+');">Скрыть комментарии</a></div>';

						for(var m = 0; m <= results.comments.length-1; m++){
							html += generateComment(results.comments[m], uid);
						}

						$('.comment-posted-block-'+post_id).empty().append(html);
					}
				}
			}
		});
	}

	$(obj).attr("onclick","hideComments("+post_id+", "+count+", this, "+uid+");");
	$(obj).html('Скрыть комментарии');
}

function getPostCategories(category){
	$.ajax({
		url: '/ajax/getcategories',
		type: 'POST',
		dataType: 'json',
		success: function (results) {
			if (results.status == 200 && results.categories != null) {
				var html = '';
				var categories = _.groupBy(results.categories, 'parent');
				var roots = categories[0];

				html += '<option value="-1">Выберите категорию...</option>';
				$.each(roots, function( index, root ) {
					html += '<option value="'+root['id']+'">'+root['name']+'</option>';
					if(categories[root['id']] != null){
						$.each(categories[root['id']], function( index, cat_2 ) {
							html += '<option value="'+cat_2['id']+'">&nbsp;&nbsp;&nbsp;&nbsp;'+cat_2['name']+'</option>';
							if(categories[cat_2['id']] != null){
								$.each(categories[cat_2['id']], function( index, cat_3 ) {
									html += '<option value="'+cat_3['id']+'">&nbsp;&nbsp;&nbsp;&nbsp;'+cat_3['name']+'</option>';
								});
							}
						});
					}
				});

				$('.post-category').append(html);
				if(category > 0){
					$('.post-category').val(category);
				}

				$(".post-category").select2();
			}
		}
	});
}