$('document').ready(function () {

	$('body').on('change', '.goals-table .checkbox', function () {
		event.preventDefault();
		var elem = $(this);
		var id = elem.attr('data-id');
		var status = $(this).is(':checked') ? 1 : 0;

		$.ajax({
			url: '/user/goalupdate',
			type: 'POST',
			dataType: 'json',
			data: {
				id: id,
				status: status
			},
			success: function (results) {
				if (results.status == 200 && results.goal_status != null) {
					if(results.goal_status == 1){
						elem.closest('tr').addClass('done');
					}else{
						elem.closest('tr').removeClass('done');
					}
					updateGoalsTable();
				}else{
					error(results.message);
					return false;
				}
			}
		});
	});

	$('body').on('click', '.goal-add', function () {
		event.preventDefault();
		var goal_name = $('#goal-name').val();
		var goal_price = $('#goal-price').val();

		$.ajax({
			url: '/user/goaladd',
			type: 'POST',
			dataType: 'json',
			data: {
				goal_name: goal_name,
				goal_price: goal_price
			},
			success: function (results) {
				if (results.status == 200 && results.goal) {
					var html = generateGoal(results.goal);
					$('.goals-table tbody').prepend(html);
					updateGoalsTable();
					$('#goal-name').val('');
					$('#goal-price').val('');
				}else{
					error(results.message);
					return false;
				}
			}
		});
	});

	$('body').on('click', '.goal-delete', function () {
		event.preventDefault();
		var elem = $(this);
		var id = elem.attr('data-id');

		BootstrapDialog.show({
			title: 'Удаление цели',
			message: 'Удалить выбраную цель?',
			animate: false,
			buttons: [
				{
					label: 'Удалить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						$.ajax({
							url: '/user/goaldelete',
							type: 'POST',
							dataType: 'json',
							data: {
								id: id
							},
							success: function (results) {
								if (results.status == 200) {
									elem.closest('tr').remove();
									updateGoalsTable();
								} else {
									error(results.message);
									return false;
								}
							}
						});
						dialogRef.close();

					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						dialogItself.close();
					}
				}]
		});
	});


	$('#goal-price').bind("change keyup input click", function() {
		if (this.value.match(/[^0-9]/g)) {
			this.value = this.value.replace(/[^0-9]/g, '');
		}
	});

	$('body').on('click', '.tab[rel="private-goals"]', function () {
		var elem = this;
		if($('.'+$(elem).attr('rel')).attr('data-load') == 0){
			$.ajax({
				url: '/user/goalsmy',
				type: 'POST',
				dataType: 'json',
				success: function (results) {
					if (results.status == 200 && results.goals) {
						var html = '';

						for(var i = 0; i < results.goals.length; i++){
							html += generateGoal(results.goals[i]);
						}
						$('.goals-table tbody').empty().append(html);
						updateGoalsTable();
					}
					$('.'+$(elem).attr('rel')).attr('data-load', 1);
				}
			});
		}
	});
});

function updateGoodsFilter(){
	if($.cookie('goods_category') != null) {
		$(".project_goods_categories li[data-cat-id='"+$.cookie('goods_category')+"']").addClass('active');
	}else{
		var firstCat = $(".project_goods_categories li:eq(1)");
		$.cookie('goods_category', firstCat.attr('data-cat-id'));
		firstCat.addClass('active');
	}
	if($.cookie('goods_type_1') != null) {
		$("#goods_type_1").prop('checked', $.cookie('goods_type_1'));
	}
	if($.cookie('goods_type_2') != null) {
		$("#goods_type_2").prop('checked', $.cookie('goods_type_2'));
	}
	if($.cookie('goods_condition_1') != null) {
		$("#goods_condition_1").prop('checked', $.cookie('goods_condition_1'));
	}if($.cookie('goods_condition_2') != null) {
		$("#goods_condition_2").prop('checked', $.cookie('goods_condition_2'));
	}
}

function updateGoalsTable(){
	$('.goals-table tr').each(function (i) {
		$("td:first", this).html(i);
	});

	var goals_total = $('.goals-table .checkbox').length;
	var goals_checked = $('.goals-table input:checked').length;
	var percents = (goals_checked/goals_total)*100;
	$('.row_progress_in').animate({  "width": percents+"%" });
	$('.progress_wrap span').empty().append(percents.toFixed(2)+'%');
}

function generateGoal(goal){
	var html = '';
	html +=
		'<tr '+(goal.status == 1 ? 'class="done"' : '')+'>' +
		'<td></td>' +
		'<td>'+goal.name+'</td>' +
		'<td><span>'+goal.price+'</span> <span class="currency">$</span></td>' +
		'<td>' +
		'<div class="goal_checkbox">' +
		'<input type="checkbox" value=" " id="goal-'+goal.id+'" data-id="'+goal.id+'" name="comment" class="checkbox" '+(goal.status == 1 ? 'checked' : '')+'>' +
		'<label for="goal-'+goal.id+'"></label>' +
		'</div>' +
		'</td>' +
		'<td>' +
		//'<button class="close" aria-hidden="true">×</button>' +
		'<a href="#" class="goal-delete" data-id="'+goal.id+'">×</a>' +
		'</td>' +
		'</tr>';
	return html;
}