<?php

class AliasUrlRule extends CBaseUrlRule
{

	public $connectionID = 'db';

	public $aliases = array(
		1 => 'wall',
		2 => 'group',
        3 => 'store',
        4 => 'event',
	);

	public function createUrl($manager, $route, $params, $ampersand)
	{
		if (in_array($route, $this->aliases)) {
			if (isset($params['alias']))
				return $params['alias'];
		}
		return false;  // не применяем данное правило
	}

	public function parseUrl($manager, $request, $pathInfo, $rawPathInfo)
	{
        if (preg_match('%^[a-z\d\.]+%', $pathInfo, $matches)) {
            $connection = Yii::app()->db;
            $address = mysql_escape_string(htmlspecialchars(strip_tags($matches[0])));
            $request_uri = mysql_escape_string(htmlspecialchars(strip_tags($request->requestUri)));

            $alias = $connection->createCommand("SELECT uid, type FROM {{alias}} WHERE `name` = :address")->bindParam(":address", $address)->queryRow();

            if (!empty($alias)) {                
                if (preg_match('%\/note/\d+$%', $request_uri, $match)) {                    
                    $_GET['note'] = intval(str_replace("/note/","",$match[0]));
                }

                $_GET['alias'] = $address;
                $_GET['uid'] = $alias['uid'];
                switch($alias['type']){
                    case 1:
                    case 2:{
                        return '/page/'.$this->aliases[$alias['type']];
                    }
                    case 3:{
                        return '/store/'.$this->aliases[$alias['type']];
                    }
                    case 4:{
                        return '/events/'.$this->aliases[$alias['type']];
                    }
                }
            }
        }
        return false;  // не применяем данное правило
	}
}