<?php

/**
 * @param $str
 * @param null $count
 * @param string $dict
 * @internal param string $ string line to translate'.
 * @return string
 */
function t($str, $count = null, $dict = 'app') {
	return Yii::t($dict, $str, $count);
}

function n_time($t) {
//	date_default_timezone_set('Europe/Moscow');
	$n_date = date('d.m.Y', $t);
	$n_date_time = date('H:i', $t);
	$n_date_exp = explode('.', $n_date);
	$n_month = array(
		1 => 'янв',
		2 => 'фев',
		3 => 'мар',
		4 => 'апр',
		5 => 'мая',
		6 => 'июн',
		7 => 'июл',
		8 => 'авг',
		9 => 'сен',
		10 => 'окт',
		11 => 'ноя',
		12 => 'дек'
	);

	$n_month_name = '';
	foreach ($n_month as $key => $value) {
		if($key == intval($n_date_exp[1])) $n_month_name = $value;
	}

	if($n_date == date('d.m.Y')) return 'сегодня в '.$n_date_time;
	elseif($n_date_exp == date('d.m.Y', strtotime('-1 day'))) return 'вчера в '.$n_date_time;
	else return $n_date_exp[0].' '.$n_month_name.' '.$n_date_exp[2].' в '.$n_date_time;
}

function f_dt($t){
	$date = date('Y-m-d', $t);
	$today = date('Y-m-d');

	if($date == $today){
		return date('H:i:s', $t); //время
	}else{
		return date('d:m:y', $t); //дата
	}
}

function f_replace($s, $isTextArea = false, $isModal = false){	
	$from = array('\\\\\\\\n', '\\\\\\n', '\\\\n', '\\n');
	$to = $isModal ? array(' ', ' ', ' ', ' ') : array('<br>', '<br>', '<br>', '<br>');
	if($isTextArea)
		$to = array('&#13;&#10;', '&#13;&#10;', '&#13;&#10;', '&#13;&#10;');

	return str_replace($from, $to, $s);
}

function f_hs_decode($s){
	return htmlspecialchars_decode($s);
}

function f_alias_allowed($s){
	$connection = Yii::app()->db;
	$err = '';

	if (!preg_match(
		'/^(id|groups|post|event|wall|user|site|registration|recovery|page|login|team|'+
		'im|ajax|online|admin|control|vip|audio|blog|books|invoice|journal|market|'+
		'messages|order|social|voucher|wallet|goods|favorite|recommend)/', $s) && preg_match('/^[a-z0-9]*$/', $s)) {
		$alias = $connection->createCommand("SELECT name FROM {{alias}} WHERE `name` = :name LIMIT 1")->bindParam(":name", $s)->queryScalar();
		if(!empty($alias)){
			$err .= 'Недопустимый адрес страницы';
		}
	}else{
		$err .= 'Недопустимый адрес страницы';
	}
	return empty($err);
}

function f_getUploadServer(){
	$connection = Yii::app()->db;
	return $connection->createCommand("SELECT * FROM {{servers}} WHERE status = 1 ORDER BY images ASC LIMIT 1")->queryRow();
}


/**
 * Controller is the customized base controller class.
 * All controller classes for this application should extend from this base class.
 */
class Controller extends CController
{
	/**
	 * @var string the default layout for the controller view. Defaults to '//layouts/column1',
	 * meaning using a single column layout. See 'protected/views/layouts/column1.php'.
	 */
	public $layout='//layouts/column1';
	/**
	 * @var array context menu items. This property will be assigned to {@link CMenu::items}.
	 */
	public $menu=array();
	/**
	 * @var array the breadcrumbs of the current page. The value of this property will
	 * be assigned to {@link CBreadcrumbs::links}. Please refer to {@link CBreadcrumbs::links}
	 * for more details on how to specify this property.
	 */
	public $breadcrumbs=array();

}