<?php

class Functions extends CComponent
{

	public static function access_level($myuid, $uid) {
		$connection = Yii::app()->db;

		$is = false;
		$refx = $connection->createCommand("SELECT refx FROM {{usersinfo}} WHERE uid = :uid")
			->bindParam(":uid", $uid)
			->queryScalar();

		while(true) {
			if($refx == $myuid) {
				$is = true;
				break;
			}

			if($refx == 0) {
				break;
			}

			$refx = $connection->createCommand("SELECT refx FROM {{usersinfo}} WHERE uid = :uid")
				->bindParam(":uid", $refx)
				->queryScalar();
		}

		if($myuid == $uid) $is = true;

		return($is);
	}

	public static function access_control($package){
		$err = '';
		$package = intval($package);
		if(Yii::app()->user->isGuest){
			$err .= 'Доступ запрещен';
		}

		$connection = Yii::app()->db;
		$userinfo = $connection->createCommand("SELECT uid, alias FROM {{usersinfo}} WHERE uid = :uid AND package >= :package")
			->bindParam(":uid", Yii::app()->user->id)
			->bindParam(":package", $package)
			->queryRow();
			
		$invite = $connection->createCommand("SELECT * FROM {{users_invite_user}} WHERE uid=:uid")
		->bindParam(":uid",Yii::app()->user->id)
		->queryRow();
		
		$invite_access = $connection->createCommand("SELECT id, title FROM {{settings_access_invite}} WHERE controller = :controller AND action = :action AND status = 1")
		->bindParam(":controller", Yii::app()->controller->id)
		->bindParam(":action", Yii::app()->controller->action->id)
		->queryRow();
		
		if(empty($invite) && empty($invite_access)) {
			$err = 'Данная функция доступна только после активации кода приглашения. <a href="/'.$userinfo['alias'].'">Приступить к вводу инвайта</a>.';
		}
			
		if($err == "") {
			if(empty($userinfo)){
				$err = 'Данная опция доступна только после Подписки.';
			}
		}

		if($err != ''){
			if (Yii::app()->request->isAjaxRequest){
				$res["status"] = 500;
				$res["message"] = $err;
				echo CJSON::encode($res);
				Yii::app()->end();
			}else{
				Yii::app()->request->redirect('/feed');
			}
		}
	}
	
	
	//Проверка карты на аогоритм ЛУНА
	public static function is_valid_credit_card($s) {
	    // оставить только цифры
	    $s = strrev(preg_replace('/[^\d]/','',$s));
	 
	    // вычисление контрольной суммы
	    $sum = 0;
	    for ($i = 0, $j = strlen($s); $i < $j; $i++) {
	        // использовать четные цифры как есть
	        if (($i % 2) == 0) {
	            $val = $s[$i];
	        } else {
	            // удвоить нечетные цифры и вычесть 9, если они больше 9
	            $val = $s[$i] * 2;
	            if ($val > 9)  $val -= 9;
	        }
	        $sum += $val;
	    }
	 
	    // число корректно, если сумма равна 10
	    return (($sum % 10) == 0);
	}
	
	
}
