<?php

class Helpers
{
	const max_photo_width = 2560;
	const max_photo_height = 1690;
	const max_photo_size = 3145728;

	public static function uploadAvatar($file, $thumbnail_width = 800, $thumbnail_height = 600, $x1 = 0, $y1 = 0, $x2 = 0, $y2 = 0)
	{
		$res = array(
			'file' => null,
			'error' => 'При загрузке изображения возникла ошибка.',
		);

		if (empty($file)) return $res;

		$image = mysql_escape_string(htmlspecialchars(strip_tags($file["name"])));
		$uploaded_file = mysql_escape_string(htmlspecialchars(strip_tags($file['tmp_name'])));

		if ($image) {
			try {
				$filename = stripslashes($file['name']);
				$extension = self::getExtension($filename);
				$extension = strtolower($extension);
				if (($extension != "jpg") && ($extension != "jpeg") && ($extension != "png")) {
					$res['error'] = "Вы можете загрузить изображение только в формате JPG или PNG.";
				} elseif ($file['size'] > self::max_photo_size) {
					$res['error'] = "Вы можете загрузить изображение размером не больше 3 МБ.";
				} else {
					if ($extension == "jpg" || $extension == "jpeg") {
						$myImage = imagecreatefromjpeg($uploaded_file);
					} else {
						$myImage = imagecreatefrompng($uploaded_file);
					}

					list($width_orig, $height_orig) = getimagesize($uploaded_file);

					// CROP ORIGINAL
					$ratio = max(($width_orig / self::max_photo_width), ($height_orig / self::max_photo_height));
					if ($ratio > 1) {
						$new_width = $width_orig / $ratio;
						$new_height = $height_orig / $ratio;
					} else {
						$new_width = $width_orig;
						$new_height = $height_orig;
					}

					//SAVE ORIGINAL
					$process = imagecreatetruecolor($new_width, $new_height);
					imagecopyresampled($process, $myImage, 0, 0, 0, 0, $new_width, $new_height, $width_orig, $height_orig);
					$key = self::genKey(11);
					$file_name = Yii::app()->params['img_usr_dir'].'/'.$key.".jpg";
					imagejpeg($process, $file_name, 100);
					$res['file'] = file_exists($file_name) ? Yii::app()->params['img_usr_dir'].'/'.$key : null;

					//SAVE MEDIUM
					$process = imagecreatetruecolor($thumbnail_width, $thumbnail_height);
					imagecopyresampled($process, $myImage, 0, 0, round($x1), round($y1), $thumbnail_width, $thumbnail_height, round($x2), round($y2));
					$file_name = Yii::app()->params['img_usr_dir'].'/'.$key."_md.jpg";
					imagejpeg($process, $file_name, 100);

					//SAVE SMALL
					$process = imagecreatetruecolor(90, 90);
					imagecopyresampled($process, $myImage, 0, 0, round($x1), round($y1), 90, 90, round($x2), round($y2));
					$file_name = Yii::app()->params['img_usr_dir'].'/'.$key ."_sm.jpg";
					imagejpeg($process, $file_name, 100);

					imagedestroy($myImage);
					imagedestroy($process);
				}
			} catch(Exception $e) {
				$res["error"] = "При загрузке изображения возникла ошибка.";
			}
		}

		return $res;
	}

	public static function uploadAttachImage($file)
	{
		$res = array(
			'file' => null,
			'error' => 'При загрузке изображения возникла ошибка.',
		);

		if (empty($file)) return $res;

		$image = mysql_escape_string(htmlspecialchars(strip_tags($file["name"])));
		$uploaded_file = mysql_escape_string(htmlspecialchars(strip_tags($file['tmp_name'])));

		if ($image) {
			try {
				$filename = stripslashes($file['name']);
				$extension = self::getExtension($filename);
				$extension = strtolower($extension);
				if (($extension != "jpg") && ($extension != "jpeg") && ($extension != "png")) {
					$res['error'] = "Вы можете загрузить изображение только в формате JPG или PNG.";
				} elseif ($file['size'] > self::max_photo_size) {
					$res['error'] = "Вы можете загрузить изображение размером не больше 3 МБ.";
				} else {
					if ($extension == "jpg" || $extension == "jpeg") {
						$myImage = imagecreatefromjpeg($uploaded_file);
					} else {
						$myImage = imagecreatefrompng($uploaded_file);
					}

					list($width_orig, $height_orig) = getimagesize($uploaded_file);

					// CROP ORIGINAL
					$ratio = max(($width_orig / self::max_photo_width), ($height_orig / self::max_photo_height));
					if ($ratio > 1) {
						$new_width = $width_orig / $ratio;
						$new_height = $height_orig / $ratio;
					} else {
						$new_width = $width_orig;
						$new_height = $height_orig;
					}

					$process = imagecreatetruecolor($new_width, $new_height);
					imagecopyresampled($process, $myImage, 0, 0, 0, 0, $new_width, $new_height, $width_orig, $height_orig);

					$key = self::genKey(11);
					$file_name = Yii::app()->params['img_tmp_dir'].'/' . $key . ".jpg";

					imagejpeg($process, $file_name, 100);

					//CROP MEDIUM
					$ratio = max(($width_orig / 800), ($height_orig / 600));
					if ($ratio > 1) {
						$new_width = $width_orig / $ratio;
						$new_height = $height_orig / $ratio;
					} else {
						$new_width = $width_orig;
						$new_height = $height_orig;
					}

					$process = imagecreatetruecolor($new_width, $new_height);
					imagecopyresampled($process, $myImage, 0, 0, 0, 0, $new_width, $new_height, $width_orig, $height_orig);

					$file_name = Yii::app()->params['img_tmp_dir'].'/' .$key . "_md.jpg";

					imagejpeg($process, $file_name, 100);


					//CROP SMALL
					$ratio = max(($width_orig / 80), ($height_orig / 60));
					if ($ratio > 1) {
						$new_width = $width_orig / $ratio;
						$new_height = $height_orig / $ratio;
					} else {
						$new_width = $width_orig;
						$new_height = $height_orig;
					}

					$process = imagecreatetruecolor($new_width, $new_height);
					imagecopyresampled($process, $myImage, 0, 0, 0, 0, $new_width, $new_height, $width_orig, $height_orig);

					$file_name = Yii::app()->params['img_tmp_dir'].'/' .$key . "_sm.jpg";

					imagejpeg($process, $file_name, 100);


					$res['file'] = file_exists(Yii::app()->params['img_tmp_dir'].'/' . $key . ".jpg") ? Yii::app()->params['img_tmp_dir'].'/' . $key . "_sm.jpg" : null;
					$res['key'] = $key;

					imagedestroy($myImage);
					imagedestroy($process);

					//Сборщик мусора в папке TEMP
					$now = time();
					if (file_exists(Yii::app()->params['img_tmp_dir'])) {
						foreach (new DirectoryIterator(Yii::app()->params['img_tmp_dir']) as $fileInfo) {
							if ($fileInfo->isDot()) {
								continue;
							}
							if ($now - $fileInfo->getCTime() >= 3*60*60) {
								unlink($fileInfo->getRealPath());
							}
						}
					}
				}
			} catch (Exception $e) {
				$res["error"] = "При загрузке изображения возникла ошибка.";
			}
		}

		return $res;
	}

	private function getExtension($str)
	{
		$i = strrpos($str, ".");
		if (!$i) {
			return "";
		}
		$l = strlen($str) - $i;
		$ext = substr($str, $i + 1, $l);
		return $ext;
	}

	private function genKey($length)
	{
		$chars = 'abcdefghiklmnopqrstuvwxyz0123456789ABCDEFGHIKLMNOPQRSTUVXYZ0123456789';
		$numChars = strlen($chars);
		$string = '';
		for ($i = 0; $i < $length; $i++) {
			$string .= substr($chars, rand(1, $numChars) - 1, 1);
		}
		return $string;
	}

	public static function getLastFolderID(){

		$directory = array_diff( scandir( Yii::app()->params['img_dir'] ), array(".", "..") );

		//if there is empty root, return zero. Else, return last folder name;
		$id = empty($directory) ? 1 : intval( end($directory) );
		if (!file_exists(Yii::app()->params['img_dir'].'/'.$id)) {
			mkdir(Yii::app()->params['img_dir'].'/'.$id, 0777, true);
		}

		$files = glob(Yii::app()->params['img_dir'].'/'.$id .'/*.jpg');

		if ( $files !== false )
		{
			$file_count = count( $files );
			if ($file_count >= Yii::app()->params['max_img_for_dir'])
			{
				$id = $id + 1;
				mkdir(Yii::app()->params['img_dir'].'/'.$id, 0777, true);
			}
		}

		return $id;
	}

	public static function  dayNowMidnight()
	{
		return mktime(00, 00, 00, date("m", time()), date("d", time()), date("Y", time()));
	}

	public static function  dayNextMidnight()
	{
		return mktime(00, 00, 00, date("m", time()), date("d", time()) + 1, date("Y", time()));
	}

	public static function requestTime()
	{
		return (int)$_SERVER['REQUEST_TIME'];
	}
	
	public static function fullTime($date){
        $t = is_int($date) ? $date : strtotime($date);

        $months = [
            1 => 'января',
            2 => 'февраля',
            3 => 'марта',
            4 => 'апреля',
            5 => 'мая',
            6 => 'июня',
            7 => 'июля',
            8 => 'августа',
            9 => 'сентября',
            10 => 'октября',
            11 => 'ноября',
            12 => 'декабря'];

        $year = date("Y", $t);
        $month = date("n", $t);
        $day = date("d", $t);

        $hours = date("H", $t);
        $minutes = date("i", $t);

        return $hours.':'.$minutes.', '.$day.' '.$months[$month].' '.$year;
    }

    public static function f_area_replace($s){
        $from = array('\\\\n', '\\\\\\\\', '\\\\\\\'');
        $to   = array(PHP_EOL, '\\', '\'');
        return str_replace($from, $to, $s);
    }

}