<?php

class UloginUserIdentity extends CUserIdentity
{

    private $id;
    private $name;
    private $isAuthenticated = false;
    private $states = array();


    public function authenticate($uloginModel = null)
    {
        $criteria = new CDbCriteria;
        $criteria->condition = 'identity = :identity AND network = :network';
        $criteria->params = array(
            ':identity' => $uloginModel->identity
        , ':network' => $uloginModel->network
        );
        $user = User::model()->find($criteria);


        if (!empty($user)) {
            $this->id = $user->uid;
        }
        else {
            $user = new User();
            $user->identity = $uloginModel->identity;
            $user->network = $uloginModel->network;
            $user->mail = $uloginModel->email;
            $user->pass = md5($uloginModel->identity);
            $user->created = time();
            
            if($user->save()){
	            $connection = Yii::app()->db;
	            $names = explode(" ", $uloginModel->name);

	            $connection->createCommand()->insert('{{usersinfo}}', array(
		            'uid' => $user->uid,
		            'email' => $user->mail,
		            'name' => !empty($names[0]) ? $names[0] : '',
		            'fio' => !empty($names[1]) ? $names[1] : '',
		            'alias' => 'id'.$user->uid
	            ));

	            $connection->createCommand()->insert('{{alias}}', array(
		            'uid' => $user->uid,
		            'name' => 'id'.$user->uid,
		            'type' => 1
	            ));
            }else{
	            $this->isAuthenticated = false;
	            return false;
            }
        }

	    $this->id = $user->uid;
	    $this->name = 'id'.$user->uid;

	    $connection = Yii::app()->db;
	    $user_info = $connection->createCommand("SELECT alias FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", $user->uid)->queryRow();

	    $this->setState('alias', $user_info['alias']);
	    Yii::app()->session->setUserId($user->uid);
	    Yii::app()->session->protectSession($user->mail);

	    $this->isAuthenticated = true;
	    return true;
    }

    public function getId()
    {
        return $this->id;
    }
}