<?php

/**
 * @property mixed uid
 * @property mixed mail
 */
class WebUser extends CWebUser
{
	public $mail;
	public $username;

	public function getRole()
	{
		return $this->getState('__role');
	}

	public function getId()
	{
		return $this->getState('__id') ? $this->getState('__id') : -1;
	}


	protected function afterLogin($fromCookie)
	{
		parent::afterLogin($fromCookie);
		$this->updateSession();
	}

	public function updateSession() {
		$user = User::model()->findByPk($this->id);
		$this->mail = $user->mail;
		$userAttributes = array(
			'mail'=>$user->mail,
			'secret'=>UserModule::session_hash_string($_SERVER["REMOTE_ADDR"], $user->mail)
		);

		foreach ($userAttributes as $attrName=>$attrValue) {
			Yii::app()->session->add($attrName,$attrValue);
		}
	}

	public function getUserMail($id=0){
		return $this->mail;
	}

	public function model($id=0) {
		return User::model()->findByPk($id);
	}

	public function user($id=0) {
		return $this->model($id);
	}

}