<?php
/* @var $my */
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/group.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/filters_aside.css');

$connection = Yii::app()->db;
$find_query = !empty($tag) ? '#' . $tag : (!empty($query) ? $query : '');

$user_settings = $connection->createCommand("SELECT uid, find_place FROM {{users_settings}} WHERE uid = :uid")->bindParam(":uid", $my['uid'])->queryRow();
if (empty($user_settings)) {
    $user_settings['find_place'] = 2;
}
?>

<section class="section filters filters-my" style="display: none;">
    <div class="section_filters_header">
        Мои Фильтры
    </div>
    <ul class="list-unstyled filters_list"></ul>
</section>

<section class="section filters_params filters-search">
    <div class="section_filters_header">
        Поиск
    </div>
    <div class="filters_params_body">
        <form>
            <div class="form-group">
                <label for="exampleSelect3">Ключевые слова:</label>
                <input type="text" class="form-control" id="filter_text" placeholder="Ключевые слова"
                       value="<?= !empty($find_query) ? $find_query : '' ?>">
            </div>
            <div class="form-group">
                <label for="filter_country">Страна:</label>
                <select class="form-control js-data-ajax-country" id="filter_country">
                    <option value="-1" title="Выберите страну...">Выберите страну...</option>
                </select>
            </div>
            <div class="form-group">
                <label for="filter_city">Город:</label>
                <select class="form-control js-data-ajax-city" id="filter_city">
                    <option value="-1" title="Выберите город...">Выберите город...</option>
                </select>
            </div>
            <div class="form-group">
                <label for="type">Тип:</label>
                <select class="form-control" id="type">
                    <option value="1">Новость</option>
                    <option value="2">Хочу</option>
                    <option value="3">Предлагаю</option>
                </select>
            </div>
            <div class="post-category-wrapper" style="display: none;">
                <div class="form-group">
                    <label for="filter_category">Категория:</label>
                    <select class="form-control post-category" id="filter_category"></select>
                </div>
            </div>
            <div class="form-group">
                <label for="filter_find">Где искать:</label>
                <select class="form-control filter_find" id="filter_find">
                    <option value="1" <?= $user_settings['find_place'] == 1 ? 'selected' : '' ?>>Искать у друзей
                    </option>
                    <option value="2" <?= $user_settings['find_place'] == 2 ? 'selected' : '' ?>>Искать по всей сети
                    </option>
                </select>
            </div>
            <div class="form-group">
                <label for="filter_order">Сортировать:</label>
                <select class="form-control" id="filter_order">
                    <option value="1">По дате</option>
                    <option value="2">По популярности</option>
                </select>
            </div>
        </form>
        
        <a class="filters_btn save-filter-btn" href="#">Сохранить</a>
        
    </div>
    
</section>

<script type="application/javascript">
    $(document).ready(function () {

    });

</script>