<?php

return array(
	'basePath' => dirname(__FILE__) . DIRECTORY_SEPARATOR . '..',
	'name' => 'BOKOBOK',
	'sourceLanguage' => 'ru',
	'language' => 'ru',
	'timeZone'=>'GMT',

	'preload' => array('log'),

	'import' =>
		array(
			0 => 'application.models.*',
			1 => 'application.components.*',
			2 => 'application.extensions.*',
			3 => 'application.extensions.yii-mail.*',
			4 => 'application.extensions.curl.*',
			5 => 'ext.eoauth.*',
			6 => 'ext.eoauth.lib.*',
			7 => 'ext.eauth.*',
			8 => 'ext.eauth.services.*',

		),


	'modules' => array(

		'gii' => array(
			'class' => 'system.gii.GiiModule',
			'password' => 'demo',
			'ipFilters' => array('127.0.0.1', '::1'),
		),

	),

	// application components
	'components' => array(
		'curl' => array(
			'class' => 'ext.Curl',
		),
		'phpseclib' => array(
		 	'class' => 'ext.phpseclib.PhpSecLib'
		),

		'request' => array('enableCookieValidation' => true,),
		'user' => array(
			// enable cookie-based authentication
			'class' => 'WebUser',
			'allowAutoLogin' => true,
			'loginUrl' => array('/login'),
			'authTimeout' => 60*10 // 1 day
		),
		'eauth' => array(
			'class' => 'ext.eauth.EAuth',
			//'popup' => false,
			'services' => array(
				'bokobok' => array(
					'class' => 'BokobokOAuthService',
					'client_id' => 'bokobok',
					'client_secret' => 'Rt56F5PF',
					'title' => 'Bokobok',
				),
			),
		),
		'loid' => array(
			'class' => 'ext.lightopenid.loid',
		),

		// uncomment the following to enable URLs in path-format

		'urlManager' => array(
			'urlFormat' => 'path',
			'showScriptName' => false,
			'rules' => array(
				'/' => 'site/index',
				'login/<service:(bokobok)>' => 'site/login',
				'/login' => 'site/login',
				'logout' => 'site/logout',

				'/support/control' => '/supportcontrol/',
				'/support/control/<action:>' => '/supportcontrol/<action>',

				'/store/edit/<alias:\w+>' => '/store/edit/alias/<alias>',
                '/stores' => '/store/index',

				'merchant/<id:\d+>' => 'merchant/index/id/<id>',
				'market/user/<uid:\d+>' => 'market/user/uid/<uid>',
				'market/<gid:\d+>' => 'market/details/gid/<gid>',
				'market/edit/<gid:\d+>' => 'market/edit/gid/<gid>',
				'<action:(notifications|blacklist|subscribers|users|feed|popular|subscribersmy|friends|recommend|favorite|invite|packages|buy|sell|voucher|team)>' => '/page/<action>',
                '<controller:(groups|events)>/edit/<alias:\w+>' => '/<controller>/edit/alias/<alias>',
                '/user/settings' => '/page/settings',
				'/quotes' => 'quotes/index',
				'/feed' => 'feed/index',
				'im' => 'im/index/',
				'im/<sel:\d+>' => 'im/index/sel/<sel>',
				'subscribers/<uid:\d+>' => 'page/subscribers/uid/<uid>',
				'friends/<uid:\d+>' => 'page/friends/uid/<uid>',
				'wall|group/<uid:.*?>' => 'wall/index/<id>',
				
				'/away/url<url:\d+>' => '/away/index/url/<url>',

				// своё правило для URL вида '/username/'
				array(
					'class' => 'application.components.AliasUrlRule',
					'connectionID' => 'db',
				),
				
				'<controller:\w+>/<id:\d+>' => '<controller>/view',
				'<controller:\w+>/<action:\w+>/<id:\d+>' => '<controller>/<action>',
				'<controller:\w+>/<action:\w+>' => '<controller>/<action>'				
			),
		),

		'db' => array(
			'connectionString' => 'mysql:host=127.0.0.1;dbname=bkbkmain',
			'emulatePrepare' => true,
			'username' => 'bokobok',
			'password' => 'z33efst2q',
			'tablePrefix' => 'pm_',
			'charset' => 'utf8',
			'class'=>'CDbConnection'
		),
		'fs_db' => array(
			'connectionString' => 'mysql:host=127.0.0.1;dbname=bkbkfs',
			'emulatePrepare' => true,
			'username' => 'bokobok',
			'password' => 'z33efst2q',
			'tablePrefix' => 'pm_',
			'charset' => 'utf8',
			'class'=>'CDbConnection',
		),

		'authManager' => array(
			'class' => 'PhpAuthManager',
			'defaultRoles' => array('guest'),
		),

		'session' => array(
			'class' => 'ExCDbHttpSession',
			'autoStart' => false,
			'cookieMode' => 'only',
			'connectionID' => 'db',
			'sessionTableName' => '{{sessions}}',
			'autoCreateSessionTable' => false,
			'timeout' => 60*30
		),

		'errorHandler' => array(

			'errorAction' => 'site/error',
		),

		'log' => array(
			'class' => 'CLogRouter',
			'routes' => array(
				array(
					'class' => 'CFileLogRoute',
					'levels' => 'error, warning',
				),
			),
		),
		'clientScript' => array(
			'scriptMap' => array(
				'jquery.js' => '/js/jquery.js',
			),
		),
		'cache'=>array(
			'class'=>'system.caching.CFileCache'
		)


	),

	'behaviors' => array(
		'class' => 'application.components.ApplicationBehavior',
	),

	'params' => array(
		'adminEmail' => '',
		'api_pass' => 'K2LKxnB7VRSDFHkd028u9fjs99_4wI3PL',
		'api_obmenbp' => 'K2LK11xnB7VR4wI3PL',
		'bonus_pass' => 'PucM?KJZBkqXdyYx6?q$*dSxsqkTdwa$',
		
		'api_verify' => 'NWpBwql5vuhKkb8qCoHLwwq7gPYnEHPc',
		'potential_hash' => 'TBvvGb900aN5uCy9JyWgxCWOjcbPbqhG',
		
		'hash_count' => 15,
		'min_hash_count' => 7,
		'max_hash_count' => 30,
		'hash_length' => 55,
		'flood_limit' => 5,

		// Настройки сайта
		'min-age' => 14,
		'users-per-page' => 20,
		'max_img_for_dir' => 1000,
		'img_tmp_dir' => 'img/tmp', //TEMP DIR
		'img_usr_dir' => 'img/u', //USER DIR
		'img_dir' => 'img/m',  //MAIN DIR
		
		
		"digest_alg" => "sha256",
	    "private_key_bits" => 1024,
	    "private_key_type" => OPENSSL_KEYTYPE_RSA,
		
		/*'rsa_public_key' => '-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQC1gIJjImdmzZcVnkKzsCNOogo+
fJqF3jWDMNUkCkcuTBwjHc5cqF39ZURSPS+AHefWQAfjveGwTO18jRf/vu0je1Ka
a5ZsnphR3xNarNFyQWiYLvBSHh6ffSd4r25x5tNOfjgS+O6Lwf5MDp4Y9n8L5Kvd
6FGqTx+pOvHQFd6+YwIDAQAB
-----END PUBLIC KEY-----',


        'rsa_private_key' => '-----BEGIN PRIVATE KEY-----
MIICeAIBADANBgkqhkiG9w0BAQEFAASCAmIwggJeAgEAAoGBALWAgmMiZ2bNlxWe
QrOwI06iCj58moXeNYMw1SQKRy5MHCMdzlyoXf1lRFI9L4Ad59ZAB+O94bBM7XyN
F/++7SN7UpprlmyemFHfE1qs0XJBaJgu8FIeHp99J3ivbnHm005+OBL47ovB/kwO
nhj2fwvkq93oUapPH6k68dAV3r5jAgMBAAECgYBLHP3Y7PoB739hMPfFyVUzS5gV
uBdy4z0eJ+1tVtuSa2kRl1o5umv7XBdkOXIZAUdawXECbSijf5KhAvs1mdwlKgf5
5Av+le3pnc7MdmLK9IHD7SeMWZrl608EWKxy4mvz85uZiazC5YvAZcwm79FYf0yx
iSVCsvT249Hk8vl8gQJBAOjXsroACiMk0QUNg+JfS9uVOnxq7hkMG+voFwskR31R
e6iNj1W46KAllxge/X96uwcd2D2p85VjOAueECyuICECQQDHjaa8RfW6jfSJX55f
h6OVCCmpbU63BTDX74Nl32XUr8SuN0sC6pysU7IFsBaAGCdAw7ig3nXg8rxZK+kY
AJ4DAkEAh8zdyYuiXfLoEYlbZRjtdkknzk7TRTqBwmofnnjvVRDEDX9anMV2r4id
Ag15DfO3xyPJ7dUEYxl2I5hxmI2J4QJBAJ6Zd3ZViAqgPkVcaKv2Ss3s8efFh3Uw
u/QzWVSDLBTRKdlo+sYznxfbYTbiD8/44mG37Kp2hGunoIiivJymCO8CQQC8SFem
ezZSJ8n+/uALoidIk6Oi2A1IioU1IAj3MC6AIxRq5Wwh8Rw3HYgHmmyvkOArxJQQ
lHj50JgCqypcxDUn
-----END PRIVATE KEY-----',*/

'rsa_public_key' => '-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDjlmsIuqxJHfYTrHtDHtWTs169
fz9DXeZNV/AdbAUpOgNiMQcxtsqS+H29B3IbMhIsqGUQ5xqr3dM85VmQsuFMnm5T
GY1ZB2Wj6hGpDcV6FybQ5DTFTcMnqreFuhY4SB4yZhUak7j1mxmTcatrtU9CII0D
uRAEWpeJQsuAWrOdvQIDAQAB
-----END PUBLIC KEY-----',

'rsa_private_key' => '-----BEGIN RSA PRIVATE KEY-----
MIICXgIBAAKBgQDjlmsIuqxJHfYTrHtDHtWTs169fz9DXeZNV/AdbAUpOgNiMQcx
tsqS+H29B3IbMhIsqGUQ5xqr3dM85VmQsuFMnm5TGY1ZB2Wj6hGpDcV6FybQ5DTF
TcMnqreFuhY4SB4yZhUak7j1mxmTcatrtU9CII0DuRAEWpeJQsuAWrOdvQIDAQAB
AoGAGEU5QuQNbXq5fF2fg4ftROQTDWhdicSgw8zF+Y1Ee6IJLFaIKuAQeF3xotAB
di7/yy1mIchTitKMLWlUBN9esUaKjbq4+MeFcDRHq3fq78+M/xOkecxpBzg8To/8
EtWx1XX1n6lyu2dG7sU9oHUK5zlM70Yj38Y6KWzhKyZlny0CQQD68DiMx4Lqr8pf
Mstrj4JxuyfJY1MW7kEc4CWaozelPCreJfVNT+jAorB0gALBzN0npBOukp4rpv5J
MpykPK+rAkEA6C2esnmX0ybAGHucRBiZ0kxR3iPrIXJYdec+RFkTZhdIQxGN2SGz
ztc4G71/V/gu+UU4vyza6o4+TxqqOJ2gNwJBAMgAcnHyCiwXFAqwJ2WBKgyPiHSA
j5b1KjxjglUvxYgS3m/UfSCzkeUHRfB0nr3sFFAl+/Hltd9A5+dbSXG1VKUCQQDY
36wqaFwCV2L+O5CXJyegAbxDNOfwoR+yWmOWcmIlbcAJLf+C//E2V2DIwLSP1nsC
Sr+cC+kdSes39t9j7RD3AkEAkOdMOg+0jsh5cJLIcyhWVOODo395/ANnt+pf8C4g
QXz+xYjPwcwnTK0wrMhs6GUNBH/MnJ9Aj0t75pUPWmG97A==
-----END RSA PRIVATE KEY-----'
		
		
	),
);