<?php

class OnlineController extends Controller
{
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	public function accessRules()
	{
		return array(
			array('allow',
				'users' => array('@'),
			),
			array('deny',
				'users' => array('*'),
			)
		);
	}

	public function  actionUpdate(){
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$connection = Yii::app()->db;
			
			$connection->createCommand("UPDATE {{usersinfo}} SET online = :time WHERE uid = :uid")
				->bindParam(":time", time())
				->bindParam(":uid", Yii::app()->user->id)
				->query();	
				
		}
	}
	

	public function actionError()
	{
		if ($error = Yii::app()->errorHandler->error) {
			if (Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}
}