<?php

class UserController extends Controller
{
	public function filters()
	{
		return array(
			'accessControl',
		);
	}

	public function accessRules()
	{
		return array(
			array('allow',
				'users' => array('@'),
			),
			array('deny',
				'users' => array('*'),
			)
		);
	}
	
	public function actionSetPaymentSolution()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;
			$err = '';

			$payment_name = intval($_POST["payment_name"]);
			$payment_data1 = intval($_POST["payment_data1"]);
			$payment_data2 = mysql_escape_string(htmlspecialchars(strip_tags($_POST["payment_data2"])));
			$payment_data3 = mysql_escape_string(htmlspecialchars(strip_tags($_POST["payment_data3"])));
			$payment_amount = doubleval($_POST["payment_amount"]);

			$payment_solution = $connection->createCommand("SELECT * FROM {{users_payment_solution}} WHERE uid = :uid AND status = 0")
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();

			if(!empty($payment_solution)){
				$err .= '<li>Ваша заявка уже находится в обработке. Дождитесь решения по ней.</li>';
			}
			if(empty($payment_name) || !in_array($payment_name, [111])){
				$err .= '<li>Необходимо указать Способ оплаты.</li>';
			}
			if(empty($payment_data1)){
				$err .= '<li>Необходимо указать "Batch код" (номер перевода).</li>';
			}
			if(empty($payment_data2) || !preg_match('/^U\d+/', $payment_data2)){
				$err .= '<li>Неверный формат поля "Кошелек отправителя".</li>';
			}
			if(empty($payment_data3) || !preg_match('/^U\d+/', $payment_data3)){
				$err .= '<li>Неверный формат поля "Кошелек получателя".</li>';
			}
			if(empty($payment_amount) || !is_numeric($payment_amount) || $payment_amount < 0/*!in_array($payment_amount, [200, 500, 1000, 2000, 5000, 10000, 20000, 50000, 100000, 200000])*/){
				$err .= '<li>Необходимо указать "Сумму".</li>';
			}

			if ($err == '') {
				$connection->createCommand()->insert('{{users_payment_solution}}', array(
						'uid' => Yii::app()->user->id,
						'type' => $payment_name,
						'date' => time(),
						'data1' => $payment_data1,
						'data2' => $payment_data2,
						'data3' => $payment_data3,
						'amount' => $payment_amount,
						'status' => 0
				));

				$res["status"] = 200;
				$res["message"] = "Ваша заявка успешно отправлена.";
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка." . $err;
			}
			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}

	public function actionGoalUpdate()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			Functions::access_control(1);
			$connection = Yii::app()->db;
			$res = array();

			$id = intval($_POST["id"]);
			$status = intval($_POST["status"]);
			$goal = $connection->createCommand("SELECT * FROM {{goals}} WHERE id = :id AND uid = :uid")
				->bindParam(":id", $id)
				->bindParam(":uid", Yii::app()->user->id)
				->queryRow();

			if (!empty($goal) && in_array($status, [0,1])) {
				$transaction = $connection->beginTransaction();
				try {
					$connection->createCommand('UPDATE {{goals}} SET status = :status WHERE id = :id AND uid = :uid')
						->bindParam('id', $id)
						->bindParam('status', $status)
						->bindParam('uid', Yii::app()->user->id)
						->query();

					$transaction->commit();
					$res["status"] = 200;
					$res["goal_status"] = $status;
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен.";
				}
			} else {
				$res["status"] = 500;
				$res["message"] = "Сервер временно недоступен.";
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}

	public function actionGoalDelete()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			Functions::access_control(1);
			$connection = Yii::app()->db;
			$res = array();

			$id = intval($_POST["id"]);
			$goal = $connection->createCommand("SELECT * FROM {{goals}} WHERE id = :id AND uid = :uid")
				->bindParam(":id", $id)
				->bindParam(":uid", Yii::app()->user->id)
				->queryRow();

			if (!empty($goal)) {
				$transaction = $connection->beginTransaction();
				try {
					Yii::app()->db->createCommand('DELETE FROM {{goals}} WHERE id = :id AND uid = :uid')
						->bindParam('id', $id)
						->bindParam('uid', Yii::app()->user->id)
						->query();

					$transaction->commit();
					$res["status"] = 200;
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен.";
				}
			} else {
				$res["status"] = 500;
				$res["message"] = "Сервер временно недоступен.";
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}

	public function actionGoalAdd()
	{

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			Functions::access_control(1);
			$connection = Yii::app()->db;
			$res = array();
			$err = '';

			$name = mysql_escape_string(htmlspecialchars(strip_tags($_POST["goal_name"])));
			$price = intval($_POST["goal_price"]);

			if(empty($name)){
				$err .= '<li>Выберите название.</li>';
			}
			if(empty($price)){
				$err .= '<li>Укажите стоимость.</li>';
			}

			if (empty($err)) {
				$transaction = $connection->beginTransaction();
				try {
					$connection->createCommand()->insert('{{goals}}', array(
						'uid' => Yii::app()->user->id,
						'name' => $name,
						'price' => $price,
						'status' => 0,
						'date' => time()
					));
					$goal_id = Yii::app()->db->getLastInsertID();

					$goal = $connection->createCommand("SELECT id, uid, name, price, status FROM {{goals}} WHERE id = :id")
						->bindParam(":id", $goal_id)
						->queryRow();

					$transaction->commit();
					$res["status"] = 200;
					$res["goal"] = $goal;
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "При добавлении цели возникла ошибка.";
				}
			} else {
				$res["status"] = 500;
				$res["message"] = $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}


	public function actionGoalsMy()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			Functions::access_control(1);
			$res = array();
			$connection = Yii::app()->db;

			$goals = $connection->createCommand("SELECT id, uid, name, price, status FROM {{goals}} WHERE uid = :uid ORDER BY date DESC")
				->bindParam(":uid", Yii::app()->user->id)
				->queryAll();

			if (!empty($goals)) {
				$res["goals"] = $goals;
				$res["status"] = 200;
			} else {
				$res["status"] = 500;
				$res["total"] = 0;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	public function actionGetUserInvite(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;

			if (Yii::app()->user->id > 0) {
				
				$res["invite"] = $connection->createCommand("SELECT id, uid, invite, FROM_UNIXTIME(date, '%d-%m-%Y') AS date, status FROM {{users_invite_code}}  WHERE uid = :uid AND status = 0 ORDER BY status DESC")
				->bindParam(":uid", Yii::app()->user->id)
				->queryAll();;

				$res["inviteactive"] = $connection->createCommand("SELECT c. id, c.date, c.invite, c.status, u.package, FROM_UNIXTIME(u.date_start, '%d-%m-%Y') AS date_start, FROM_UNIXTIME(u.date_end, '%d-%m-%Y') AS date_end, u.status as 'status_user', i.name, i.fio, i.alias, i.photo, i.package FROM {{users_invite_code}} c INNER JOIN {{users_invite_user}} u INNER JOIN {{usersinfo}} i  ON  c.id = u.cid AND u.uid = i.uid AND c.uid = :uid")
				->bindParam(":uid", Yii::app()->user->id)
				->queryAll();
				
				$res["status"] = 200;
				
			} else {
				$res["status"] = 500;
				$res["message"] = "У Вас нет свободных пригласительных";
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}

	}
	
	
	public function actionSetPackegeStart(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			Functions::access_control(0);
			$res = array();
			$connection = Yii::app()->db;
			
			/*$res["status"] = 500;
			$a = serialize($_POST);
			$res["message"] = $a;

			echo CJSON::encode($res);
			Yii::app()->end();*/
			
			//$code = mysql_escape_string(htmlspecialchars(strip_tags($_POST["code"])));
			$type = intval($_POST["type"]);
			$price = intval($_POST["price"]);
			
			//============================================================================================
			//Код перед оплатой
			
			$code = Yii::app()->user->id . "-" . md5(Yii::app()->user->id . " - " . time() . "-" . rand(999999,9999999));
			$connection->createCommand()->insert('{{users_payment_package}}', array('uid' => Yii::app()->user->id, 'date' => time(), 'code' => $code, 'amount' => 0, 'package' => 0, 'status' => 0));
			
			//============================================================================================
			
			$transaction = $connection->createCommand("SELECT * FROM {{users_payment_package}} WHERE uid = :uid AND code = :code AND status = 0")
			->bindParam(":uid", Yii::app()->user->id)
			->bindParam(":code", $code)
			->queryRow();
			
			$pkg_now = $connection->createCommand("SELECT package FROM {{usersinfo}} WHERE uid = :uid")
			->bindParam(":uid", Yii::app()->user->id)
			->queryScalar();
			
			//Находим на какой кошелек отправлять деньги
			$pay_code = 111; //Perfect Money
			
			$psid = $transaction = $connection->createCommand("SELECT * FROM {{users_payment_wallet}} WHERE status = 1 AND type = 1 ORDER BY money_my DESC LIMIT 1")
			->bindParam(":uid", Yii::app()->user->id)
			->bindParam(":pay_code", $pay_code)
			->queryRow(); //Какой кошелек пополнять
			
			$err = "";
			
			$pkg_price = 0;
			switch($type) {
				case 1:
					$pkg_price = 200;
					break;
				case 2:
					$pkg_price = 500;
					break;
				case 3:
					$pkg_price = 1000;
					break;
				case 4:
					$pkg_price = 2000;
					break;
				case 5:
					$pkg_price = 5000;
					break;
				case 6:
					$pkg_price = 10000;
					break;
				case 7:
					$pkg_price = 20000;
					break;
				case 8:
					$pkg_price = 50000;
					break;
				case 9:
					$pkg_price = 100000;
					break;
				case 10:
					$pkg_price = 200000;
					break;								
			}
			
			if(empty($transaction)) {
				$err .= "<li>Сервер временно недоступен. Обновите страницу и повторите попытку снова.</li>";
			}
			
			if($pkg_price != $price) {
				$err .= "<li>Повторите попытку через несколько минут.</li>";
			}
			
			if($pkg_now >= $type)
				$err = "<li>Вы не можете активировать данный пакет, так как Ваша подписка более актуальна.</li>";
			
			if(empty($psid)) {
				$err = "<li>Сервер временно недоступен. Обновите страницу и повторите попытку снова.</li>";
			}

			
			if (Yii::app()->user->id > 0 && $err == "") {
				
				$connection->createCommand("UPDATE {{users_payment_package}} SET status = 1, amount=:amount, package=:package, psid = :psid WHERE uid = :uid AND code = :code AND status = 0")
					->bindParam(":uid", Yii::app()->user->id)
					->bindParam(":code", $code)
					->bindParam(":amount", $price)
					->bindParam(":package", $type)
					->bindParam(":psid", $psid["id"])
					->query();
				
				$res["wallet"] = $psid["pay_wallet"];
				$res["recipient"] = $psid["pay_recipient"];
				$res["code"] = $code;
				$res["price"] = $pkg_price;
				$res["status"] = 200;
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка при активации подписки." . $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}

	}
	
	
	
	//Получение выделенных инвайтов
	public function actionSetInviteNew(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			Functions::access_control(1);
			$res = array();
			$connection = Yii::app()->db;
			
			$invite = $connection->createCommand("SELECT * FROM {{users_invite_new}} WHERE uid = :uid AND status = 0 ORDER BY amount DESC LIMIT 1")
				->bindParam(":uid", Yii::app()->user->id)
				->queryRow();
			
			$amount = intval($invite["amount"]);

			if (!empty($invite) && $amount > 0) {
				
				$transaction = $connection->beginTransaction();
				try {
					
					$date = time();
					
					$connection->createCommand()->insert('{{users_invite_history}}', array('uid' => Yii::app()->user->id, 'nid' => $invite["id"], 'date' => time(), 'status' => 1));
					
					for($i=1; $i<=$amount;$i++) {
						
						$code = Yii::app()->user->id . "-" . $date . "-" . $invite["id"] . "-" . $i;
						$invite_code = strtoupper(md5($code));
						
						$connection->createCommand()->insert('{{users_invite_code}}', array('uid' => Yii::app()->user->id, 'invite' => $invite_code, 'date' => time(), 'status' => 0));
						
					}
					
					$connection->createCommand("UPDATE {{users_invite_new}} SET status = 1 WHERE uid = :uid AND id = :id")
						->bindParam(":uid", Yii::app()->user->id)
						->bindParam(":id", $invite["id"])
						->query();
					
					$transaction->commit();
					
					$res["message"] = "Вашему аккаунту активировано $amount Инвайтов.";
					$res["status"] = 200;
				
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
				}
				
				
			} else {
				$res["status"] = 500;
				$res["message"] = "На данный момент у Вас нет доступных Инвайтов для активации.";
			}

			echo CJSON::encode($res);
			Yii::app()->end();
			
		}

	}
	
	
	
	//Получение выделенных инвайтов
	public function actionSetInviteNewCount(){
	
		if(Yii::app()->user->id != 3) {
			
			$res["status"] = 500;
			$res["message"] = "Возможность вскоре будет доустпна.";
			echo CJSON::encode($res);
			Yii::app()->end();
			
		}
		
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			Functions::access_control(1);
			$res = array();
			$connection = Yii::app()->db;
			
			$err = "";
			
			$invite = $connection->createCommand("SELECT * FROM {{users_invite_new}} WHERE uid = :uid AND status = 0 ORDER BY amount DESC LIMIT 1")
				->bindParam(":uid", Yii::app()->user->id)
				->queryRow();
			
			
			//Если пустой инвайт - надо получить еще 10ку
			if(empty($invite)) {
				
				//Проверка на наличие свободных инвайтов
				$invite_count = intval($connection->createCommand("SELECT COUNT(*) FROM {{users_invite_code}} WHERE uid = :uid AND status = 0")
				->bindParam(":uid", Yii::app()->user->id)
				->queryScalar());
				
				if($invite_count > 0) {
					$err .= "<li>На данный момент у Вас есть $invite_count свободных инвайтов. Вы можете получить новые инвайты, как только данные инвайты будут использованы.</li>";
				}
				
				// Добавляем новые инвайты
				if($invite_count == 0 && $err == "") {
					
					$connection->createCommand()->insert('{{users_invite_new}}', array('uid' => Yii::app()->user->id, 'amount' =>10, 'date' => time(), 'type' => 3, 'status' => 0, 'hash' => doubleval(Yii::app()->user->id . "." . time()) ));
					
					$invite = $connection->createCommand("SELECT * FROM {{users_invite_new}} WHERE uid = :uid AND status = 0 ORDER BY amount DESC LIMIT 1")
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();
					
				}
				
			}
			
			
			//Полследняя проверка
			if($err == "") {
			
				$amount = intval($invite["amount"]);
				
				if($amount == 0 || empty($invite)) {
					$err = "<li>На данный момент у Вас нет доступных Инвайтов для активации.</li>";
				}
			
			}

			if (!empty($invite) && $amount > 0 && $err == "") {
				
				$transaction = $connection->beginTransaction();
				try {
					
					$date = time();
					
					$connection->createCommand()->insert('{{users_invite_history}}', array('uid' => Yii::app()->user->id, 'nid' => $invite["id"], 'date' => time(), 'status' => 1));
					
					for($i=1; $i<=$amount;$i++) {
						
						$code = Yii::app()->user->id . "-" . $date . "-" . $invite["id"] . "-" . $i;
						$invite_code = strtoupper(md5($code));
						
						$connection->createCommand()->insert('{{users_invite_code}}', array('uid' => Yii::app()->user->id, 'invite' => $invite_code, 'date' => time(), 'status' => 0));
						
					}
					
					$connection->createCommand("UPDATE {{users_invite_new}} SET status = 1 WHERE uid = :uid AND id = :id")
						->bindParam(":uid", Yii::app()->user->id)
						->bindParam(":id", $invite["id"])
						->query();
					
					$transaction->commit();
					
					$res["message"] = "Вашему аккаунту активировано $amount Инвайтов.";
					$res["status"] = 200;
				
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
				}
				
				
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка при получении инвайтов." . $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
			
		}

	}
	
	
	//Получение выделенных инвайтов
	public function actionSetInviteActivate(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;
			
			$invite = mysql_escape_string(htmlspecialchars(strip_tags($_POST["invite"])));
			
			$invite_code = $connection->createCommand("SELECT id, uid, invite FROM {{users_invite_code}} WHERE invite=:invite AND uid <> :uid AND status = 0")
			->bindParam(":invite",$invite)
			->bindParam(":uid",Yii::app()->user->id)
			->queryRow();
			
			$package = $connection->createCommand("SELECT package FROM {{usersinfo}} WHERE uid = :uid")
			->bindParam(":uid",Yii::app()->user->id)
			->queryScalar();
			
			if(empty($invite_code)) {
				
				$res["status"] = 500;
				$res["message"] = "Введенный Вами код не найден либо уже используется другим пользователем.";
				echo CJSON::encode($res);
				Yii::app()->end();
				
			}
			
			$is_invite_in = $connection->createCommand("SELECT * FROM {{users_invite_user}} WHERE uid=:uid")
			->bindParam(":uid",Yii::app()->user->id)
			->queryRow();
			
			$err = "";
			
			if(!empty($is_invite_in))
				$err = "<li>Ваш Инвайт уже активирован.</li>";
				
			if(Functions::access_level(Yii::app()->user->id, $invite_code["uid"]))
				$err = "<li>Владелец данного Инвайта уже находится у Вас в сети. Используйте Инвайт другого участника.</li>";

			if ($err == "") {
				
				$transaction = $connection->beginTransaction();
				try {
					
					$status = $package > 0 ? 1 : 0;
					
					$date_end = time() + 864000; // 10 дней
					
					$connection->createCommand()->insert('{{users_invite_user}}', array('uid' => Yii::app()->user->id, 'cid' => $invite_code["id"], 'invite' => $invite_code["invite"], 'date_start' => time(), 'date_end' => $date_end, 'package' => $package, 'status' => $status));
					
					$connection->createCommand("UPDATE {{users_invite_code}} SET status = 1 WHERE id = :id")
						->bindParam(":id", $invite_code["id"])
						->query();
						
					$connection->createCommand("UPDATE {{usersinfo}} SET refx = :refx WHERE uid = :uid")
						->bindParam(":uid", Yii::app()->user->id)
						->bindParam(":refx", $invite_code["uid"])
						->query();
					
					$transaction->commit();
					
					$res["message"] = "Ваш Инвайт успешно активирован.";
					$res["status"] = 200;
				
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = $e . "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
				}
				
				
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка при активации Инвайта." . $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
			
		}

	}
	
	//Получение выделенных инвайтов
	public function actionSetUserInviteCancel(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;

			$id = intval($_POST["id"]);
			
			$invite_codes = $connection->createCommand("SELECT * FROM {{users_invite_code}} WHERE id = :id AND uid = :uid AND status = 1")
			->bindParam(":id",$id)
			->bindParam(":uid",Yii::app()->user->id)
			->queryRow();
			
			$invite_user = $connection->createCommand("SELECT * FROM {{users_invite_user}} WHERE cid=:id AND invite = :invite")
			->bindParam(":id",$id)
			->bindParam(":invite",$invite_codes["invite"])
			->queryRow();
			
			$err = "";
			
			//Запрещаем отзывать инвайт если уже проплачен пакет
			if($invite_user["status"] == 1) {
				$res["status"] = 500;
				$res["message"] = "Вы не можете отозвать инвайт.";
				echo CJSON::encode($res);
				Yii::app()->end();
			}
			
			if(empty($invite_codes))
				$err .= "<li>Ошибка отмены.</li>";
				
			if(empty($invite_user))
				$err .= "<li>Ошибка отмены.</li>";


			if (Yii::app()->user->id > 0 && $err == "") {
				
				$transaction = $connection->beginTransaction();
				try {
					
					$connection->createCommand()->insert('{{users_invite_deleted}}', array('uid' => Yii::app()->user->id, 'tuid' => $invite_user["uid"],'invite' => $invite_user["invite"], 'date' => time(), 'status' => 1));
					
					$hash = Yii::app()->user->id . "." . time();
					$connection->createCommand()->insert('{{users_invite_new}}', array('uid' => Yii::app()->user->id, 'amount' => 1, 'date' => time(), 'type' => 2, 'status' => 1, 'hash' => $hash));
					
					$invite_new_id = Yii::app()->db->getLastInsertID();
					
					$code = Yii::app()->user->id . "-" . time() . "-" . $invite_new_id . "-" . "1";
					$invite_code = strtoupper(md5($code));
					
					$connection->createCommand()->insert('{{users_invite_code}}', array('uid' => Yii::app()->user->id, 'invite' => $invite_code, 'date' => time(), 'status' => 0));
					$connection->createCommand("DELETE FROM {{users_invite_user}} WHERE cid=:id AND invite = :invite")
					->bindParam(":id",$id)
					->bindParam(":invite",$invite_codes["invite"])
					->query();
					
					$connection->createCommand("DELETE FROM {{users_invite_code}} WHERE id = :id AND uid = :uid AND status = 1")
					->bindParam(":id",$id)
					->bindParam(":uid",Yii::app()->user->id)
					->query();
					
					$transaction->commit();
					
					$res["message"] = "Инвайт успешно отменен. Взамен Вам выделен новый Инвайт: $invite_code";
					$res["status"] = 200;
				
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
				}
				
				
			} else {
				$res["status"] = 500;
				$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
			}

			echo CJSON::encode($res);
			Yii::app()->end();
			
		}

	}
	
	//get-wallet-transactions2
	public function actionGetWalletTransactions2()
	{
		if (Yii::app()->request->isAjaxRequest) {
			$connection = Yii::app()->db;
			$res = array();

			if(Yii::app()->user->id > 0) {

				$res["transactions"] = $connection->createCommand("SELECT d.id, d.type, d.status, d.action, d.amount, d.amount_now, FROM_UNIXTIME(d.date, '%d-%m-%Y %H:%i') as 'date', CONCAT(u.name,' ',u.fio) AS 'whose' FROM {{utransactions2}} d INNER JOIN {{usersinfo}} u ON u.uid = d.ruid AND d.uid = :uid AND d.ruid >= 1 AND d.status IN (0,1) ORDER BY d.id DESC LIMIT 0,100")
					->bindParam(":uid", Yii::app()->user->id)
					->queryAll();

				$res["status"] = 200;
				
			} else {
				
				$res["status"] = 500;
				
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	
	public function actionSetUserLevel2()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$connection = Yii::app()->db;
			$res = array();

			$transaction = $connection->beginTransaction();
			try {

				$my = $connection->createCommand("SELECT uid, level, count_users FROM {{usersinfo}} WHERE uid = :uid AND level = 1 AND status = 1")
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();

				$ref_count = $connection->createCommand("SELECT COUNT(uid) FROM {{usersinfo}} WHERE refx = :uid AND count_users >= 5 AND status = 1")
					->bindParam(":uid", Yii::app()->user->id)
					->queryScalar();

				if (!empty($my) && $my['level'] == 1 && $ref_count >= 10) {
					$connection->createCommand("UPDATE {{usersinfo}} SET level = 2 WHERE uid = :uid AND level = 1 AND status = 1")
						->bindParam(":uid", Yii::app()->user->id)
						->query();

                    $connection->createCommand()->insert('{{users_invite_new}}', array('uid' => Yii::app()->user->id, 'amount' => 10, 'date' => time(), 'type' => 3, 'status' => 0, 'hash' => doubleval(Yii::app()->user->id . "." . time()) ));

					$transaction->commit();
					$res["level"] = 200;
					$res["message"] = 'Ваш новый уровень успешно подтвержден!';
				} else {
					$res["level"] = 500;
					$res["message"] = 'Возникла ошибка при переходе на новый уровень.';
				}

			} catch (Exception $e) {
				$transaction->rollback();
				$res["level"] = 500;
				$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}

	public function actionSetUserLevel1(){
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$connection = Yii::app()->db;
			$res = array();

			$transaction = $connection->beginTransaction();
			try {
				$my = $connection->createCommand("SELECT uid, level, count_users FROM {{usersinfo}} WHERE uid = :uid AND level = 0 AND status = 1")
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();

				if (!empty($my) && $my['level'] == 0 && $my['count_users'] >= 10) {
					$connection->createCommand("UPDATE {{usersinfo}} SET level = 1 WHERE uid = :uid AND level = 0 AND status = 1")
						->bindParam(":uid", Yii::app()->user->id)
						->query();

					$transaction->commit();
					$res["status"] = 200;
					$res["message"] = 'Ваш новый уровень успешно подтвержден!';
				} else {
					$res["status"] = 500;
					$res["message"] = 'Возникла ошибка при переходе на новый уровень.';
				}
			} catch (Exception $e) {
				$transaction->rollback();
				$res["status"] = 500;
				$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	public function actionGetMemberInvestors()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$connection = Yii::app()->db;

			//Входящие данные
			$uid = intval($_POST["uid"]);

			if ((Functions::access_level(Yii::app()->user->id, $uid)) && (Yii::app()->user->id > 0) && ($uid > 0)) {
				$res["members"] = $connection->createCommand("SELECT u.uid, u.refx, u.name, u.fio, u.level, u.count_users, u.photo, u.alias, u.package FROM {{usersinfo}} u WHERE u.refx = :uid AND u.status = 1 AND u.uid <> :uid ORDER BY u.count_users DESC, u.level DESC")
					->bindParam(":uid", $uid)
					->queryAll();

				$res["status"] = 200;
			} else {
				$res["status"] = 500;
				$res["message"] = "Вы не можете просматривать информацию о пользователе.";
			}
			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	

    // отменить входящую подписку
    public function actionFriendCancel()
    {
        
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;

            $uid = intval($_POST["uid"]);

            if(!empty($uid)){
                $transaction = $connection->beginTransaction();
                try {
                    $connection->createCommand("DELETE FROM {{friends}} WHERE uid = :uid AND fuid = :fuid")
                        ->bindParam(":uid", $uid)
                        ->bindParam(":fuid", Yii::app()->user->id)
                        ->query();
                    $transaction->commit();
                    $res["status"] = 200;
                }catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            }else{
                $res["status"] = 500;
                $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
            }
            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }

    // оставить в подписчиках
    public function actionFriendLeaveSubscribed()
    {   
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;

            $uid = intval($_POST["uid"]);
            $friend = $connection->createCommand("SELECT * FROM {{friends}} WHERE uid = :uid AND fuid = :fuid AND status = 0")->bindParam(":uid", $uid)->bindParam(":fuid", Yii::app()->user->id)->queryAll();

            if(!empty($friend)){
                $transaction = $connection->beginTransaction();
                try {

                    $connection->createCommand("UPDATE {{friends}} SET status = 1 WHERE uid = :uid AND fuid = :fuid AND status = 0")->bindParam(":uid", $uid)->bindParam(":fuid", Yii::app()->user->id)->query();

                    $transaction->commit();
                    $res["status"] = 200;
                }catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            }else{
                $res["status"] = 500;
                $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
            }
            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }

    public function actionFriendAdd()
    {
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;

            $uid = intval($_POST["uid"]);

            if(!empty($uid)){
                $transaction = $connection->beginTransaction();
                try {
                    $friend_my = $connection->createCommand("SELECT * FROM {{friends}} WHERE uid = :uid AND fuid = :fuid")->bindParam(":uid", $uid)->bindParam(":fuid", Yii::app()->user->id)->queryRow();
                    $my_friend = $connection->createCommand("SELECT * FROM {{friends}} WHERE uid = :uid AND fuid = :fuid")->bindParam(":uid", Yii::app()->user->id)->bindParam(":fuid", $uid)->queryRow();

                    if(!empty($friend_my) && ($friend_my['status'] == 0 || $friend_my['status'] == 1)){
                        $connection->createCommand("UPDATE {{friends}} SET status = 2 WHERE uid = :uid AND fuid = :fuid")->bindParam(":uid", $uid)->bindParam(":fuid", Yii::app()->user->id)->query();
                        if(!empty($my_friend)){
                            $connection->createCommand("UPDATE {{friends}} SET status = 2 WHERE uid = :uid AND fuid = :fuid")->bindParam(":uid", Yii::app()->user->id)->bindParam(":fuid", $uid)->query();
                        }else{
                            $connection->createCommand()->insert('{{friends}}', array('uid' => Yii::app()->user->id, 'fuid' => $uid, 'date' => time(), 'status' => 2));
                        }
                    }else{
                        if(!empty($my_friend)){
                            $connection->createCommand("UPDATE {{friends}} SET status = 0 WHERE uid = :uid AND fuid = :fuid")->bindParam(":uid", Yii::app()->user->id)->bindParam(":fuid", $uid)->query();
                        }else{
                            $connection->createCommand()->insert('{{friends}}', array('uid' => Yii::app()->user->id, 'fuid' => $uid, 'date' => time(), 'status' => 0));
                        }
                    }

                    $transaction->commit();
                    $res["status"] = 200;
                }catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            }else{
                $res["status"] = 500;
                $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
            }
            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }

    public function actionMyFriendsFilter()
    {
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;
            $limit = Yii::app()->params['users-per-page'];

            $alias = mysql_escape_string(htmlspecialchars(strip_tags($_POST["alias"])));
            $user_info = !empty($alias) ? $connection->createCommand("SELECT uid, alias, CONCAT(name, ' ', fio) as fio FROM {{usersinfo}} WHERE alias = :alias")->bindParam(":alias", $alias)->queryRow() : $connection->createCommand("SELECT * FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();

            $page = intval($_POST['page']);
            $country = intval($_POST['country']);
            $city = intval($_POST['city']);
            $sex = intval($_POST['sex']);
            $marital_status = intval($_POST['marital_status']);
            $age_from = intval($_POST['age_from']);
            $age_to = intval($_POST['age_to']);
            $search_query = mysql_escape_string(htmlspecialchars(strip_tags($_POST["search_query"])));
            $pieces = explode(" ", $search_query);

            if(!empty($user_info)){
                $query = array();
                try {
                    $query['user'] = ' u.type = 1 AND u.status = 1 ';
                    $query['not_me'] = ' u.uid <> :uid ';

                    if (!empty($country) && $country > 0) {
                        $query['country'] = ' u.country = :country ';
                    }
                    if (!empty($city) && $city > 0) {
                        $query['city'] = ' u.city = :city ';
                    }
                    if (!empty($sex) && in_array($sex, array(1, 2))) {
                        $query['sex'] = ' u.sex = :sex ';
                    }
                    if (!empty($marital_status) && $marital_status > 0 && $marital_status <= 7) {
                        $query['marital_status'] = ' u.marital_status = :marital_status ';
                    }
                    if (!empty($age_from) && $age_from >= 14) {
                        $query['age_from'] = ' FLOOR(DATEDIFF(CURDATE(), u.birth)/365)>=:age_from ';
                    }
                    if (!empty($age_to) && ($age_to >=1 && $age_to <= 80)) {
                        $query['age_to'] = ' FLOOR(DATEDIFF(CURDATE(), u.birth)/365)<=:age_to ';
                    }
                    if (!empty($search_query) && strlen($search_query) >= 3) {
                        if (count($pieces) == 1) {
                            $query['search_query'] = ' (u.name LIKE :text1 || u.fio LIKE :text1) ';
                        } elseif (count($pieces) == 2) {
                            $query['search_query'] = ' (u.name LIKE :text1 || u.fio LIKE :text1 || u.name LIKE :text2 || u.fio LIKE :text2) ';
                        }
                    }

                    $query = !empty($query) ? " WHERE " . implode(" AND ", $query) : '';

                    $sql = "SELECT SQL_CALC_FOUND_ROWS u.uid, u.name, u.fio, u.alias, u.status, u.photo, u.country, u.online, u.sex FROM {{usersinfo}} u INNER JOIN {{friends}} f ON f.fuid = :uid AND f.uid = u.uid AND f.status = 2 " . $query . " ORDER BY uid DESC LIMIT :limit OFFSET :offset";

                    $command = $connection->createCommand($sql);
                    $command->bindParam(":uid", $user_info['uid']);
                    $command->bindValue(":limit", $limit, PDO::PARAM_INT);
                    $command->bindValue(":offset", ($page - 1) * $limit, PDO::PARAM_INT);

                    if (!empty($country) && $country > 0) {
                        $command->bindParam(":country", $country);
                    }
                    if (!empty($city) && $city > 0) {
                        $command->bindParam(":city", $city);
                    }
                    if (!empty($sex) && in_array($sex, array(1, 2))) {
                        $command->bindParam(":sex", $sex);
                    }
                    if (!empty($marital_status)) {
                        $command->bindParam(":marital_status", $marital_status);
                    }
                    if (!empty($age_from) && $age_from >= 14) {
                        $command->bindParam(":age_from", $age_from);
                    }
                    if (!empty($age_to) && ($age_to >=1 && $age_to <= 80)) {
                        $command->bindParam(":age_to", $age_to);
                    }
                    if (!empty($search_query) && strlen($search_query) >= 3) {
                        if (count($pieces) == 1) {
                            $command->bindValue(":text1", '%' . $pieces[0] . '%');
                        } elseif (count($pieces) == 2) {
                            $command->bindValue(":text1", '%' . $pieces[0] . '%');
                            $command->bindValue(":text2", '%' . $pieces[2] . '%');
                        }
                    }

                    $users = $command->queryAll();
                    $totalRecords = $connection->createCommand('SELECT FOUND_ROWS()')->queryScalar();

                    if (!empty($users)) {
                        $res["status"] = 200;
                        $res["users"] = $users;
                        $res["total"] = $totalRecords;
                    } else {
                        $res["status"] = 500;
                        $res["total"] = 0;
                    }
                } catch (Exception $e) {
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен.";
                }
            }else{
                $res["status"] = 500;
                $res["total"] = 0;
            }

            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }

    // удалить из друзей
    public function actionFriendDelete()
    {
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;
            $uid = intval($_POST["uid"]);

            if(!empty($uid)){
                $transaction = $connection->beginTransaction();
                try {
                    $connection->createCommand("UPDATE {{friends}} SET status = 1 WHERE uid = :uid AND fuid = :fuid AND status = 2;")
                        ->bindParam(":uid", $uid)
                        ->bindParam(":fuid", Yii::app()->user->id)
                        ->query();
                    $connection->createCommand("DELETE FROM {{friends}} WHERE uid = :uid AND fuid = :fuid AND status = 2;")
                        ->bindParam(":uid", Yii::app()->user->id)
                        ->bindParam(":fuid", $uid)
                        ->query();

                    $transaction->commit();
                    $res["status"] = 200;
                }catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            }else{
                $res["status"] = 500;
                $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
            }
            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }

    public function actionSetPrivacySettings()
    {
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;
            $err = '';

            $mail_send = intval($_POST["mail_send"]);

            $my = $connection->createCommand("SELECT * FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();

            if(empty($my)){
                $err .= '<li>Досткп запрещен.</li>';
            }
            if(!in_array($mail_send, [1,2,3,4])){
                $err .= '<li>Укажите кто может писать Вам сообщения</li>';
            }

            if ($err == '') {
                $transaction = $connection->beginTransaction();
                try{
                    $users_settings = $connection->createCommand("SELECT uid, mail_send FROM {{users_settings}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
                    if(!empty($users_settings)){
                        $connection->createCommand("UPDATE {{users_settings}} SET mail_send = :mail_send WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->bindParam(":mail_send", $mail_send)->query();
                    }else{
                        $connection->createCommand()->insert('{{users_settings}}', array('uid' => Yii::app()->user->id, 'find_place' => 1, 'mail_send' => 1 ));
                    }

                    $transaction->commit();
                    $res["status"] = 200;
                }catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            } else {
                $res["status"] = 500;
                $res["message"] = 'Возникла ошибка. '.$err;
            }

            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }
    
    
    
    
    public function actionSetUserFilter()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;
			$err = '';

			$filter_name = mysql_escape_string(htmlspecialchars(strip_tags($_POST["filter_name"])));
			$type = intval($_POST["type"]);
			$query_text = mysql_escape_string(htmlspecialchars(strip_tags($_POST["query_text"])));
			$category_id = intval($_POST["category_id"]);
			$country_id = intval($_POST["country_id"]);
			$city_id = intval($_POST["city_id"]);
			$place = intval($_POST["place"]);
			$sort = intval($_POST["sort"]);

			$my = $connection->createCommand("SELECT * FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
			$category = null;
			if(in_array($type, [2,3])){
				$category = $connection->createCommand("SELECT * FROM {{categories}} WHERE id = :id")->bindParam(":id", $category_id)->queryRow();
			}
			$country = null;
			$city = null;
			if($country_id > 0){
				$country = Loc::getCountryById($country_id);
			}
			$country_name = !empty($country) ? $country['title'] : '';
			if($city_id > 0){
				$city = Loc::getCityById($city_id);
			}
			$city_name = !empty($city) ? $city['title'] : '';

			if(empty($my)){
				$err .= '<li>Доступ запрещен</li>';
			}
			if(empty($filter_name)){
				$err .= '<li>Введите название фильтра.</li>';
			}
			$type = in_array($type, [1,2,3]) ? $type : 1;
			$category_name = !empty($category) ? $category['name'] : '';
			$place = in_array($place, [1,2]) ? $place : 1;
			$sort = in_array($sort, [1,2]) ? $sort : 1;

			if ($err == '') {
				$transaction = $connection->beginTransaction();
				try{
					$connection->createCommand()->insert('{{users_filter}}', array(
						'uid' => Yii::app()->user->id,
						'name' => $filter_name,
						'type' => $type,
						'country_id' => !empty($country) ? $country_id : 0,
						'city_id' => !empty($city) ? $city_id : 0,
						'category_id' => !empty($category) ? $category_id : 0,
						'country_name' => $country_name,
						'city_name' => $city_name,
						'category_name' => $category_name,
						'query_text' => $query_text,
						'sort' => $sort,
						'place' => $place
					));
					$filter_id = Yii::app()->db->getLastInsertID();

					$filter = $connection->createCommand("SELECT * FROM {{users_filter}} WHERE id = :id")->bindParam(":id", $filter_id)->queryRow();

					$transaction->commit();
					$res["filter"] = $filter;
					$res["status"] = 200;
				}catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
				}
			} else {
				$res["status"] = 500;
				$res["message"] = $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}

	public function actionGetFilters(){
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$connection = Yii::app()->db;
			$res = array();

			if (Yii::app()->user->id > 0) {
				$res["filters"] = $connection->createCommand("SELECT * FROM {{users_filter}} WHERE uid = :uid")
					->bindValue(":uid", Yii::app()->user->id)
					->queryAll();
				$res["status"] = 200;
			} else {
				$res["status"] = 500;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}

	}

	public function actionUserFilterDelete()
	{
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;

			$id = intval($_POST["id"]);
			$filter = $connection->createCommand("SELECT * FROM {{users_filter}} WHERE id = :id AND uid = :uid")
				->bindParam(":uid", Yii::app()->user->id)
				->bindParam(":id", $id)
				->queryRow();

			if(!empty($filter)){
				$transaction = $connection->beginTransaction();
				try {
					$connection->createCommand("DELETE FROM {{users_filter}} WHERE id = :id AND uid = :uid")
						->bindParam(":uid", Yii::app()->user->id)
						->bindParam(":id", $id)
						->query();
					$transaction->commit();
					$res["status"] = 200;

				}catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
				}
			}else{
				$res["status"] = 500;
				$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
			}
			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	
	
	
	
	public function actionSetTransfer()
    {
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $connection = Yii::app()->db;
            $res = array();
            $err = '';

            $email = mysql_escape_string(htmlspecialchars(strip_tags($_POST["email"])));
            $date_from = strtotime('-1 month');

            $transfer = $connection->createCommand("SELECT * FROM {{users_transfer}} WHERE uid = :uid AND status = 0")->bindParam(":uid", Yii::app()->user->id)->queryRow();
            $transfer_ok = $connection->createCommand("SELECT * FROM {{users_transfer}} WHERE uid = :uid AND status = 1 AND date > :date_from ORDER BY date DESC LIMIT 1")->bindParam(":uid", Yii::app()->user->id)->bindParam(":date_from", $date_from)->queryRow();
            $user_to = $connection->createCommand("SELECT uid FROM {{users}} WHERE mail = :email")->bindParam(":email", $email)->queryRow();
            $user_from = $connection->createCommand("SELECT uid, refx FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();

            if(empty($user_to)){
                $err .= '<li>Проверьте правильность заполненных полей и повторите попытку снова.</li>';
            }
            if(!empty($transfer)){
                $err .= '<li>Вы уже подали заявку на переход.</li>';
            }
            if(!empty($transfer_ok)){
                $err .= '<li>Вы можете сделать переход не более 1 раза в месяц.</li>';
            }
            if($user_to['uid'] == Yii::app()->user->id){
                $err .= '<li>Вы не можете сделать переход в свою структуру.</li>';
            }
            
            if($user_from["refx"] == $user_to["uid"]) {
	             $err .= '<li>Вы уже находитесь в первой линии данного пользователя.</li>';
            }
            
            if($err == "") {
            
	            if(Functions::access_level(Yii::app()->user->id, $user_to["uid"])) {
		         	$err = '<li>Вы не можете перейти к данному пользователю, так как он находится в вашей структуре.</li>';
		        }
	        
	        }

            if ($err == '') {
                $transaction = $connection->beginTransaction();
                try{
                    $connection->createCommand()->insert('{{users_transfer}}', array('uid' => Yii::app()->user->id, 'touid' => $user_to['uid'], 'status' => 0, 'date' => time()));

                    $transaction->commit();
                    $res["status"] = 200;
                    $res["message"] = "Заявка на переход успешно отправлена.";
                }catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            } else {
                $res["status"] = 500;
                $res["message"] = 'Возникла ошибка. '.$err;
            }

            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }

    public function actionGetTransfer()
    {
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $connection = Yii::app()->db;
            $res = array();

            $res["transfers_my"] = $connection->createCommand("SELECT t.id, t.status, t.date, CONCAT(u.name, ' ', u.fio) as fio FROM {{users_transfer}} t INNER JOIN {{usersinfo}} u WHERE t.uid = :uid AND t.status = 0 AND u.uid = t.touid")->bindParam(":uid", Yii::app()->user->id)->queryAll();
            $res["transfers_in"] = $connection->createCommand("SELECT t.id, t.status, t.date, CONCAT(u.name, ' ', u.fio) as fio FROM {{users_transfer}} t INNER JOIN {{usersinfo}} u WHERE t.touid = :uid AND t.status = 0 AND u.uid = t.uid")->bindParam(":uid", Yii::app()->user->id)->queryAll();
            $res["status"] = 200;

            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }

    public function actionSetUserTransferCancel(){

        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $connection = Yii::app()->db;
            $res = array();
            $err = "";

            $id = intval($_POST["id"]);
            $transfer = $connection->createCommand("SELECT * FROM {{users_transfer}} WHERE id = :id AND uid = :uid AND status = 0")->bindParam(":id",$id)->bindParam(":uid",Yii::app()->user->id)->queryRow();

            if(empty($transfer)){
                $err .= "<li>Ошибка отмены.</li>";
            }

            if (Yii::app()->user->id > 0 && $err == '') {
                $transaction = $connection->beginTransaction();
                try {
                    $connection->createCommand("DELETE FROM {{users_transfer}} WHERE id = :id AND uid = :uid AND status = 0")->bindParam(":id",$id)->bindParam(":uid",Yii::app()->user->id)->query();
                    $transaction->commit();

                    $res["status"] = 200;
                    $res["message"] = "Заявка успешно отменена.";
                } catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            } else {
                $res["status"] = 500;
                $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
            }

            echo CJSON::encode($res);
            Yii::app()->end();

        }
    }

    public function actionSetUserTransferOk(){
	    
	   /* if(Yii::app()->user->id != 3) {
	    $res["status"] = 500;
	    $res["message"] = "Возможность вскоре будет доступна.";
	    echo CJSON::encode($res);
	    Yii::app()->end();
	    }*/

        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $connection = Yii::app()->db;
            $res = array();
            $err = "";

            $id = intval($_POST["id"]);
            $transfer = $connection->createCommand("SELECT * FROM {{users_transfer}} WHERE id = :id AND touid = :uid AND status = 0")->bindParam(":id", $id)->bindParam(":uid", Yii::app()->user->id)->queryRow();
            $transfer_uid = $transfer["uid"];
            
            $usersinfo = $connection->createCommand("SELECT * FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", $transfer_uid)->queryRow();
            

            if(empty($transfer)){
                $err .= "<li>Ошибка подтверждения.</li>";
            }

	        if($usersinfo["refx"] == Yii::app()->user->id){
                $err = "<li>Пользователь уже находится у вас в структуре.</li>";
            }
            
            if($transfer["touid"] <> Yii::app()->user->id){
               $err = "<li>Ошибка подтверждения.</li>";
            }
	        
	        if($err == "") {
            
	            if(Functions::access_level($transfer["uid"], $transfer["touid"])) {
		         	$err = '<li>Вы не можете перевести данного пользователя в свою структуру.</li>';
		        }
	        
	        }
	        
	         $invite_user = $connection->createCommand("SELECT * FROM {{users_invite_user}} WHERE uid = :uid AND status = 1")
	         ->bindParam(":uid", $transfer["uid"])
	         ->queryRow();
	         $invite_user_invite = $invite_user["invite"];
	         
	         $invite_code = $connection->createCommand("SELECT * FROM {{users_invite_code}} WHERE invite = :invite AND status = 1")
	         ->bindParam(":invite", $invite_user_invite)
	         ->queryRow();
	         
	         if(empty($invite_user)) {
		          $err = "<li>Пользователь не вводил ранее инвайтов.</li>";
	         }
	         
	         if(empty($invite_code)) {
		          $err = "<li>Пользователь не вводил ранее инвайтов.</li>";
	         }
	        

            if (Yii::app()->user->id > 0 && $err == '') {
                $transaction = $connection->beginTransaction();
                try {
                    
                    $connection->createCommand()->insert('{{users_transfer_ok}}', array(
						'tid' => $transfer["id"],
						'date' => time(),
						'status' => 1
					));
                    
                    $connection->createCommand("UPDATE {{users_invite_code}} SET transfer_id = :transfer_id, uid = :uid WHERE id = :id")
	                    ->bindParam(":id", $invite_code["id"])
	                    ->bindParam(":transfer_id", $transfer["id"])
	                    ->bindParam(":uid", Yii::app()->user->id)
	                    ->query();
	                    
	                $connection->createCommand("UPDATE {{usersinfo}} SET refx = :refx WHERE uid = :uid")
	                    ->bindParam(":refx", $transfer["touid"])
	                    ->bindParam(":uid", $transfer["uid"])
	                    ->query();
	                    
	                //Вставляем новый инвайт если пользовоатель выше
					/*$hash = $usersinfo["refx"] . "." . time();
					$connection->createCommand()->insert('{{users_invite_new}}', array(
						'uid' => $usersinfo["refx"], 
						'amount' => 1, 'date' => time(), 
						'type' => 4, 
						'status' => 1, 
						'hash' => $hash
					));*/
					
					$date = time();
					$code = $usersinfo["refx"] . "-" . $date . "-" .$transfer["id"] . "-" . 1;
					$invite_code_new = strtoupper(md5($code));
						
					$connection->createCommand()->insert('{{users_invite_code}}', array(
						'uid' => $usersinfo["refx"], 
						'invite' => $invite_code_new, 
						'date' => time(), 
						'status' => 0
					));
                    
                    $connection->createCommand("UPDATE {{users_transfer}} SET status = 1 WHERE id = :id AND touid = :uid AND status = 0")
                    	->bindParam(":id", $id)
                    	->bindParam(":uid", Yii::app()->user->id)
                    	->query();
                    	
                    $transaction->commit();

                    $res["status"] = 200;
                    $res["message"] = "Заявка успешно подтверждена.";
                } catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = $e . "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            } else {
                $res["status"] = 500;
                $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
            }

            echo CJSON::encode($res);
            Yii::app()->end();

        }

    }
	
	
	
    
	

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if ($error = Yii::app()->errorHandler->error) {
			if (Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}
}