<?php

class VoucherController extends Controller
{
	public function filters()
	{
		return array(
			'accessControl',
		);
	}

	public function accessRules()
	{
		return array(
			array('allow',
				'users' => array('@'),
			),
			array('deny',
				'users' => array('*'),
			)
		);
	}


	public function actionSetVoucherActivate(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;
			$err = '';
			$voucher = intval($_POST["voucher"]);

			$voucher_code = $connection->createCommand("SELECT id, uid, voucher, package, amount, uid_activate FROM {{users_voucher_code}} WHERE id = :voucher AND uid = :uid AND status = 0 AND uid_activate <> :uid AND uid > 0")
					->bindParam(":voucher", $voucher)
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();
			$wallet = $connection->createCommand("SELECT id, uid, cash_now FROM {{users_wallet}} WHERE uid = :uid AND type = 4")
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();
			$user_info = $connection->createCommand("SELECT uid, package, level, refx FROM {{usersinfo}} WHERE uid = :uid AND status > 0 AND status = 1")
					->bindParam(":uid", $voucher_code['uid_activate'])
					->queryRow();
			$is_voucher_in = $connection->createCommand("SELECT * FROM {{users_voucher_user}} WHERE uid = :uid AND voucher = :voucher")
					->bindParam(":uid", $voucher_code['uid_activate'])
					->bindParam(":voucher", $voucher_code['voucher'])
					->queryRow();

			if(empty($voucher_code)) {
				$err .= "<li>Введенный Вами код не найден либо уже используется другим пользователем.</li>";
				$connection->createCommand()->insert('{{users_voucher_logs}}', array('uid' => Yii::app()->user->id, 'ip' => $_SERVER["REMOTE_ADDR"], 'date' => time(), 'data' => $voucher, 'action' => 0, 'status' => 0 ));
			}
			if($user_info['package'] >= $voucher_code['package']){
				$err .= "<li>Вы не можете активировать данный пакет, так как подписка пользователя более актуальна.</li>";
			}
			if(!empty($is_voucher_in))
				$err .= "<li>Данный ваучер уже активирован.</li>";
			if(empty($wallet))
				$err .= "<li>Возникла ошибка при активации ваучера. Обновите страницу и повторите попытку снова</li>";

			if ($err == "") {

				$transaction = $connection->beginTransaction();
				try {

					$status = $user_info['package'] > 0 ? 1 : 0;
					$date_end = time() + 864000; // 10 дней

					$connection->createCommand()->insert('{{users_voucher_user}}', array('uid' => $voucher_code['uid_activate'], 'cid' => $voucher_code["id"], 'voucher' => $voucher_code["voucher"], 'date_start' => time(), 'date_end' => $date_end, 'package' => $user_info['package'], 'status' => $status));

					$connection->createCommand("UPDATE {{users_voucher_code}} SET status = 1 WHERE id = :id")
							->bindParam(":id", $voucher_code["id"])
							->query();

					//Вставляется запись в pm_users_voucher_history - тоже подтверждение
//					$connection->createCommand()->insert('{{users_voucher_history}}', array('uid' => $voucher_code['uid_activate'], 'nid' => $voucher["id"], 'date' => time(), 'status' => 1));

					$connection->createCommand("UPDATE {{usersinfo}} SET package = :package WHERE uid = :uid; UPDATE {{users_invite_user}} SET status = 1, package = :package WHERE uid = :uid; ")
							->bindParam(":uid", $voucher_code['uid_activate'])
							->bindParam(":package", $voucher_code["package"])
							->query();
							
					$connection->createCommand()->insert('{{users_pkg}}', array('uid' => $voucher_code['uid_activate'], 'date' => time(),  'deposit' => $voucher_code["amount"], 'pid' => $voucher_code['id'], 'type' => $voucher_code["package"], 'status' => 1, 'hash' => doubleval($voucher_code["uid"] . "." . $voucher_code["package"]) ));
					$kpg_id = Yii::app()->db->getLastInsertID();

					//Обновляем сумму в кошельке у хранителя
					$connection->createCommand("UPDATE {{users_wallet}} SET cash_now = cash_now + :amount WHERE uid = :uid AND type = 4;")
							->bindParam(":uid", $voucher_code['uid'])
							->bindParam(":amount", $voucher_code['amount'])
							->query();

					//Вставляем транзакцию
					$connection->createCommand()->insert('{{utransactions}}', array(
							'did' => $kpg_id, 'psid' => $voucher_code['id'], 'uid' => $wallet['uid'], 'ruid' => $voucher_code['uid_activate'], 'amount' => $voucher_code['amount'], 'amount_now' => $wallet['cash_now'] + $voucher_code['amount'], 'date' => time(), 'type' => 1, 'status' => 1, 'transaction' => $voucher_code["voucher"], 'action' => 2
					));
					$utransactions = $connection->getLastInsertID();

					//Вставляем бонус + увеличиваем потенциал =============

					//Вставляем потенциал

					$percent = 0.003;
					$days = 333;
					$amount = $voucher_code["amount"];

					$percent_promo = 0; //0.2 20%
					$amount_all = $amount + $percent_promo;

					$connection->createCommand()->insert('{{users_potential}}', array('uid' => $voucher_code['uid_activate'], 'cuid' => $voucher_code['uid_activate'], 'puid' => 0, 'fuid' => 0, 'date' => time(), 'dt' => 0, 'dte' => $days, 'deposit' => $amount, 'percent' => $percent, 'cash_now' => 0, 'cash_out' => 0, 'cash_all' => 0, 'type' => 1, 'status' => 1));
					$pid_id = Yii::app()->db->getLastInsertID();
					
					//Вставляем привязку из архива
					$amount_archive = $amount;//doubleval($amount/2);
					$connection->createCommand()->insert('{{users_potential_archive}}', array(
						'uid' => $voucher_code['uid_activate'], 
						'pid' => $pid_id, 
						'gid' => 0,
						'date' => time(), 
						'amount' => $amount_archive, 
						'status' => 0
					));


					//Вставляем акционное приумножение

					$promo = 0.6; //В 2 раза
					$invite_count = 10;
					switch($voucher_code["package"]) {
						case 1:
							$promo = 0.6;
							$invite_count = 10;
							break;
						case 2:
							$promo = 0.7;
							$invite_count = 10;
							break;
						case 3:
							$promo = 0.8;
							$invite_count = 10;
							break;
						case 4:
							$promo = 0.9;
							$invite_count = 10;
							break;
						case 5:
							$promo = 1;
							$invite_count = 10;
							break;
						case 6:
							$promo = 1.1;
							$invite_count = 10;
							break;
						case 7:
							$promo = 1.25;
							$invite_count = 10;
							break;
						case 8:
							$promo = 1;
							$invite_count = 10;
							break;
						case 9:
							$promo = 0.75;
							$invite_count = 10;
							break;
						case 10:
							$promo = 0.5;
							$invite_count = 10;
							break;
						
					}

					$hash_promo = $voucher_code['uid_activate'] . "." . time();
					$date_activate = time() + rand(36000, 108000);
					$amount_promo = $amount * $promo;

					$connection->createCommand()->insert('{{users_potential}}', array('uid' => $voucher_code['uid_activate'], 'cuid' => $voucher_code['uid_activate'], 'puid' => 0, 'fuid' => 0, 'date' => time(), 'dt' => 0, 'dte' => $days, 'deposit' => $amount_promo, 'percent' => $percent, 'cash_now' => 0, 'cash_out' => 0, 'cash_all' => 0, 'type' => 3, 'status' => 1));
					$pid_promo_id = Yii::app()->db->getLastInsertID();

					$connection->createCommand()->insert('{{users_potential_promo}}', array('uid' => $voucher_code['uid_activate'], 'pid' => $pid_id, 'amount' => $amount, 'promo' => $promo, 'date' => time(), 'date_activate' => $date_activate, 'status' => 1, 'hash' => $hash_promo));

					//Вставляем бонус + увеличиваем потенциал =============
					
					

					//Раздаем инвайты
					if($user_info["package"] == 0) {
						$connection->createCommand()->insert('{{users_invite_new}}', array('uid' => $voucher_code['uid_activate'], 'amount' => $invite_count, 'date' => time(), 'type' => 1, 'status' => 0, 'hash' => doubleval($voucher_code['uid_activate'] . "." . time()) ));
					}
					
					if($user_info["level"] == -1 && $user_info["package"] == 0) {
							$connection->createCommand("UPDATE {{usersinfo}} SET level = 0 WHERE uid = :uid; UPDATE {{usersinfo}} SET count_users = count_users + 1 WHERE uid = :refx;")
							->bindParam(":uid", $voucher_code['uid_activate'])
							->bindParam(":refx", $user_info["refx"])
							->query();
						}

					//Начисляем призовые. Если нет - отлаживаем их начисление;
					if(Functions::access_level(1, $voucher_code['uid_activate'])) {
						Money2::update_money_x($amount, $voucher_code['uid_activate'], 1); //type 1 = pkg
					} else {
						//Откладываем начисление до дольнейших разбирательств в чем проблема
						$connection->createCommand()->insert('{{usersdeposit_rx2_cancel}}', array('uid' => $voucher_code['uid_activate'], 'amount' => $amount, 'date' =>  time(), 'type' => 1, 'status' => 0));
					}

					$transaction->commit();
					$res["status"] = 200;
					$res["message"] = "Активация подписки прошла успешно. потенциал пользователя пополнен на $amount бонусных единиц (Bonus Point).";
				} catch (Exception $e) {
					$transaction->rollback();
					$res["status"] = 500;
					$res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
				}
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка при активации ваучера." . $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	
	
	public function actionSetVoucherPotentialActivate(){
		
		return;
		
        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;
            $err = '';
            $voucher = intval($_POST["voucher"]);

            $voucher_code = $connection->createCommand("SELECT id, uid, voucher, package, amount, uid_activate FROM {{users_voucher_code}} WHERE id = :voucher AND uid = :uid AND status = 0 AND uid_activate <> :uid AND uid > 0")
                ->bindParam(":voucher", $voucher)
                ->bindParam(":uid", Yii::app()->user->id)
                ->queryRow();
            $wallet = $connection->createCommand("SELECT id, uid, cash_now FROM {{users_wallet}} WHERE uid = :uid AND type = 4")
                ->bindParam(":uid", Yii::app()->user->id)
                ->queryRow();
            $user_info = $connection->createCommand("SELECT package, level, refx FROM {{usersinfo}} WHERE uid = :uid AND status > 0 AND status = 1")
                ->bindParam(":uid", $voucher_code['uid_activate'])
                ->queryRow();
            $is_voucher_in = $connection->createCommand("SELECT * FROM {{users_voucher_user}} WHERE uid = :uid AND voucher = :voucher")
                ->bindParam(":uid", $voucher_code['uid_activate'])
                ->bindParam(":voucher", $voucher_code['voucher'])
                ->queryRow();

            if(empty($voucher_code)) {
                $err .= "<li>Введенный Вами код не найден либо уже используется другим пользователем.</li>";
                $connection->createCommand()->insert('{{users_voucher_logs}}', array('uid' => Yii::app()->user->id, 'ip' => $_SERVER["REMOTE_ADDR"], 'date' => time(), 'data' => $voucher, 'action' => 0, 'status' => 0 ));
            }

            if(!empty($is_voucher_in))
                $err .= "<li>Данный ваучер уже активирован.</li>";
            if(empty($wallet))
                $err .= "<li>Возникла ошибка при активации ваучера. Обновите страницу и повторите попытку снова</li>";

            if ($err == "") {

                $transaction = $connection->beginTransaction();
                try {

                    $date_end = time() + 864000; // 10 дней

                    $connection->createCommand()->insert('{{users_voucher_user}}', array('uid' => $voucher_code['uid_activate'], 'cid' => $voucher_code["id"], 'voucher' => $voucher_code["voucher"], 'date_start' => time(), 'date_end' => $date_end, 'package' => 0, 'status' => 1));

                    $connection->createCommand("UPDATE {{users_voucher_code}} SET status = 1 WHERE id = :id")
                        ->bindParam(":id", $voucher_code["id"])
                        ->query();

                    //Обновляем сумму в кошельке у хранителя
                    $connection->createCommand("UPDATE {{users_wallet}} SET cash_now = cash_now + :amount WHERE uid = :uid AND type = 4;")
                        ->bindParam(":uid", $voucher_code['uid'])
                        ->bindParam(":amount", $voucher_code['amount'])
                        ->query();

                    //Вставляем транзакцию
                    $connection->createCommand()->insert('{{utransactions}}', array(
                        'did' => 0, 'psid' => $voucher_code['id'], 'uid' => $wallet['uid'], 'ruid' => $voucher_code['uid_activate'], 'amount' => $voucher_code['amount'], 'amount_now' => $wallet['cash_now'] + $voucher_code['amount'], 'date' => time(), 'type' => 1, 'status' => 1, 'transaction' => $voucher_code["voucher"], 'action' => 2
                    ));
                    $utransactions = $connection->getLastInsertID();

                    //Вставляем бонус + увеличиваем потенциал =============

                    //Вставляем потенциал

                    $percent = 0.003;
                    $days = 333;
                    $amount = $voucher_code["amount"];

                    $percent_promo = 0; //0.2 20%
                    $amount_all = $amount + $percent_promo;

                    $connection->createCommand()->insert('{{users_potential}}', array('uid' => $voucher_code['uid_activate'], 'cuid' => $voucher_code['uid_activate'], 'puid' => 0, 'fuid' => 0, 'date' => time(), 'dt' => 0, 'dte' => $days, 'deposit' => $amount, 'percent' => $percent, 'cash_now' => 0, 'cash_out' => 0, 'cash_all' => 0, 'type' => 1, 'status' => 1));
                    $pid_id = Yii::app()->db->getLastInsertID();
                    
                    
                    //Вставляем привязку из архива
					$amount_archive = doubleval($amount/2);
					$connection->createCommand()->insert('{{users_potential_archive}}', array(
						'uid' => $voucher_code['uid_activate'], 
						'pid' => $pid_id, 
						'gid' => 0,
						'date' => time(), 
						'amount' => $amount_archive, 
						'status' => 0
					));
					

                    //Вставляем акционное приумножение

                    $promo = 0.6; //В 2 раза
					$invite_count = 10;
					switch($user_info["package"]) {
						case 1:
							$promo = 0.6;
							$invite_count = 10;
							break;
						case 2:
							$promo = 0.7;
							$invite_count = 10;
							break;
						case 3:
							$promo = 0.8;
							$invite_count = 10;
							break;
						case 4:
							$promo = 0.9;
							$invite_count = 10;
							break;
						case 5:
							$promo = 1;
							$invite_count = 10;
							break;
						case 6:
							$promo = 1.1;
							$invite_count = 10;
							break;
						case 7:
							$promo = 1.25;
							$invite_count = 10;
							break;
						case 8:
							$promo = 1;
							$invite_count = 10;
							break;
						case 9:
							$promo = 0.75;
							$invite_count = 10;
							break;
						case 10:
							$promo = 0.5;
							$invite_count = 10;
							break;
						
					}

                    $hash_promo = $voucher_code['uid_activate'] . "." . time();
                    $date_activate = time() + rand(36000, 108000);
                    $amount_promo = $amount * $promo;

                    $connection->createCommand()->insert('{{users_potential}}', array('uid' => $voucher_code['uid_activate'], 'cuid' => $voucher_code['uid_activate'], 'puid' => 0, 'fuid' => 0, 'date' => time(), 'dt' => 0, 'dte' => $days, 'deposit' => $amount_promo, 'percent' => $percent, 'cash_now' => 0, 'cash_out' => 0, 'cash_all' => 0, 'type' => 3, 'status' => 1));
                    $pid_promo_id = Yii::app()->db->getLastInsertID();

                    $connection->createCommand()->insert('{{users_potential_promo}}', array('uid' => $voucher_code['uid_activate'], 'pid' => $pid_id, 'amount' => $amount, 'promo' => $promo, 'date' => time(), 'date_activate' => $date_activate, 'status' => 1, 'hash' => $hash_promo));

                    //Начисляем призовые. Если нет - отлаживаем их начисление;
                    if(Functions::access_level(1, $voucher_code['uid_activate'])) {
                        Money2::update_money_x($amount, $voucher_code['uid_activate'], 1); //type 1 = pkg
                    } else {
                        //Откладываем начисление до дольнейших разбирательств в чем проблема
                        $connection->createCommand()->insert('{{usersdeposit_rx2_cancel}}', array('uid' => $voucher_code['uid_activate'], 'amount' => $amount, 'date' =>  time(), 'type' => 1, 'status' => 0));
                    }

                    $transaction->commit();
                    $res["status"] = 200;
                    $res["message"] = "Активация ваучера прошла успешно. Потенциал пользователя пополнен на $amount бонусных единиц (Bonus Point).";
                } catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            } else {
                $res["status"] = 500;
                $res["message"] = "Возникла ошибка при активации ваучера." . $err;
            }

            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }



	public function actionGetUserVoucher(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;

			if (Yii::app()->user->id > 0) {

				//Используемые ваучеры
				$res["voucheractive"] = $connection->createCommand("SELECT c.type, c.uid_activate, c.id, c.uid, c.voucher, c.status, c.package, c.amount, i.name as user_name, i.fio as user_fio, i.alias as user_alias, i.photo as user_photo, i.package as user_package FROM {{users_voucher_code}} c INNER JOIN {{usersinfo}} i ON c.uid_activate = i.uid WHERE c.uid = :uid AND c.status IN(0,1) AND c.uid_activate <> 0 ORDER BY c.status DESC")
						->bindParam(":uid", Yii::app()->user->id)
						->queryAll();

				//Свободные ваучеры
				$res["voucher"] = $connection->createCommand("SELECT type, id, uid, voucher, status, package, amount FROM {{users_voucher_code}} WHERE uid = :uid AND status = 0 AND uid_activate = 0 ORDER BY status DESC")
						->bindParam(":uid", Yii::app()->user->id)
						->queryAll();

				$res["status"] = 200;
			} else {
				$res["status"] = 500;
				$res["message"] = "У Вас нет свободных ваучеров";
			}
			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}


	public function actionSetVoucherCode(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;
			$err = '';
			$voucher = mysql_escape_string(htmlspecialchars(strip_tags($_POST["voucher"])));

			$voucher_code = $connection->createCommand("SELECT id, uid, voucher, package, amount FROM {{users_voucher_code}} WHERE voucher = :voucher AND uid <> :uid AND status = 0 AND uid_activate = 0")
					->bindParam(":voucher", $voucher)
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();
			$user_info = $connection->createCommand("SELECT package FROM {{usersinfo}} WHERE uid = :uid")
					->bindParam(":uid",Yii::app()->user->id)
					->queryRow();
			$is_voucher_in = $connection->createCommand("SELECT * FROM {{users_voucher_user}} WHERE uid = :uid AND voucher = :voucher")
					->bindParam(":uid", Yii::app()->user->id)
					->bindParam(":voucher", $voucher_code['voucher'])
					->queryRow();

			if(empty($voucher_code)) {
				$err .= "<li>Введенный Вами код не найден либо уже используется другим пользователем.</li>";
				$connection->createCommand()->insert('{{users_voucher_logs}}', array('uid' => Yii::app()->user->id, 'ip' => $_SERVER["REMOTE_ADDR"], 'date' => time(), 'data' => $voucher, 'action' => 0, 'status' => 0 ));
			}
			if($user_info['package'] >= $voucher_code['package']){
				$err .= "<li>Вы не можете активировать данный пакет, так как Ваша подписка более актуальна.</li>";
			}
			if(!empty($is_voucher_in)){
				$err .= "<li>Данный ваучер уже активирован.</li>";
			}

			if ($err == "") {
				$connection->createCommand("UPDATE {{users_voucher_code}} SET uid_activate = :uid WHERE id = :id")
						->bindParam(":id", $voucher_code['id'])
						->bindParam(":uid", Yii::app()->user->id)
						->query();

				$res["status"] = 200;
				$res["message"] = "Активация ваучера прошла успешно. Ожидайте подтверждения.";
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка при активации ваучера." . $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	public function actionSetVoucherCodePotential(){

		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;
			$err = '';
			$voucher = mysql_escape_string(htmlspecialchars(strip_tags($_POST["voucher"])));

			$voucher_code = $connection->createCommand("SELECT id, uid, voucher, package, amount FROM {{users_voucher_code}} WHERE voucher = :voucher AND uid <> :uid AND status = 0 AND uid_activate = 0")
					->bindParam(":voucher", $voucher)
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();
					
			$user_info = $connection->createCommand("SELECT package FROM {{usersinfo}} WHERE uid = :uid")
					->bindParam(":uid",Yii::app()->user->id)
					->queryRow();

			$is_voucher_in = $connection->createCommand("SELECT * FROM {{users_voucher_user}} WHERE uid = :uid AND voucher = :voucher")
					->bindParam(":uid", Yii::app()->user->id)
					->bindParam(":voucher", $voucher_code['voucher'])
					->queryRow();

			if(!array_filter($voucher_code)) {
				$err .= "<li>Введенный Вами код не найден либо уже используется другим пользователем.</li>";
				$connection->createCommand()->insert('{{users_voucher_logs}}', array('uid' => Yii::app()->user->id, 'ip' => $_SERVER["REMOTE_ADDR"], 'date' => time(), 'data' => $voucher, 'action' => 0, 'status' => 0 ));
			}
			
			if($user_info['package'] == 0){
				$err .= "<li>Вы не можете активировать ваучер, не имея пакета подписки.</li>";
			}
			
			if(!empty($is_voucher_in)){
				$err .= "<li>Данный ваучер уже активирован.</li>";
			}

			if ($err == "") {
				$connection->createCommand("UPDATE {{users_voucher_code}} SET uid_activate = :uid WHERE id = :id")
						->bindParam(":id", $voucher_code['id'])
						->bindParam(":uid", Yii::app()->user->id)
						->query();

				$res["status"] = 200;
				$res["message"] = "Активация ваучера прошла успешно. Ожидайте подтверждения.";
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка при активации ваучера." . $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	public function actionSetVoucherCodeActiveBonus(){
		
		$res["status"] = 500;
		$res["message"] = "Пополнение активного бонуса при помощи ваучера вскоре будет доступно.";
		echo CJSON::encode($res);
		Yii::app()->end();
		
	}
	
	
	
	public function actionSetVoucherCodeNew(){
		
		if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
			$res = array();
			$connection = Yii::app()->db;
			$err = '';
			
			$voucher = mysql_escape_string(htmlspecialchars(strip_tags($_POST["voucher"])));
			$type_in = intval($_POST["type_in"]);

			$voucher_code = $connection->createCommand("SELECT id, uid, voucher, package, amount FROM {{users_voucher_code}} WHERE voucher = :voucher AND uid <> :uid AND status = 0 AND uid_activate = 0 AND type = 4")
					->bindParam(":voucher", $voucher)
					->bindParam(":uid", Yii::app()->user->id)
					->queryRow();
					
			$user_info = $connection->createCommand("SELECT package FROM {{usersinfo}} WHERE uid = :uid")
					->bindParam(":uid",Yii::app()->user->id)
					->queryRow();

			$is_voucher_in = $connection->createCommand("SELECT * FROM {{users_voucher_user}} WHERE uid = :uid AND voucher = :voucher")
					->bindParam(":uid", Yii::app()->user->id)
					->bindParam(":voucher", $voucher_code['voucher'])
					->queryRow();

			if(!array_filter($voucher_code)) {
				$err .= "<li>Введенный Вами код не найден либо уже используется другим пользователем.</li>";
				$connection->createCommand()->insert('{{users_voucher_logs}}', array('uid' => Yii::app()->user->id, 'ip' => $_SERVER["REMOTE_ADDR"], 'date' => time(), 'data' => $voucher, 'action' => 0, 'status' => 0 ));
			}
			
			if(!empty($is_voucher_in)){
				$err .= "<li>Данный ваучер уже активирован.</li>";
			}
			
			if(!in_array($type_in, array(1,2))) {
				$err = "Недопустимый тип ваучера.";
			}

			if ($err == "") {
				
				$connection->createCommand("UPDATE {{users_voucher_code}} SET uid_activate = :uid, newsystem = 1, newsystem_data = :type WHERE id = :id")
						->bindParam(":id", $voucher_code['id'])
						->bindParam(":uid", Yii::app()->user->id)
						->bindParam(":type", $type_in)
						->query();
						
						

				$res["status"] = 200;
				$res["message"] = "Активация ваучера прошла успешно. Ожидайте подтверждения.";
			} else {
				$res["status"] = 500;
				$res["message"] = "Возникла ошибка при активации ваучера." . $err;
			}

			echo CJSON::encode($res);
			Yii::app()->end();
		}
	}
	
	
	
	
	
	
	public function actionSetVoucherPotentialActivateNew(){

        if (Yii::app()->request->isAjaxRequest && !Yii::app()->user->isGuest) {
            $res = array();
            $connection = Yii::app()->db;
            $err = '';
            $voucher = intval($_POST["voucher"]);

            $voucher_code = $connection->createCommand("SELECT * FROM {{users_voucher_code}} WHERE id = :voucher AND uid = :uid AND status = 0 AND uid_activate <> :uid AND uid > 0 AND type = 4")
                ->bindParam(":voucher", $voucher)
                ->bindParam(":uid", Yii::app()->user->id)
                ->queryRow();
            $wallet = $connection->createCommand("SELECT id, uid, cash_now FROM {{users_wallet}} WHERE uid = :uid AND type = 4")
                ->bindParam(":uid", Yii::app()->user->id)
                ->queryRow();
            $userinfo = $connection->createCommand("SELECT uid, package, level, refx FROM {{usersinfo}} WHERE uid = :uid AND status > 0 AND status = 1")
                ->bindParam(":uid", $voucher_code['uid_activate'])
                ->queryRow();
            $is_voucher_in = $connection->createCommand("SELECT * FROM {{users_voucher_user}} WHERE uid = :uid AND voucher = :voucher")
                ->bindParam(":uid", $voucher_code['uid_activate'])
                ->bindParam(":voucher", $voucher_code['voucher'])
                ->queryRow();

            if(empty($voucher_code)) {
                $err .= "<li>Введенный Вами код не найден либо уже используется другим пользователем.</li>";
                $connection->createCommand()->insert('{{users_voucher_logs}}', array('uid' => Yii::app()->user->id, 'ip' => $_SERVER["REMOTE_ADDR"], 'date' => time(), 'data' => $voucher, 'action' => 0, 'status' => 0 ));
            }

            if(!empty($is_voucher_in))
                $err .= "<li>Данный ваучер уже активирован.</li>";
            if(empty($wallet))
                $err .= "<li>Возникла ошибка при активации ваучера. Обновите страницу и повторите попытку снова</li>";
            
            
            //Проверочные данные
                
            $from_uid = 181182; //У кого на счету списываются деньги
						
			$wallet_from = $connection->createCommand("SELECT * FROM {{users_wallet}} WHERE uid = :uid AND type = 1 AND status = 1")->bindParam(":uid", $from_uid)->queryRow();
			
			$wallet_to = $connection->createCommand("SELECT * FROM {{users_wallet}} WHERE uid = :uid AND type = 1 AND status = 1")->bindParam(":uid", $voucher_code["uid_activate"])->queryRow();

			if ((empty($wallet_from)) || (empty($wallet_to))) {
				$err .= "<p>Выбранных кошельков не существует.</p>";
			}
			
			
			
            if ($err == "") {

                $transaction = $connection->beginTransaction();
                try {

                    $date_end = time() + 864000; // 10 дней

                    $connection->createCommand()->insert('{{users_voucher_user}}', array('uid' => $voucher_code['uid_activate'], 'cid' => $voucher_code["id"], 'voucher' => $voucher_code["voucher"], 'date_start' => time(), 'date_end' => $date_end, 'package' => 0, 'status' => 1));

                    $connection->createCommand("UPDATE {{users_voucher_code}} SET status = 1 WHERE id = :id")
                        ->bindParam(":id", $voucher_code["id"])
                        ->query();

                    //Обновляем сумму в кошельке у хранителя
                    $connection->createCommand("UPDATE {{users_wallet}} SET cash_now = cash_now + :amount WHERE uid = :uid AND type = 4;")
                        ->bindParam(":uid", $voucher_code['uid'])
                        ->bindParam(":amount", $voucher_code['amount'])
                        ->query();

                    //Вставляем транзакцию
                    $connection->createCommand()->insert('{{utransactions}}', array(
                        'did' => 0, 'psid' => $voucher_code['id'], 'uid' => $wallet['uid'], 'ruid' => $voucher_code['uid_activate'], 'amount' => $voucher_code['amount'], 'amount_now' => $wallet['cash_now'] + $voucher_code['amount'], 'date' => time(), 'type' => 1, 'status' => 1, 'transaction' => $voucher_code["voucher"], 'action' => 2
                    ));
                    $utransactions = $connection->getLastInsertID();


					//++++++++++++++++++++++++++++++++++++
					
					$amount = $voucher_code["amount"];
					$amount_check = doubleval($voucher_code["amount"] / 2);
					
					//++++++++++++++++++++++++++++++++++++
			
					
					 //Проверяем способ распределения (100 или 50 на 50)
					
					$type_in = intval($voucher_code["newsystem_data"]);
					if($type_in == 0) $type_in = 1;
					
					if($type_in == 1) {
						
						$amount_check = doubleval($voucher_code["amount"]);
								
						//*********************************
						//Добавляем сумму в потенциал
						//*********************************
						
						
						//Вставляем потенциал
						
						$percent = 0.003;
						$days = 333;
						$amount_check = $amount_check;
						
						$percent_promo = 0; //0.2 20%
						$amount_all = $amount_check + $percent_promo;
						

						$connection->createCommand()->insert('{{users_potential}}', array('uid' => $voucher_code["uid_activate"], 'cuid' => $voucher_code["uid_activate"], 'puid' => 0, 'fuid' => 0, 'date' => time(), 'dt' => 0, 'dte' => $days, 'deposit' => $amount_check, 'percent' => $percent, 'cash_now' => 0, 'cash_out' => 0, 'cash_all' => 0, 'type' => 1, 'status' => 1, 'newsystem' => 1));			
						$pid_id = Yii::app()->db->getLastInsertID();
						
						
						//Вставляем привязку из архива
						$amount_archive = $amount_check;
						$connection->createCommand()->insert('{{users_potential_archive}}', array(
							'uid' => $voucher_code["uid_activate"], 
							'pid' => $pid_id, 
							'gid' => 0,
							'date' => time(), 
							'amount' => $amount_archive, 
							'status' => 0
						));
					
					
					$message = "Ваш потенциал пополнен на $amount_check BP и сумма Привязанных EC увеличена на $amount_check BP.";
					
					} //100 в потенциал
					
					
					if($type_in == 2) {
						
						$amount_check = doubleval($voucher_code["amount"] / 2);
					
						//*********************************
						//Добавляем сумму в активный бонус
						//*********************************
						
						//Вставляем странзакцию и обновляем кошельки
						
						//Вставляем транзакцию мне
						$connection->createCommand()->insert('{{utransactions2}}', array('did' => 0, 'uid' => $from_uid, 'ruid' => $voucher_code["uid_activate"], 'amount' => $amount_check, 'amount_now' => $wallet_from["cash_now"] - $amount_check, 'date' => time(), 'type' => 0, 'status' => 1, 'invoice' => 0, 'action' => 13));
						$utransactions1 = $connection->getLastInsertID();
	
						//Вставляем транзакцию адрессату
						$connection->createCommand()->insert('{{utransactions2}}', array('did' => 0, 'uid' => $voucher_code["uid_activate"], 'ruid' =>$from_uid, 'amount' => $amount_check, 'amount_now' => $wallet_to["cash_now"] + $amount_check, 'date' => time(), 'type' => 1, 'status' => 1, 'invoice' => 0, 'action' => 13));
						$utransactions2 = $connection->getLastInsertID();

	
						$connection->createCommand("UPDATE {{users_wallet}} SET cash_now = cash_now - :amount WHERE uid = :uid AND type = 1 AND status = 1; UPDATE {{users_wallet}} SET cash_now = cash_now + :amount WHERE uid = :touid AND type = 1 AND status = 1")
							->bindParam(":amount", $amount_check)
							->bindParam(":uid", $from_uid)
							->bindParam(":touid", $voucher_code["uid_activate"])
							->query();
							
						
						//*********************************
						//Добавляем сумму в потенциал
						//*********************************
						
						
						//Вставляем потенциал
						
						$percent = 0.003;
						$days = 333;
						$amount_check = $amount_check;
						
						$percent_promo = 0; //0.2 20%
						$amount_all = $amount_check + $percent_promo;
						

						$connection->createCommand()->insert('{{users_potential}}', array('uid' => $voucher_code["uid_activate"], 'cuid' => $voucher_code["uid_activate"], 'puid' => 0, 'fuid' => 0, 'date' => time(), 'dt' => 0, 'dte' => $days, 'deposit' => $amount_check, 'percent' => $percent, 'cash_now' => 0, 'cash_out' => 0, 'cash_all' => 0, 'type' => 1, 'status' => 1, 'newsystem' => 1));			
						$pid_id = Yii::app()->db->getLastInsertID();
						
						
						//Вставляем привязку из архива
						$amount_archive = $amount_check;
						$connection->createCommand()->insert('{{users_potential_archive}}', array(
							'uid' => $voucher_code["uid_activate"], 
							'pid' => $pid_id, 
							'gid' => 0,
							'date' => time(), 
							'amount' => $amount_archive, 
							'status' => 0
						));
					
					
					
					$message = "Ваш активный бонус пополнен на $amount_check BP, в Потенциал начислено $amount_check BP и сумма Привязанных EC увеличена на $amount_check BP.";
					
					} //50 на 50
					
					
					//*********************************
					//Обновляем пользователя и финальные действия
					//*********************************
					
					
					//Раздаем инвайты
					$is_invite = $connection->createCommand("SELECT * FROM {{users_invite_new}} WHERE uid = :uid AND type = 1")
						->bindParam(":uid", $voucher_code["uid_activate"])
						->queryRow();
					
					if($trans["amount"] >= 250 && empty($is_invite)) {
						
						$connection->createCommand()->insert('{{users_invite_new}}', array('uid' => $voucher_code["uid_activate"], 'amount' => 10, 'date' => time(), 'type' => 1, 'status' => 0, 'hash' => doubleval($voucher_code["uid_activate"] . "." . time()) ));

						
					}
					
					
					
					/*if($userinfo["package"] == 0) {
						
						$connection->createCommand()->insert('{{users_invite_new}}', array('uid' => $voucher_code["uid_activate"], 'amount' => 10, 'date' => time(), 'type' => 1, 'status' => 0, 'hash' => doubleval($voucher_code["uid_activate"] . "." . time()) ));

						
					}*/
					
					//Обвновляем пакет
					if($userinfo["level"] == -1 && $userinfo["package"] == 0) {
						$connection->createCommand("UPDATE {{usersinfo}} SET level = 0, package = 1 WHERE uid = :uid; UPDATE {{usersinfo}} SET count_users = count_users + 1 WHERE uid = :refx; UPDATE {{users_invite_user}} SET status = 1, package = 1 WHERE uid = :uid;")
						->bindParam(":uid", $voucher_code["uid_activate"])
						->bindParam(":refx", $userinfo["refx"])
						->query();
					}
					
					
					//Начисляем призовые. Если нет - отлаживаем их начисление;
					if(Functions::access_level(1, $voucher_code["uid_activate"])) {
						Money2::update_money_x($amount_check, $voucher_code["uid_activate"], 2); //type 1 = pkg
					} else {
						
						//Откладываем начисление до дольнейших разбирательств в чем проблема
						$connection->createCommand()->insert('{{usersdeposit_rx2_cancel}}', array('uid' => $voucher_code["uid_activate"], 'amount' => $amount_check, 'date' =>  time(), 'type' => 1, 'status' => 0));
						
					}

  

                    $transaction->commit();
                    $res["status"] = 200;
                    $res["message"] = $message;
                } catch (Exception $e) {
                    $transaction->rollback();
                    $res["status"] = 500;
                    $res["message"] = "Сервер временно недоступен. Обновите страницу и повторите попытку снова.";
                }
            } else {
                $res["status"] = 500;
                $res["message"] = "Возникла ошибка при активации ваучера." . $err;
            }

            echo CJSON::encode($res);
            Yii::app()->end();
        }
    }
	
	
	
	
	


	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if ($error = Yii::app()->errorHandler->error) {
			if (Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}
}