<?php

/**
 * The followings are the available columns in table 'users':
 * @property integer uid
 * @property string $pass
 * @property string $mail
 */
class User extends CActiveRecord
{
	const STATUS_ACTIVE = 1;
	const STATUS_BLOCKED = 0;


	/**
	 * Returns the static model of the specified AR class.
	 * @return CActiveRecord the static model class
	 */
	public static function model($className = __CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return "{{users}}";
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.CConsoleApplication
		return array(
			array('pass', 'length', 'max' => 128, 'min' => 4,
				'message' => t("Incorrect password (minimal length 4 symbols).")),
			array('mail', 'email'),
			array('mail, pass', 'required'),
			array('uid, pass, mail', 'safe', 'on' => 'search'),

		);
	}


	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		return array();
	}

	public function scopes()
	{
		return array(
			'notsafe' => array(
				'select' => 'uid, pass, mail',
			),
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria = new CDbCriteria;

		$criteria->compare('uid', $this->uid);
		$criteria->compare('pass', $this->pass);
		$criteria->compare('mail', $this->mail, true);
	}

}