<?php

/**
 * The followings are the available columns in table 'users':
 * @property integer $id
 * @property integer $uid
 * @property integer $ref
 * @property integer $refx
 * @property string $name
 * @property string $fio
 * @property string $country
 * @property string $region
 * @property string $city
 * @property string $tel
 * @property string $email
 * @property integer $status
 * @property string $code
 * @property integer $user_dep
 * @property integer $user_count
 * @property double $money_my
 * @property double $money_structure
 * @property double $money_topay
 * @property integer $navyvod
 * @property integer $navvod
 * @property integer $state
 */
class UsersInfo extends CActiveRecord
{
	/**
	 * Returns the static model of the specified AR class.
	 * @return CActiveRecord the static model class
	 */
	public static function model($className = __CLASS__)
	{
		return parent::model($className);
	}

	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return "{{usersinfo}}";
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.CConsoleApplication
		return array(
			// todo implement user input filters

			array('status', 'default', 'value' => -1, 'setOnEmpty' => true, 'on' => 'insert'),
//			array('code, user_count, money_my, money_structure,'.
//				  'money_topay, navyvod', 'default', 'value' => 0, 'setOnEmpty' => true, 'on' => 'insert'),
			array('uid, ref, refx, name, fio, country, region, city, tel,' .
				'email, status, code, user_count, money_my, money_structure,'.
				'money_topay, navyvod, navvod, state', 'safe', 'on' => 'search'),

		);
	}


	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		return array();
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'id' => t("id"),
			'uid' => t("uid"),
			'ref' => t("ref"),
			'refx' => t("refx"),
			'name' => t("name"),
			'fio' => t("fio"),
			'country' => t("country"),
			'region' => t("region"),
			'city' => t("city"),
			'tel' => t("tel"),
			'email' => t("email"),
			'status' => t("status"),
			'code' => t("code"),
			'user_count' => t("user_count"),
			'money_my' => t("money_my"),
			'money_structure' => t("money_structure"),
			'money_topay' => t("money_topay"),
			'navyvod' => t("navyvod"),
			'navvod' => t("navvod"),
			'state' => t("state"),
		);
	}


	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 * @return CActiveDataProvider the data provider that can return the models based on the search/filter conditions.
	 */
	public function search()
	{
		// Warning: Please modify the following code to remove attributes that
		// should not be searched.

		$criteria = new CDbCriteria;

		$criteria->compare('id', $this->id);
		$criteria->compare('uid', $this->uid);
		$criteria->compare('ref', $this->ref);
		$criteria->compare('refx', $this->refx);
		$criteria->compare('name', $this->name);
		$criteria->compare('fio', $this->fio);
		$criteria->compare('country', $this->country);
		$criteria->compare('region', $this->region);
		$criteria->compare('city', $this->city);
		$criteria->compare('tel', $this->tel);
		$criteria->compare('email', $this->email);
		$criteria->compare('status', $this->status);
		$criteria->compare('code', $this->code);
		$criteria->compare('user_dep', $this->user_dep);
		$criteria->compare('user_count', $this->user_count);
		$criteria->compare('money_my', $this->money_my);
		$criteria->compare('money_structure', $this->money_structure);
		$criteria->compare('money_topay', $this->money_topay);
		$criteria->compare('navyvod', $this->navyvod);
		$criteria->compare('navvod', $this->navvod);
		$criteria->compare('state', $this->state);
	}

	public static function addUsersInfo($userModel, $ref, $refx)
	{
		$user_info = new UsersInfo();

		$user_info->uid = $userModel->uid;
		$user_info->email = $userModel->mail;
		$user_info->tel = $userModel->name;
		$user_info->status = -1;
		$user_info->ref = $ref;
		$user_info->refx = $refx;
		$user_info->name = '';
		$user_info->fio = '';
		$user_info->country = 2;
		$user_info->region = -1;
		$user_info->city = -1;
		$user_info->code = UserModule::genRef(5);
		$user_info->user_dep = 0;
		$user_info->user_count = 0;
		$user_info->money_my = 0;
		$user_info->money_structure = 0;
		$user_info->money_topay = 0;
		$user_info->navyvod = 0;
		$user_info->navvod = 0;
		$user_info->state = 1;

		return $user_info->save() ? $user_info : false;
	}

}