<?php
$connection = Yii::app()->db;
?>

	<h4>Список жалоб на продавцов</h4>

	<table class="table table-hover table-template usersblocktable">
		<thead>
		<tr>
			<th>#</th>
			<th>Дата</th>
			<th width="100px">Кто жалуется</th>
			<th>Товар</th>
            <th>Комментарий</th>
			<th>Навигация</th>
		</tr>
		</thead>
		<tbody></tbody>
	</table>

<script type="application/javascript">

	function getBlockedUsers() {

		$(".usersblocktable tbody").fadeOut(300);

		$.ajax({
			type: 'POST',
			url: '/control/getgoodclaim',
			dataType: 'json',
			success: function (results) {
				var txt = '';

				if (results.status == 200) {
					if (results.claim.length > 0) {
						$.each(results.claim, function (key, val) {
                            txt += '<tr>';
                            txt += '<td>'+val.id+'</td>';
                            txt += '<td>' + val.date + '</a></td>';
                            txt += '<td><a href="/'+val.alias+'" target="_blank">' + val.fio + '</td>';
                            txt += '<td><a href="/market/'+val.gid+'" target="_blank">' + val.title + '</td>';
                            
                            txt += '<td>' + val.comment + '</td>';
                            txt += '<td><a class="user-claim-ok" data-id="'+val.id+'" style="cursor: pointer;" data-ajax="1">Вопрос решен</a></td>';
                            txt += '</tr>';
						});
					} else {
						txt = '<tr><td colspan="6">Нет записей.</td></tr>';
					}

					$(".usersblocktable tbody").html(txt);
				}
			}
		});

		$(".usersblocktable tbody").fadeIn(500);
	}

$('document').ready(function () {
	getBlockedUsers();

    $('body').on('change keyup input click', '.userblock_days', function () {
        if (this.value.match(/[^0-9.]/g)) {
            this.value = this.value.replace(/[^0-9.]/g, '');
        }
        if(this.value > 180){
            this.value = 180;
        }
    });
	
	$('body').on('click', '.user-claim-ok', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
		
		var id = $(this).attr('data-id');

		BootstrapDialog.show({
			title: 'Решение вопроса',
			message: 'Вы уверены, что данный вопрос решен?',
			animate: true,
			buttons: [
				{
					label: 'Подтвердить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						dialogRef.close();
						
						$.ajax({
							url: '/control/setgoodclaimok',
							type: 'POST',
							dataType: 'json',
							data: {
								id: id
							},
							success: function (results) {
								if (results.status == 200) {
									$(elem).parent().parent().remove();
									message_info(results.message);
									
								} else {
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}]
		});
	});

	$('body').on('click', '.user-block-add', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
        var err = '';
		
		var alias = $(".userblock_alias").val();
		var days = $(".userblock_days").val();
        var comment = $(".userblock_comment").val();

        if(alias == ''){
            err += 'Укажите адрес страницы.';
        }
        if(days > 180){
            err += 'Максимальный термин блокировки 180 дней.';
        }
        if(comment == ''){
            err += 'Укажите комментарий.';
        }
        if(comment.length > 200){
            err += 'Длина комментария не должна превышать 200 символов.';
        }

        if(err == ''){
            BootstrapDialog.show({
                message: 'Заблокировать пользователя ' +alias,
                animate: true,
                buttons: [
                    {
                        label: 'Заблокировать',
                        cssClass: 'btn-success',
                        action: function (dialogRef) {
                            dialogRef.close();

                            $.ajax({
                                url: '/control/setuserblockok',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    alias: alias,
                                    days: days,
                                    comment: comment
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        getBlockedUsers();
                                        message_info(results.message);
                                    } else {
                                        dialogRef.close();
                                        message_info(results.message);
                                    }
                                },
                                complete: function() {
                                    $(elem).attr("data-ajax",1);
                                }
                            });
                        }
                    },
                    {
                        label: 'Закрыть',
                        action: function (dialogItself) {
                            $(elem).attr("data-ajax",1);
                            dialogItself.close();
                        }
                    }]
            });
        }else {
            message_info(err);
        }
	});
});

</script>