<?php
$connection = Yii::app()->db;

$page = 1;
?>

<style type="text/css">
	.settings_in .settings_header {
		background: #fff;
	}
	.settings_in {
		background: #f1f1f1;
	}

</style>
<div class="load-container" style="max-width: 750px;">
	<div class="wall-posts"></div>
</div>

<script type="application/javascript">

	var processing = false;
	var page = <?= $page; ?>;

	$('document').ready(function () {

		$(document).scroll(_.debounce(function () {
			feedFilter(page);
			loadComments(<?=Yii::app()->user->id?>);
		}, 300));

		$('body').on('click', '.post-delete', function () {
			event.preventDefault();
			var elem = $(this);
			var id = $(this).attr('data-id');

			BootstrapDialog.show({
				title: 'Сообщение',
				message: 'Удалить данную публикацию?',
				animate: false,
				buttons: [
					{
						label: 'Подтвердить',
						cssClass: 'btn-success',
						action: function (dialogItself) {
							$.ajax({
								url: '/control/postdelete',
								type: 'POST',
								dataType: 'json',
								data: {
									id: id
								},
								success: function (results) {
									if (results.status == 200) {
										elem.closest('.push-down-30').remove();
									} else {
										error(results.message);
									}
								}
							});
							dialogItself.close();
						}
					},
					{
						label: 'Отмена',
						action: function (dialogItself) {
							dialogItself.close();
						}
					}]
			});
			return false;
		});

		feedFilter(1, true);
	});

	function feedFilter(p, forseLoad) {
		if (processing && !forseLoad) return false;

		if (($(window).scrollTop() >= $(document).height() - $(window).height() - 700) || forseLoad) {
			processing = true;

			if(forseLoad) $('.wall-posts').empty();
			$.ajax({
				url: '/control/postfilter',
				type: 'POST',
				dataType: 'json',
				data: {
					page: p
				},
				success: function (results) {
					if (results.status == 200) {
						processing = results.posts.length == 0;

						for (var i = 0; i < results.posts.length; i++) {
							var html =	'<div class="boxed push-down-30" data-load='+(results.posts[i].comment == 0 ? 1 : 0)+' data-post-id="'+results.posts[i].id+'">';
							html += generatePost(results.posts[i], false);
							html += '</div>';
							$('.wall-posts').append(html);
							$("div[data-post-id='"+results.posts[i].id+"']").find('.post_content p').linkify().readmore({
								speed: 75,
								collapsedHeight:180,
								moreLink: '<a class="data-readmore-toggle">Читать далее..</a>',
								lessLink: '<a class="data-readmore-toggle">Скрыть</a>',
								embedCSS: false
							});
						}
						loadComments(<?=Yii::app()->user->id?>);
					} else {
						processing = true;
					}
				}
			});
			page = p + 1;
		}
	}

	function generatePost(post, isModal) {
		var post_type = '';
		if(post.type == 2){
			post_type = 'Хочу';
		}else{
			if(post.type == 3){
				post_type = 'Предлагаю';
			}
		}

		var html = '';
		html +=
			'<section class="post">' +
			'<div class="post_header">';

		if(post.repost != 0){
			html += '<a href="/'+post.repost_alias+'" class="post_header_avatar"><img src="//'+post.repost_photo+'_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';" alt="'+post.repost_fio+'"></a><h3><a href="/'+post.repost_alias+'">'+he.decode(post.repost_fio)+'</a> | <a href="/'+post.alias+'">'+he.decode(post.fio)+'</a></h3>';
		}else{
			html +=	'<a href="/'+post.alias+'" class="post_header_avatar"><img src="//'+post.photo+'_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';" alt="'+post.fio+'"></a><h3><a href="/'+post.alias+'">'+he.decode(post.fio)+'</a></h3>';
		}

		html +=
			'<div class="time"><span>'+full_date(post.date)+'</span>· <img src="/images/globe.png" alt="globe"><span> '+post.category_name+'</span></div>' +

				// post type
			'<a href="#" class="post_tag">жалоб: '+post.dislike_count+'</a>';

		//contrlos
		if(isModal != true){
			html +=
				'<div class="post_controls">' +
				'<span class="post_controls_btn"><img src="/images/toggle_down.png" alt="smile"></span>' +
				'<div class="post_dropdown_menu" id="post_controls_'+post.id+'">' +
				'<ul class="list-unstyled">';


			html +=
				'<li class="hide_post post-delete" data-id="'+post.id+'">' +
				'<p>Удалить</p>' +
				'<span></span>' +
				'</li>';


			html +=
				'</ul>' +
				'</div>' +
				'</div>';

		}
		//end controls
		html +=

			'</div>' +

			'<div class="post_content">' +
			'<p>'+$.emotions(f_replace(he.decode(post.text)))+'</p>';
		if (post.media_vid != '') {
			var media_vid = (post.media_vid).split('&');
			$.each(media_vid, function( index, value ) {
				html+= '<div class="media-cover" data-id="'+value+'" style="position: relative; left: 0; top: 0;"><img src="//img.youtube.com/vi/'+value+'/sddefault.jpg" style="position: relative;"/><img src="/images/youtube-play.png" style="position: absolute;"/></div>';
			});
		}

		if (post.media_img != '') {
			var media_img = (post.media_img).split('&');
			$.each(media_img, function( index, value ) {
				html += '<a class="post_content_image"><img src="//'+value+'_md.jpg" alt="http://'+value+'_md.jpg"></a>';
			});
		}

		html +=
			'</div>' +

			'<div class="post_footer">' +
			'<ul class="list-unstyled list-inline">' +
			'<li>' +
			'<a href="#" class="post-like" data-load="1" data-id="'+post.id+'">Нравится</a>' +
			'</li>' +
			'<li>' +
			'<a href="#" class="make-comment">Комментировать</a>' +
			'</li>' +
			'<li>' +
			'<a href="#" class="re-post" data-reposted="0" data-id="' + post.id + '">Поделиться</a>' +
			'</li>' +
			'</ul>' +
			'</div>' +

			'<div class="post_likes">' +
			'<p><span>'+post.like_count+'</span> это нравится</p>' +
			'<p><span>0</span>  комментариев</p>' +
			'<p><span>'+post.repost_count+'</span> репостов</p>' +
			'</div>' +

			'<div class="comment_block comment-posted-block-'+post.id+'" style="display:none;">' +
			'</div>' +

			'<div class="comment_form">' +
			'<form name="comment_form" action="" method="">' +
			'<a href="/<?=$owner['alias']?>" class="comment_form_avatar"><img src="//<?=$my['photo']?>_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';" alt="<?=$owner['full_name']?>"></a>' +
			'<div class="message-content text" id="reply_field_'+post.id+'" contenteditable="true"></div>' +
			'<div class="smiles">' +
			'<span class="smiles_btn"><img src="/images/smile.png" alt="smile"></span>' +
			'</div>' +
			'<div class="">' +
			'<a href="#" class="comment_form_btn" onclick="wallSendReplay('+post.id+', <?=Yii::app()->user->id?>)">Отправить</a>' +
			'</div>' +
			'</form>' +
			'</div>' +
			'</section>';

		return html;
	}

	function generateComment(comment, uid) {
		var html = '';
		html +=
			'<div class="comment comment-posted-'+comment.id+'">' +
			'<a href="/' + comment.alias + '" class="comment_avatar">' +
			'<img src="http://' + comment.photo + '_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';" alt="' + comment.fio + '">' +
			'</a>';

		if (comment.uid == uid) {
			html +=
				'<a href="#" class="comment_close comment-delete" data-id="' + comment.id + '"">×</a>';
		}
		if(comment.uid != uid){
			html += '<a href="#" class="comment-answer answer" data-name="' + comment.fio + '" data-post-id="' + comment.pid + '" data-answer="' + comment.id + '">Ответить</a>';
		}
		html +=
			'<a href="/' + comment.alias + '">' + comment.fio + '</a>' +
			'<span class="data">' + full_date(comment.date) + '</span>' +
			'<p>' + $.emotions(he.decode(f_replace(comment.text))) + '</p>' +
			'</div>';
		return html;
	}

</script>