<?php

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/Chart.min.js', CClientScript::POS_END);


$connection = Yii::app()->db;
?>

<div class="load-container">
	<div style="width: 100%">

		<h3><span class="users-transactions-title">График 1 - входящие реферальные в неделю по лиделам</span></h3>
		<canvas id="users-transactions-week" height="70"></canvas>
		
		<h3><span class="users-transactions-title">График 2 - входящие реферальные за все время по лиделам</span></h3>
		<canvas id="users-transactions-all" height="70"></canvas>
		
		<hr>

		<h3><span class="users-topay-title">График 3 - выплаты по неделям</span></h3>
		<canvas id="users-topay-week" height="70"></canvas>
		
		<h3><span class="users-topay-title">График 4 - выплаты сумарные</span></h3>
		<canvas id="users-topay-all" height="70"></canvas>
	</div>
</div>

<script type="application/javascript">
	$('document').ready(function () {
		//drawUsersWeek();
		//drawUsersAll();
		drawTransactionsWeek();
		drawTransactionsAll();
		drawTopayWeek();
		drawTopayAll();
	});

	function drawUsersWeek(){
		var ctx = document.getElementById("users-week").getContext("2d");

		$.ajax({
			type: 'POST',
			url: '/control/getstatusersweek',
			dataType: 'json',
			success: function (results) {
				if (results.status == 200) {
					if (results.stats.length > 0) {
						var lables = [];
						var data_set = [];
						var data_set_package = [];
						var data_set_nopackage = [];

						$.each(results.stats, function (key, val) {
							lables.push(val.date_start);
							data_set.push(val.users);
						});
						
						$.each(results.stats_package, function (key, val) {
							data_set_package.push(val.users);
						});
						
						$.each(results.stats_nopackage, function (key, val) {
							data_set_nopackage.push(val.users);
						});

						var usersStatData = {
							labels : lables,
							datasets : [
								{
									label: "Все польщователи",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "rgba(220,220,220,1)",
									pointColor : "rgba(220,220,220,1)",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set
								},
								
								{
									label: "С пакетамм",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "green",
									pointColor : "green",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_package
								},
								
								{
									label: "Без пакетов",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "red",
									pointColor : "red",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_nopackage
								}
							]
						};


						window.myLine = new Chart(ctx).Line(usersStatData, {
							responsive: true
						});
					} else {
						message_info(results.message);
					}
				}
			}
		});


	}
	
	function drawUsersAll(){
		var ctx = document.getElementById("users-all").getContext("2d");

		$.ajax({
			type: 'POST',
			url: '/control/getstatusersall',
			dataType: 'json',
			success: function (results) {
				if (results.status == 200) {
					if (results.stats.length > 0) {
						var lables = [];
						var data_set = [];
						var data_set_package = [];
						var data_set_nopackage = [];

						$.each(results.stats, function (key, val) {
							lables.push(val.date_start);
							data_set.push(val.users);
						});
						
						$.each(results.stats_package, function (key, val) {
							data_set_package.push(val.users);
						});
						
						$.each(results.stats_nopackage, function (key, val) {
							data_set_nopackage.push(val.users);
						});

						var usersStatData = {
							labels : lables,
							datasets : [
								{
									label: "Все пользователи",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "rgba(220,220,220,1)",
									pointColor : "rgba(220,220,220,1)",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set
								},
								
								{
									label: "С пакетамм",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "green",
									pointColor : "green",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_package
								},
								
								{
									label: "Без пакетов",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "red",
									pointColor : "red",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_nopackage
								}
							]
						};


						window.myLine = new Chart(ctx).Line(usersStatData, {
							responsive: true
						});
					} else {
						message_info(results.message);
					}
				}
			}
		});


	}

	function drawTransactionsWeek(){
		var ctx = document.getElementById("users-transactions-week").getContext("2d");

		$.ajax({
			type: 'POST',
			url: '/control/getstatusersrefxweek',
			dataType: 'json',
			success: function (results) {
				if (results.status == 200) {
					if (results.stats.length > 0) {
						var lables = [];
						var data_set = [];
						var data_set_100008 = [];
						var data_set_100067 = [];
						var data_set_100016 = [];
						var data_set_100011 = [];
						var data_set_100213 = [];
						var data_set_100002 = [];
						var data_set_100009 = [];


						$.each(results.stats, function (key, val) {
							lables.push(val.date_start);
							data_set.push(val.transactions);
						});
						
						$.each(results.stats_100008, function (key, val) {
							data_set_100008.push(val.transactions);
						});
						
						$.each(results.stats_100067, function (key, val) {
							data_set_100067.push(val.transactions);
						});
						
						$.each(results.stats_100016, function (key, val) {
							data_set_100016.push(val.transactions);
						});
						
						$.each(results.stats_100011, function (key, val) {
							data_set_100011.push(val.transactions);
						});
						
						$.each(results.stats_100213, function (key, val) {
							data_set_100213.push(val.transactions);
						});
						
						$.each(results.stats_100002, function (key, val) {
							data_set_100002.push(val.transactions);
						});
						
						$.each(results.stats_100009, function (key, val) {
							data_set_100009.push(val.transactions);
						});

						var usersStatData = {
							labels : lables,
							datasets : [
								{
									label: "Руденко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "rgba(220,220,220,1)",
									pointColor : "rgba(220,220,220,1)",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set
								},
								
								{
									label: "Михлик",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "green",
									pointColor : "green",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100008
								},
								
								{
									label: "Куруч",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "orange",
									pointColor : "orange",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100067
								},
								
								{
									label: "Нерушаев",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "pink",
									pointColor : "pink",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100016
								},
								
								{
									label: "Андреева",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "purple",
									pointColor : "purple",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100011
								},
								
								{
									label: "Левченко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "megenta",
									pointColor : "magenta",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100213
								},
								
								{
									label: "Артур",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "yellow",
									pointColor : "yellow",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100002
								},
								
								{
									label: "Довгалюк",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "aqua",
									pointColor : "aqua",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100009
								}
							]
						};


						window.myLine = new Chart(ctx).Line(usersStatData, {
							responsive: true
						});
					} else {
						message_info(results.message);
					}
				}
			}
		});
	}
	
	function drawTransactionsAll(){
		var ctx = document.getElementById("users-transactions-all").getContext("2d");

		$.ajax({
			type: 'POST',
			url: '/control/getstatusersrefxall',
			dataType: 'json',
			success: function (results) {
				if (results.status == 200) {
					if (results.stats.length > 0) {
						var lables = [];
						var data_set = [];
						var data_set_100008 = [];
						var data_set_100067 = [];
						var data_set_100016 = [];
						var data_set_100011 = [];
						var data_set_100213 = [];
						var data_set_100002 = [];
						var data_set_100009 = [];


						$.each(results.stats, function (key, val) {
							lables.push(val.date_start);
							data_set.push(val.transactions);
						});
						
						$.each(results.stats_100008, function (key, val) {
							data_set_100008.push(val.transactions);
						});
						
						$.each(results.stats_100067, function (key, val) {
							data_set_100067.push(val.transactions);
						});
						
						$.each(results.stats_100016, function (key, val) {
							data_set_100016.push(val.transactions);
						});
						
						$.each(results.stats_100011, function (key, val) {
							data_set_100011.push(val.transactions);
						});
						
						$.each(results.stats_100213, function (key, val) {
							data_set_100213.push(val.transactions);
						});
						
						$.each(results.stats_100002, function (key, val) {
							data_set_100002.push(val.transactions);
						});
						
						$.each(results.stats_100009, function (key, val) {
							data_set_100009.push(val.transactions);
						});

						var usersStatData = {
							labels : lables,
							datasets : [
								{
									label: "Руденко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "rgba(220,220,220,1)",
									pointColor : "rgba(220,220,220,1)",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set
								},
								
								{
									label: "Михлик",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "green",
									pointColor : "green",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100008
								},
								
								{
									label: "Куруч",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "orange",
									pointColor : "orange",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100067
								},
								
								{
									label: "Нерушаев",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "pink",
									pointColor : "pink",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100016
								},
								
								{
									label: "Андреева",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "purple",
									pointColor : "purple",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100011
								},
								
								{
									label: "Левченко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "megenta",
									pointColor : "magenta",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100213
								},
								
								{
									label: "Артур",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "yellow",
									pointColor : "yellow",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100002
								},
								
								{
									label: "Довгалюк",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "aqua",
									pointColor : "aqua",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100009
								}
							]
						};

						window.myLine = new Chart(ctx).Line(usersStatData, {
							responsive: true
						});
					} else {
						message_info(results.message);
					}
				}
			}
		});
	}
	
	
	
	function drawTopayWeek(){
		var ctx = document.getElementById("users-topay-week").getContext("2d");

		$.ajax({
			type: 'POST',
			url: '/control/GetStatisticUsersTopayWeek',
			dataType: 'json',
			success: function (results) {
				if (results.status == 200) {
					if (results.stats.length > 0) {
						var lables = [];
						var data_set = [];
						var data_set_100008 = [];
						var data_set_100067 = [];
						var data_set_100016 = [];
						var data_set_100011 = [];
						var data_set_100213 = [];
						var data_set_100002 = [];
						var data_set_100009 = [];


						$.each(results.stats, function (key, val) {
							lables.push(val.date_start);
							data_set.push(val.transactions);
						});
						
						$.each(results.stats_100008, function (key, val) {
							data_set_100008.push(val.transactions);
						});
						
						$.each(results.stats_100067, function (key, val) {
							data_set_100067.push(val.transactions);
						});
						
						$.each(results.stats_100016, function (key, val) {
							data_set_100016.push(val.transactions);
						});
						
						$.each(results.stats_100011, function (key, val) {
							data_set_100011.push(val.transactions);
						});
						
						$.each(results.stats_100213, function (key, val) {
							data_set_100213.push(val.transactions);
						});
						
						$.each(results.stats_100002, function (key, val) {
							data_set_100002.push(val.transactions);
						});
						
						$.each(results.stats_100009, function (key, val) {
							data_set_100009.push(val.transactions);
						});

						var usersStatData = {
							labels : lables,
							datasets : [
								{
									label: "Руденко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "rgba(220,220,220,1)",
									pointColor : "rgba(220,220,220,1)",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set
								},
								
								{
									label: "Михлик",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "green",
									pointColor : "green",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100008
								},
								
								{
									label: "Куруч",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "orange",
									pointColor : "orange",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100067
								},
								
								{
									label: "Нерушаев",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "pink",
									pointColor : "pink",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100016
								},
								
								{
									label: "Андреева",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "purple",
									pointColor : "purple",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100011
								},
								
								{
									label: "Левченко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "megenta",
									pointColor : "magenta",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100213
								},
								
								{
									label: "Артур",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "yellow",
									pointColor : "yellow",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100002
								},
								
								{
									label: "Довгалюк",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "aqua",
									pointColor : "aqua",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100009
								}
							]
						};


						window.myLine = new Chart(ctx).Line(usersStatData, {
							responsive: true
						});
					} else {
						message_info(results.message);
					}
				}
			}
		});
	}
	
	function drawTopayAll(){
		var ctx = document.getElementById("users-topay-all").getContext("2d");

		$.ajax({
			type: 'POST',
			url: '/control/GetStatisticUsersTopayAll',
			dataType: 'json',
			success: function (results) {
				if (results.status == 200) {
					if (results.stats.length > 0) {
						var lables = [];
						var data_set = [];
						var data_set_100008 = [];
						var data_set_100067 = [];
						var data_set_100016 = [];
						var data_set_100011 = [];
						var data_set_100213 = [];
						var data_set_100002 = [];
						var data_set_100009 = [];


						$.each(results.stats, function (key, val) {
							lables.push(val.date_start);
							data_set.push(val.transactions);
						});
						
						$.each(results.stats_100008, function (key, val) {
							data_set_100008.push(val.transactions);
						});
						
						$.each(results.stats_100067, function (key, val) {
							data_set_100067.push(val.transactions);
						});
						
						$.each(results.stats_100016, function (key, val) {
							data_set_100016.push(val.transactions);
						});
						
						$.each(results.stats_100011, function (key, val) {
							data_set_100011.push(val.transactions);
						});
						
						$.each(results.stats_100213, function (key, val) {
							data_set_100213.push(val.transactions);
						});
						
						$.each(results.stats_100002, function (key, val) {
							data_set_100002.push(val.transactions);
						});
						
						$.each(results.stats_100009, function (key, val) {
							data_set_100009.push(val.transactions);
						});

						var usersStatData = {
							labels : lables,
							datasets : [
								{
									label: "Руденко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "rgba(220,220,220,1)",
									pointColor : "rgba(220,220,220,1)",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set
								},
								
								{
									label: "Михлик",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "green",
									pointColor : "green",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100008
								},
								
								{
									label: "Куруч",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "orange",
									pointColor : "orange",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100067
								},
								
								{
									label: "Нерушаев",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "pink",
									pointColor : "pink",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100016
								},
								
								{
									label: "Андреева",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "purple",
									pointColor : "purple",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100011
								},
								
								{
									label: "Левченко",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "megenta",
									pointColor : "magenta",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100213
								},
								
								{
									label: "Артур",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "yellow",
									pointColor : "yellow",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100002
								},
								
								{
									label: "Довгалюк",
									fillColor : "rgba(220,220,220,0.2)",
									strokeColor : "aqua",
									pointColor : "aqua",
									pointStrokeColor : "#fff",
									pointHighlightFill : "#fff",
									pointHighlightStroke : "rgba(220,220,220,1)",
									data : data_set_100009
								}
							]
						};


						window.myLine = new Chart(ctx).Line(usersStatData, {
							responsive: true
						});
					} else {
						message_info(results.message);
					}
				}
			}
		});
	}
	
	
</script>