<?php
$connection = Yii::app()->db;
?>

	<h4>Блокировка пользователя</h4>
	
	<input type="text" class="userblock_alias" placeholder="Адрес страницы">
	<input type="text" class="userblock_days" placeholder="Дней" style="width: 10%;">
    <input type="text" class="userblock_comment" placeholder="Комментарий" style="width: 40%;">
	<input type="submit" value="Заблокировать" class="user-block-add" data-ajax="1">
	
	<h4>Список заблокированых пользователей</h4>

	<table class="table table-hover table-template usersblocktable">
		<thead>
		<tr>
			<th>#</th>
			<th width="100px">ФИО</th>
			<th>Контакты</th>
            <th>Комментарий</th>
            <th>Дата</th>
			<th>Дней</th>
            <th>Осталось</th>
			<th>Навигация</th>
		</tr>
		</thead>
		<tbody></tbody>
	</table>

<script type="application/javascript">

	function getBlockedUsers() {

		$(".usersblocktable tbody").fadeOut(300);

		$.ajax({
			type: 'POST',
			url: '/control/getuserblock',
			dataType: 'json',
			success: function (results) {
				var txt = '';

				if (results.status == 200) {
					if (results.block.length > 0) {
						$.each(results.block, function (key, val) {
                            txt += '<tr>';
                            txt += '<td>'+(key+1)+'</td>';
                            txt += '<td data-uid="' + val.uid + '"><a href="/'+val.alias+'" target="_blank">' + val.name + ' ' + val.fio + '</a></td>';
                            txt += '<td>' + val.email + '</td>';
                            txt += '<td>' + val.comment + '</td>';
                            txt += '<td>' + val.date + '</td>';
                            txt += '<td>' + val.days + '</td>';
                            txt += '<td>' + val.days_end +' '+ strToNum(val.days_end, ['день', 'дня', 'дней']) + '</td>';
                            txt += '<td><a class="user-block-cancel" data-uid="'+val.uid+'" style="cursor: pointer;" data-ajax="1">Удалить</a> <a class="user-block-posts" data-uid="'+val.uid+'" style="cursor: pointer;" data-ajax="1">Очистить посты</a></td>';
                            txt += '</tr>';
						});
					} else {
						txt = '<tr><td colspan="5">Нет записей.</td></tr>';
					}

					$(".usersblocktable tbody").html(txt);
				}
			}
		});

		$(".usersblocktable tbody").fadeIn(500);
	}

$('document').ready(function () {
	getBlockedUsers();

    $('body').on('change keyup input click', '.userblock_days', function () {
        if (this.value.match(/[^0-9.]/g)) {
            this.value = this.value.replace(/[^0-9.]/g, '');
        }
        if(this.value > 180){
            this.value = 180;
        }
    });
	
	$('body').on('click', '.user-block-posts', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
		
		var uid = $(this).attr('data-uid');

		BootstrapDialog.show({
			message: 'Удалить записи пользователя?',
			animate: true,
			buttons: [
				{
					label: 'Удалить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						dialogRef.close();
						
						$.ajax({
							url: '/control/setuserblockDeletePosts',
							type: 'POST',
							dataType: 'json',
							data: {
								uid: uid
							},
							success: function (results) {
								if (results.status == 200) {
									//$(elem).parent().parent().remove();
									message_info(results.message);
									
								} else {
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}]
		});
	});
	
	$('body').on('click', '.user-block-cancel', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
		
		var uid = $(this).attr('data-uid');

		BootstrapDialog.show({
			message: 'Удалить пользователя из списка заблокированных?',
			animate: true,
			buttons: [
				{
					label: 'Удалить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						dialogRef.close();
						
						$.ajax({
							url: '/control/setuserblockcancel',
							type: 'POST',
							dataType: 'json',
							data: {
								uid: uid
							},
							success: function (results) {
								if (results.status == 200) {
									$(elem).parent().parent().remove();
									message_info(results.message);
									
								} else {
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}]
		});
	});

	$('body').on('click', '.user-block-add', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
        var err = '';
		
		var alias = $(".userblock_alias").val();
		var days = $(".userblock_days").val();
        var comment = $(".userblock_comment").val();

        if(alias == ''){
            err += 'Укажите адрес страницы.';
        }
        if(days > 180){
            err += 'Максимальный термин блокировки 180 дней.';
        }
        if(comment == ''){
            err += 'Укажите комментарий.';
        }
        if(comment.length > 200){
            err += 'Длина комментария не должна превышать 200 символов.';
        }

        if(err == ''){
            BootstrapDialog.show({
                message: 'Заблокировать пользователя ' +alias,
                animate: true,
                buttons: [
                    {
                        label: 'Заблокировать',
                        cssClass: 'btn-success',
                        action: function (dialogRef) {
                            dialogRef.close();

                            $.ajax({
                                url: '/control/setuserblockok',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    alias: alias,
                                    days: days,
                                    comment: comment
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        getBlockedUsers();
                                        message_info(results.message);
                                    } else {
                                        dialogRef.close();
                                        message_info(results.message);
                                    }
                                },
                                complete: function() {
                                    $(elem).attr("data-ajax",1);
                                }
                            });
                        }
                    },
                    {
                        label: 'Закрыть',
                        action: function (dialogItself) {
                            $(elem).attr("data-ajax",1);
                            dialogItself.close();
                        }
                    }]
            });
        }else {
            message_info(err);
        }
	});
});

</script>