<?php
$connection = Yii::app()->db;
?>

	<h4>Верифицировать продавца</h4>
	
	<input type="text" class="userverify_email" placeholder="E-mail">
	<input type="text" class="userverify_percent" placeholder="Процент">
    <input type="number" min="0" step="1" class="userverify_discount" placeholder="Скидка">
	<input type="text" class="userverify_multi number_only" placeholder="Множитель">
	
	<select class="userverify_type">
		<option value="0">Верификация без вывода V200</option>
		<option value="1">Верификация с выводом V1000</option>
	</select>
	
	<input type="submit" value="Верифицировать" class="user-verify-add" data-ajax="1">
	
	
	<h4>Список верифицированых продавцов</h4>

	<table class="table table-hover table-template paymentsolutionstable">
		<thead>
		<tr>
			<th>#</th>
			<th width="100px">ФИО</th>
			<th>Контакты</th>
			<th>Процент</th>
            <th>Скидка</th>
			<th>Множ</th>
			<th>Дней</th>
			<th>Статус</th>
			<th>Навигация</th>
		</tr>
		</thead>
		<tbody>

		</tbody>
	</table>



<script type="application/javascript">

	function getMainInforamtion() {

		$(".paymentsolutionstable tbody").fadeOut(300);

		$.ajax({
			type: 'POST',
			url: '/control/getuserverify',
			dataType: 'json',
			success: function (results) {
				var txt = '';

				if (results.status == 200) {
					if (results.verify.length > 0) {
						$.each(results.verify, function (key, val) {

							val.verify = parseInt(val.verify);
							var status = "";
							var btn = "";

							switch(val.verify) {
								case 1:
									status = val.type == 0 ? '<span class="not-activated">Верифицирован</span>' : '<span class="activated">Верифицирован</span>';;
									btn += '<a class="user-verify-cancel" rel="'+val.uid+'" style="cursor: pointer;" data-ajax="1">Удалить</a>';
									btn += ' | <a class="user-verify-edit" style="color: green;" rel="'+val.uid+'" data-percent="'+val.percent+'" data-discount="'+val.discount+'" data-multi="'+val.multi+'" data-type="'+val.type+'" style="cursor: pointer;">Ред</a>';
                                    btn += ' | <a class="user-verify-info" rel="'+val.uid+'" style="cursor: pointer;" data-ajax="1">Продажы</a>';
									break;
							}

							txt += '<tr><td> </td><td rel="' + val.uid + '"><a href="/'+val.alias+'" target="_blank">' + val.name + ' ' + val.fio + '</a></td><td>' + val.email + ' ' +  val.tel + '</td><td>' + val.percent + '%</td><td>' + val.discount + '%</td><td>' + val.multi + '%</td><td>' + val.days + ' дн.</td><td>' + status + '</td><td>' + btn + '</td></tr>';

						});
					} else {
						txt = '<tr><td colspan="6">Нет записей.</td></tr>';
					}

					$(".paymentsolutionstable tbody").html(txt);
				}
			}
		});

		$(".paymentsolutionstable tbody").fadeIn(500);
	}

$('document').ready(function () {
	getMainInforamtion();

	$('body').on('change keyup input click', '.userverify_multi, .userverify_multi_edit', function () {
		if (this.value.match(/[^0-9]/g)) {
			this.value = this.value.replace(/[^0-9]/g, '');
		}

		var value = $(this).val();
		if (value < 0) $(this).val(0);
		if (value > 100) $(this).val(100);
	});

    $('body').on('change keyup input click', '.userverify_discount', function () {
        if (this.value.match(/[^0-9.]/g)) {
            this.value = this.value.replace(/[^0-9.]/g, '');
        }
        var percent = parseInt($('.userverify_percent').val());
        percent = !isNaN(percent) ? percent : 0;
        if(this.value >= percent){
            this.value = percent;
        }
    });

    $('body').on('change keyup input click', '.userverify_discount_edit', function () {
        if (this.value.match(/[^0-9.]/g)) {
            this.value = this.value.replace(/[^0-9.]/g, '');
        }
        var percent = parseInt($('.userverify_percent_edit').val());
        percent = !isNaN(percent) ? percent : 0;
        if(this.value >= percent){
            this.value = percent;
        }
    });
	
	$('body').on('click', '.user-verify-info', function () {

		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);

		var uid = $(this).attr('rel');

		$.ajax({
			url: '/control/getuserverifyorders',
			type: 'POST',
			dataType: 'json',
			data: {
				uid: uid
			},
			success: function (results) {
				if (results.status == 200) {
					var txt = '' +
						'<table class="order-info-table user-verify-orders"><tbody>' +
						'<thead><tr><th>Название товара</th><th>Дата</th><th>Сумма</th></tr></thead>';

					if(results.orders && results.orders.length > 0){
						$.each(results.orders, function (key, val) {
							txt += '<tr><td class="verify_ordertitile">'+val.title+(val.price_title != '' ? ' ('+val.price_title+')' : '')+'</td><td>'+val.date+'</td><td>'+val.price+' USD</td></tr>';
						});
						txt += '</tbody></table>';
						message_info(txt);
					}else{
						message_info('У даного пользователя нет проданых товаров.');
					}
				} else {
					message_info(results.message);
				}
			},
			complete: function() {
				$(elem).attr("data-ajax",1);
			}
		});
	});
	
	$('body').on('click', '.user-verify-cancel', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
		
		var uid = $(this).attr('rel');

		BootstrapDialog.show({
			message: 'Удалить пользователя из списка верифицированных?',
			animate: true,
			buttons: [
				{
					label: 'Удалить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						
						dialogRef.close();
						
						$.ajax({
							url: '/control/setuserverifycancel',
							type: 'POST',
							dataType: 'json',
							data: {
								uid: uid
							},
							success: function (results) {
								if (results.status == 200) {
									
									//getMainInforamtion();
									$(elem).parent().parent().remove();
									message_info(results.message);
									
								} else {
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}]

		});
	});

	$('body').on('click', '.user-verify-add', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
		
		var email = $(".userverify_email").val();
		var percent = $(".userverify_percent").val();
        var discount = $(".userverify_discount").val();
		var multi = $(".userverify_multi").val();
		var type = $(".userverify_type").val();

		BootstrapDialog.show({
			message: 'Добавить пользователя ' +email+ ' в список верифицированных?',
			animate: true,
			buttons: [
				{
					label: 'Добавить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						
						dialogRef.close();
						
						$.ajax({
							url: '/control/setuserverifyok',
							type: 'POST',
							dataType: 'json',
							data: {
								email: email,
								percent: percent,
                                discount: discount,
								multi: multi,
								type: type
							},
							success: function (results) {
								if (results.status == 200) {
									
									getMainInforamtion();
									//$(elem).parent().parent().remove();
									message_info(results.message);
									
								} else {
									dialogRef.close();
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}]

		});
	});

    $('body').on('click', '.user-verify-edit', function () {
        event.preventDefault();

        var elem = $(this);
        var ajax = 1;
        var uid = $(this).attr('rel');
        var data_percent = $(this).attr('data-percent');
        var data_discount = $(this).attr('data-discount');
		var data_multi = $(this).attr('data-multi');
		var data_type = $(this).attr('data-type');
		
		if(data_type == 0) {
			$data_type_select0 = 'selected=""';
			$data_type_select1 = '';
		} else if (data_type == 1) {
			$data_type_select0 = '';
			$data_type_select1 = 'selected=""';
		}

        BootstrapDialog.show({
            title: 'Редактировать',
            message: '<label>Введите процент:</label><br>' +
            '<input type="text" class="userverify_percent_edit" placeholder="Процент" value="'+data_percent+'"><br>' +
            '<label>Введите скидку:</label><br>' +
            '<input type="number" min="0" step="1" class="userverify_discount_edit" placeholder="Скидка" value="'+data_discount+'"><br>' +
			'<label>Введите Множитель:</label><br>' +
			'<input type="text" class="userverify_multi_edit number_only" placeholder="Множитель" value="'+data_multi+'"><br>'+
			
			'<label>Тип верификации:</label><br>' +
			'<select class="userverify_type_edit"><option value="0" '+$data_type_select0+'>Верификация без вывода V200</option><option value="1" '+$data_type_select1+'>Верификация с выводом V1000</option></select>',
			
            animate: false,
            buttons: [
                {
                    label: 'Сохранить',
                    cssClass: 'btn-success',
                    action: function (dialogItself) {
                        if (ajax == 0) return; ajax = 0;
                        var err = '';

                        var percent = parseInt($('.userverify_percent_edit').val());
                        var discount = parseInt($('.userverify_discount_edit').val());
						var multi = parseInt($('.userverify_multi_edit').val());
						var type = parseInt($('.userverify_type_edit').val());

                        if(percent < 10 || percent > 100){
                            err += "<li>Минимальный процент 10, максимальный 100.</li>";
                        }
						if(multi < 0 || multi > 100){
							err += "<li>Минимальный множитель 0, максимальный 100.</li>";
						}
                        if(discount < 0 || discount > percent){
                            err += "<li>Минимальная скидка 0, максимальная не должна превышать процент.</li>";
                        }

                        if (err == '') {
                            $.ajax({
                                url: '/control/setuserverifyedit',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    uid: uid,
                                    percent: percent,
                                    discount: discount,
									multi: multi,
									type: type
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        dialogItself.close();
                                        message_info(results.message);
                                        $(elem).closest('tr').find('td:eq(3)').html(percent+'%');
                                        $(elem).closest('tr').find('td:eq(4)').html(discount+'%');
                                        $(elem).closest('tr').find('td:eq(5)').html(multi+'%');
                                        
                                        //Указываем тип верификации
                                        var activated_text = type == 0 ? '<span class="not-activated">Верифицирован</span>' : '<span class="activated">Верифицирован</span>';
                                        $(elem).closest('tr').find('td:eq(7)').html(activated_text);
                                        $(elem).attr('data-type', type);
                                         
                                    } else {
                                        message_info(results.message);
                                    }
                                },
                                complete: function () {
                                    ajax = 1;
                                }
                            });
                        } else {
                            message_info(err);
                            ajax = 1;
                        }
                    }
                },
                {
                    label: 'Отмена',
                    action: function (dialogItself) {
                        dialogItself.close();
                    }
                }]
        });
    });
});

</script>


<style>
	.user-verify-orders tr td {
		font-size: 12px;
	}
</style>