<?php
$connection = Yii::app()->db;
?>

	<h4>Заявки на оплату товаров через MS</h4>

	<table class="table table-hover table-template usersblocktable">
		<thead>
		<tr>
			<th>#</th>
			<th>Дата</th>
			<th width="100px">ФИО</th>
			<th>Оплата BP</th>
            <th>Оплата MS</th>
            <th>Кошелек MS</th>
			<th>Навигация</th>
		</tr>
		</thead>
		<tbody></tbody>
	</table>

<script type="application/javascript">

	function getBlockedUsers() {

		$(".usersblocktable tbody").fadeOut(300);

		$.ajax({
			type: 'POST',
			url: '/control/GetUserVerifyPays',
			dataType: 'json',
			success: function (results) {
				var txt = '';

				if (results.status == 200) {
					if (results.claim.length > 0) {
						$.each(results.claim, function (key, val) {
                            txt += '<tr>';
                            txt += '<td>'+val.id+'</td>';
                            txt += '<td>' + val.date + '</a></td>';
                            txt += '<td><a href="/'+val.alias+'" target="_blank">' + val.fio + '</td>';
                            txt += '<td>' + val.paybp + '%</td>';
                            txt += '<td>' + val.payms + '%</td>';
                            txt += '<td>' + val.payms_wallet + '</td>';
                            txt += '<td><a class="user-userverify-pays-ok" data-id="'+val.id+'" style="cursor: pointer;" data-ajax="1">Подтвердить</a> | <a class="user-userverify-pays-cancel" data-id="'+val.id+'" style="cursor: pointer;" data-ajax="1">Отклонить</a></td>';
                            txt += '</tr>';
						});
					} else {
						txt = '<tr><td colspan="7">Нет записей.</td></tr>';
					}

					$(".usersblocktable tbody").html(txt);
				}
			}
		});

		$(".usersblocktable tbody").fadeIn(500);
	}

$('document').ready(function () {
	getBlockedUsers();

    $('body').on('change keyup input click', '.userblock_days', function () {
        if (this.value.match(/[^0-9.]/g)) {
            this.value = this.value.replace(/[^0-9.]/g, '');
        }
        if(this.value > 180){
            this.value = 180;
        }
    });
	
	$('body').on('click', '.user-userverify-pays-ok', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
		
		var id = $(this).attr('data-id');

		BootstrapDialog.show({
			title: 'Подтверждение данных',
			message: 'Подтвердить просьбу пользователя на установку настроек оплаты?',
			animate: true,
			buttons: [
				{
					label: 'Подтвердить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						dialogRef.close();
						
						$.ajax({
							url: '/control/SetUserVerifyPaysOk',
							type: 'POST',
							dataType: 'json',
							data: {
								id: id
							},
							success: function (results) {
								if (results.status == 200) {
									$(elem).parent().parent().remove();
									message_info(results.message);
									
								} else {
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}]
		});
	});
	
	$('body').on('click', '.user-userverify-pays-cancel', function () {
		
		var elem = this;
		var ajax = parseInt($(elem).attr("data-ajax"));
		if(ajax == 0) return; else $(elem).attr("data-ajax",0);
		
		var id = $(this).attr('data-id');

		BootstrapDialog.show({
			title: 'Отклонение действия',
			message: 'Отклонить просьбу пользователя на установку настроек оплаты?',
			animate: true,
			buttons: [
				{
					label: 'Подтвердить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						dialogRef.close();
						
						$.ajax({
							url: '/control/SetUserVerifyPaysCancel',
							type: 'POST',
							dataType: 'json',
							data: {
								id: id
							},
							success: function (results) {
								if (results.status == 200) {
									$(elem).parent().parent().remove();
									message_info(results.message);
									
								} else {
									message_info(results.message);
								}
							},
							complete: function() {
								$(elem).attr("data-ajax",1);
							}
						});
						
					}
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						$(elem).attr("data-ajax",1);
						dialogItself.close();
					}
				}]
		});
	});
});

</script>