<?php
/* @var $my */

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl.'/js/timepicki.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/select2.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/settings.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/timepicki.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/style.css');

$alias = mysql_escape_string(htmlspecialchars(strip_tags($_GET["alias"])));
empty($alias) && $this->redirect('/events');

$connection = Yii::app()->db;
$event_info = $connection->createCommand("SELECT e.url, e.country_id, e.country_name, e.city_id, e.city_name, e.address, u.uid, u.name, u.birth, u.about, u.photo, u.alias, u.owner FROM {{usersinfo}} u INNER JOIN {{users_events}} e ON e.uid = u.uid WHERE u.alias = :alias")->bindParam(":alias", $alias)->queryRow();
(empty($event_info) || $event_info['owner'] != Yii::app()->user->id) && $this->redirect('/events');

if(!empty($event_info['country_id'])){
    $country = Loc::getCountryById($event_info['country_id']);
    $event_info['country_name'] = $country['title'];
}
if(!empty($event_info['city_id'])){
    $city = Loc::getCityById($event_info['city_id']);
    $event_info['city_name'] = $city['title'];
}

$c_year = date('Y', strtotime($event_info['birth']));
$c_month = intval(date('m', strtotime($event_info['birth'])));
$c_day = date('d', strtotime($event_info['birth']));

$months = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
$my = $connection->createCommand("SELECT u.uid, u.skype, u.tel, u.city, CONCAT(u.name, ' ', u.fio) as 'full_name', u.photo, u.alias FROM {{usersinfo}} u WHERE u.uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
?>

<?php $this->widget('SideBarWidget', array(
		'my' => $my
)); ?>

<div class="col-sm-8 create_group">
	<section  class="create_group_in">
		<div class="create_group_header">
			<div class="active">
				Редактировать событие
			</div>
		</div>
		<div class="create_group_content">
			<form>
				<div class="col-sm-6 col-sm-offset-3 col-xs-12 create_group_content_wrap">
					<div class="form-group">
						<label for="name">Название:</label>
						<input type="text" class="form-control" id="name" placeholder="" required="required" value="<?=htmlspecialchars_decode($event_info['name'])?>">
					</div>
                    <div class="form-group">
                        <label for="alias">Адрес страницы:</label>
                        <input type="text" class="form-control" id="alias" placeholder="" required="required" value="<?=$event_info['alias']?>">
                    </div>
					<div class="form-group">
						<label for="about">Описание события:</label>
						<textarea class="form-control" id="about" placeholder=""><?=Helpers::f_area_replace(htmlspecialchars_decode($event_info['about']))?></textarea>
					</div>
                    <div class="form-group">
                        <label for="country">Страна:</label>
                        <select class="form-control male js-data-ajax-country" id="country" style="display: none;">
                            <?php if(!empty($event_info['country_id'])){ ?>
                                <option value="<?=$event_info['country_id']?>" title="<?=$event_info['country_name']?>"><?=$event_info['country_name']?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="city">Город:</label>
                        <select class="form-control male js-data-ajax-city" id="city" style="display: none;">
                            <?php if(!empty($event_info['city_id'])){ ?>
                                <option value="<?=$event_info['city_id']?>" title="<?=$event_info['city_name']?>"><?=$event_info['city_name']?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="address">Адрес:</label>
                        <input type="text" class="form-control" id="address" placeholder="" required="required" value="<?=$event_info['address']?>">
                    </div>
                    <div class="form-group">
                        <label for="url">Ссылка на сайт/страницу:</label>
                        <input type="text" class="form-control" id="url" placeholder="" required="required" value="<?=$event_info['url']?>">
                    </div>
                    <div class="form-group event_date">
                        <label for="bday">Дата начала:</label>
                        <select class="birth_day day" id="c_day" style="width: 22%; background-position: 92%;"></select>
                        <select class="birth_month month" id="c_month" style="width: 39%; margin-left: 18px; background-position: 94%;"></select>
                        <select class="birth_year year" id="c_year" style="width: 27%; margin-left: 18px; background-position: 92%;"></select>
                    </div>
                    <div class="form-group" style="display: initial;">
                        <label for="timepicker">Время начала:</label>
                        <input class="form-control" id="timepicker" value="<?=date("H:i", strtotime($event_info['birth']))?>" type="text" name="timepicker" data-timepicki-tim="<?=date("H", strtotime($event_info['birth']))?>" data-timepicki-mini="<?=date("i", strtotime($event_info['birth']))?>"/>
                    </div>
				</div>

				<div class="create_group_content_footer">
					<a href="#" class="create_group_btn event-edit-btn">Сохранить</a>
				</div>

			</form>
		</div>
	</section>
</div>

<script type="application/javascript">
    $('document').ready(function () {

        $(".js-data-ajax-city").select2({
            ajax: {
                url: "/ajax/cities",
                type: 'POST',
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        q: params.term,
                        id: $('#country').val()
                    };
                },
                processResults: function (data, params) {
                    params.page = params.page || 1;
                    return {
                        results: data.cities,
                        pagination: {
                            more: (params.page * 30) < data.total_count
                        }
                    };
                },
                cache: true
            },
            escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
            minimumInputLength: 2,
            templateResult: formatRepo, // omitted for brevity, see the source of this page
            templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
        });

        $('#timepicker').timepicki(
            {
                show_meridian:false,
                min_hour_value:0,
                max_hour_value:23,
                step_size_minutes:1,
                overflow_minutes:true,
                increase_direction:'up',
                disable_keyboard_mobile: true,
                start_time: ["<?=date("H", strtotime($event_info['birth']))?>", "<?=date("i", strtotime($event_info['birth']))?>"],
                custom_classes: "event_time"
            });

        $('body').on('click', '.tab', function () {
            var page = $(this).attr('rel');
            $('.tab').removeClass('active');
            $(this).addClass('active');

            $('.tab-block').hide();
            $('.'+page).show();
        });

        $('body').on('click', '.event-edit-btn', function (event) {
            event.preventDefault();
            var err = '';

            var name = $('#name').val();
            var alias = $('#alias').val();
            var url = $('#url').val();
            var about = $('#about').val();
            var c_day = $('#c_day').val();
            var c_month = $('#c_month').val();
            var c_year = $('#c_year').val();
            var time = $('#timepicker').attr('data-timepicki-tim')+':'+$('#timepicker').attr('data-timepicki-mini');
            var address = $("#address").val();
            var country = $('#country').val();
            var city = $('#city').val();

            var dt  = c_year+'-'+c_month+'-'+c_day+' '+time;
            var dtt = moment(dt, "YYYY-MM-DD HH:mm");

            var url_regex = /^((http|https)?:\/\/)?[a-zA-Z0-9-\.]+\.[a-z]{2,}/;
            if(url != '' && !url_regex.test(url)){
                err += '<li>Укажите ссылку на страницу.</li>';
            }
            if(!dtt.isValid()){
                err += '<li>Дата начала указано неверно.</li>';
            }
            if(name == ''){
                err += '<li>Укажите название.</li>';
            }
            if(about == ''){
                err += '<li>Укажите описание.</li>';
            }
            if(country == null){
                err += '<li>Укажите страну.</li>';
            }

            if(err == ''){
                $.ajax({
                    url: '/events/eventedit',
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        name: name,
                        alias: alias,
                        url: url,
                        about: about,
                        c_day: c_day,
                        c_month: c_month,
                        c_year: c_year,
                        address: address,
                        date: dt,
                        event: <?=$event_info['uid']?>,
                        country: country,
                        city: city
                    },
                    success: function (results) {
                        if (results.status == 200) {
                            window.location.replace("/"+alias);
                        }else{
                            message_info(results.message);
                        }
                    }
                });
            }else{
                message_info(err);
            }
        });

        $(function() {

            //populate our years select box
            for (var i = new Date().getFullYear(); i > 1900; i--){
                $('#c_year').append($('<option />').val(i).html(i));
            }
            $('#c_year').val(<?= $c_year ?>);

            //populate our months select box
            var months = ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"];
            for (i = 0; i < 12; i++){
                $('#c_month').append($('<option />').val(i+1).html(months[i]));
            }
            $('#c_month').val(<?= $c_month ?>);

            //populate our Days select box
            updateNumberOfDays();
            $('#c_day').val(<?= $c_day ?>);

            //"listen" for change events
            $('#c_year, #c_month').change(function(){
                updateNumberOfDays();
            });

        });
    });

    function updateNumberOfDays(){
        var selected = $('#c_day').val();
        selected = selected != null ? selected : 1;
        $('#c_day').html('');
        var month = $('#c_month').val();
        var year = $('#c_year').val();
        var days = f_daysInMonth(month, year);

        for(var i=1; i < days+1 ; i++){
            $('#c_day').append($('<option />').val(i).html(i));
        }
        $('#c_day').val(selected <= days ? selected : 1);
    }

</script>