<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');
Yii::app()->clientScript->registerCssFile('//code.jquery.com/ui/1.11.4/themes/smoothness/jquery-ui.css');

$connection = Yii::app()->db;
$countries = $connection->createCommand("SELECT DISTINCT country_id, country_name FROM {{users_events}} WHERE country_id > 0")->queryAll();
?>

<div class="col-sm-4">
	<section class="group_search">
		<div class="group_aside_header">
			Поиск событий
		</div>
		<div class="group_search_content">
			<form>
				<div>
					<div class="form-group">
						<label for="search_query">Название:</label>
						<input type="text" class="form-control" id="search_query" placeholder=" ">
					</div>
                    <div class="form-group">
                        <label for="country">Страна:</label>
                        <select class="form-control male" id="country" style="padding: 3px 12px;">
                            <option value="-1" selected="selected">Выбор страны</option>
                            <?php foreach ($countries as $country) { ?>
                                <option
                                    value="<?= $country['country_id'] ?>"><?= $country['country_name'] ?></option>
                            <?php } ?>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="city">Город:</label>
                        <select class="form-control male" id="city" style="padding: 3px 12px;">
                            <option value="-1" selected="selected">Город</option>
                        </select>
                    </div>
                    <div class="form-group">
                        <label for="datepicker">Дата начала:</label>
                        <input class="form-control" type="text" id="datepicker">
                    </div>
				</div>
				<div class="group_search_content_footer">
					<a href="/events/new" class="group_search_btn">Создать событие</a>
				</div>
			</form>
		</div>
	</section>
</div>
<div class="col-sm-8 group">
	<section class="group_in">
		<div class="group_header">
			<a href="/events" class="tab">События</a>
            <a href="/events/my" class="tab">Мои подписанные события</a>
            <a href="/events/settings" class="tab active">Управление</a>
		</div>
		<div class="group_content" id="search-result">			
		</div>
	</section>
</div>

<script type="application/javascript">
var processing = false;
var page = 1;
var req = null;
var timer = null;

$(document).ready(function () {
    eventSearch(true);

    $( "#datepicker" ).datepicker({dateFormat: "yy-mm-dd"});

    $(document).scroll(function () {
        eventSearch(false);
    });

    $('#type').change(function () {
        page = 1;
        eventSearch(true);
    });

    $("#events_old").change(function() {
        page = 1;
        eventSearch(true);
    });

    $('#city').change(function () {
        page = 1;
        eventSearch(true);
    });

    $('body').on('change', '#datepicker', function () {
        page = 1;
        eventSearch(true);
    });

    $('#country').change(function () {
        page = 1;
        var country = $(this);

        if(country.val() == -1){
            $('#city').val(-1);
        }

        $.when(eventSearch(true)).done(function () {
            if (country.val() && country.val() > 0) {
                $('#city').empty();

                $.ajax({
                    url: '/events/cities',
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        id: country.val()
                    },
                    success: function (results) {
                        if (results.status == 200 && results.cities) {
                            var text = '';
                            text += '<option value="-1">Выбор города</option>';
                            $.each(results.cities, function (key, city) {
                                text += '<option value="' + city.city_id + '">' + city.city_name + '</option>';
                            });
                            $('#city').append(text);
                        }
                    }
                });

                $('.city-block').show(200);
            } else {
                $('.city-block').hide(200);
            }

        });
    });

    $('body').on('click', '.subscribe[data-ajax="1"]', function (event) {
        event.preventDefault();

        var obj = $(this);
        obj.attr('data-ajax', "0");

        $.ajax({
            url: '/ajax/subscribe',
            type: 'POST',
            dataType: 'json',
            data: {
                uid: $(obj).data("id")
            },
            success: function (results) {
                if (results.status == 200) {
                    $(obj).html('Отписаться').toggleClass('subscribe unsubscribe');
                }
            },
            complete: function(){
                $(obj).attr('data-ajax', "1");
            }
        });
    });

    $('body').on('click', '.unsubscribe[data-ajax="1"]', function (event) {
        event.preventDefault();

        var obj = $(this);
        obj.attr('data-ajax', "0");

        $.ajax({
            url: '/ajax/unsubscribe',
            type: 'POST',
            dataType: 'json',
            data: {
                uid: $(obj).data("id")
            },
            success: function (results) {
                if (results.status == 200) {
                    $(obj).html('Подписаться').toggleClass('unsubscribe subscribe');
                }
            },
            complete: function(){
                $(obj).attr('data-ajax', "1");
            }
        });
    });

    $('#search_query').keyup(function () {
        if ($(this).val().length >= 3 || $(this).val().length == 0) {
            if (timer) {
                clearTimeout(timer); //cancel the previous timer.
                timer = null;
            }
            timer = setTimeout(
                function () {
                    page = 1;
                    eventSearch(true);
                }, 500);

        }
    });

    function eventSearch(filter) {
        if (processing && !filter)
            return false;

        if (($(window).scrollTop() >= $(document).height() - $(window).height() - 700) || filter) {
            processing = true;
            page = filter ? 1 : page + 1;

            var data = {};
            var country = $('#country').val();
            var city = $('#city').val();
            var search_query = $('#search_query').val();
            var date = $("#datepicker").datepicker({ dateFormat: 'yy-mm-dd' }).val();
            date = new Date(date).isValid() ? date : null;

            search_query.length > 2 && (data['search_query'] = search_query);
            data['act'] = 2;
            data['page'] = page;
            data['date'] = date;
            country > 0 && (data['country'] = country);
            city > 0 && (data['city'] = city);

            if (req != null) req.abort();
            req = $.ajax({
                url: '/events/esearch',
                type: 'POST',
                dataType: 'json',
                data: data,
                success: function (results) {
                    if ((results.status == 200 && results.events) || filter) {
                        $('#search-results-total').html(results.total);
                        processing = false;
                        var html = '';

                        if (results.events) {
                            $.each(results.events, function (key, val) {
                                var friend = val.friend == 1 ? "Отписаться" : "Подписка";
                                html +=
                                    '<div class="group_block">' +
                                    '<a href="/' + val.alias + '" class="group_block_avatar">' +
                                    '<img src="http://' + val.photo + '_sm.jpg" onError="this.src=\'/images/no_thumb.png\';" alt="' + val.fio + '">' +
                                    '</a>' +
                                    '<h3>' +
                                    '<a href="/' + val.alias + '">' + he.decode(val.name + val.fio) + '</a>' +
                                    '</h3>' +
                                    '<p class="summary" style="max-width: 485px; text-overflow: ellipsis; white-space: nowrap; height: 14px;">' + he.decode(f_replace(val.about)) + '</p>' +
                                    '<div class="followers"></div>' +
                                    '<a href="#" class="group_block_btn ' + (val.friend == 1 ? 'unsubscribe' : 'subscribe') + '" data-id="' + val.uid + '" data-ajax="1">' + friend + '</a>' +
                                    '</div>';
                            });


                        }
                        if(page == 1){
                            $('#search-result').empty();
                        }
                        $('#search-result').append(html);
                    } else {
                        processing = true;
                    }
                },
                complete: function () {
                    req = null;
                }
            });
        }
    }
});

Date.prototype.isValid = function () {
    return this.getTime() === this.getTime();
};

</script>