<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');

$alias = mysql_escape_string(htmlspecialchars(strip_tags($_GET["alias"])));
empty($alias) && $this->redirect('/groups');

$connection = Yii::app()->db;
$group_info = $connection->createCommand("SELECT uid, name, birth, about, photo, alias, owner, settings_comments FROM {{usersinfo}} WHERE alias = :alias")->bindParam(":alias", $alias)->queryRow();
(empty($group_info) || $group_info['owner'] != Yii::app()->user->id) && $this->redirect('/groups');
$c_year = date('Y', strtotime($group_info['birth']));
$c_month = intval(date('m', strtotime($group_info['birth'])));
$c_day = date('d', strtotime($group_info['birth']));

$months = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
$my     = $connection->createCommand("SELECT u.uid, CONCAT(u.name, ' ', u.fio) as 'fio', u.photo, u.alias FROM {{usersinfo}} u WHERE u.uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
$my['status'] = 'владелец канала';

?>

<?php $this->widget('SideBarWidget', array(
		'my' => $my
)); ?>

<div class="col-sm-8 create_group">
	<section  class="create_group_in">
		<div class="create_group_header">
			<a href="/groups/edit/<?=$my["alias"]?>"><div class="active">Основные настройки</div></a>
			<a href="/groups/blacklist/<?=$my["alias"]?>"><div>Контакты</div></a>
		</div>
		<div class="create_group_content" style="display: block;">
			<form name="" action="" method="">
				<div class="col-sm-6 col-sm-offset-3 col-xs-12 create_group_content_wrap">
					<div class="form-group">
						<label for="name">Название:</label>
						<input type="text" class="form-control" id="name" value="<?=$group_info['name']?>" placeholder="" required="required">
					</div>

					<div class="form-group">
						<label for="about">Описание:</label>
						<textarea class="form-control" id="about" placeholder=""><?=$group_info['about']?></textarea>
					</div>

					<div class="form-group">
						<label for="alias">Адрес страницы:</label>
						<input type="text" class="form-control" id="alias" value="<?=$group_info['alias']?>" placeholder="">
					</div>


					<div class="form-group">
						<label for="c_day">Дата основания:</label>
						<select class="cr_day day" id="c_day"></select>
						<select class="cr_month month" id="c_month"></select>
						<select class="cr_year year" id="c_year"></select>
					</div>

					<div class="create_group_content_checkbox">
						<input type="checkbox" id="comments_off" placeholder=" " name=" " class="checkbox comments_off" value="1" <?=$group_info['settings_comments'] == 1 ? 'checked="checked"' : ''?>>
						<label for="comments_off">
							Комментарии включены
						</label>
					</div>

					<div class="create_group_content_checkbox">
						<input type="checkbox" value=" " id="checkbox1" name=" " class="checkbox" checked>
						<label for="checkbox1">
							Закрытая группа
						</label>
					</div>

				</div>

				<div class="create_group_content_footer">
					<a href="#" class="create_group_btn group-edit-btn">Сохранить</a>
				</div>

			</form>
		</div>
	</section>
</div>

<script type="application/javascript">
	$('document').ready(function () {
		$('body').on('click', '.tab', function () {
			var page = $(this).attr('rel');
			$('.tab').removeClass('active');
			$(this).addClass('active');

			$('.tab-block').hide();
			$('.'+page).show();
		});

		$('body').on('click', '.group-edit-btn', function () {
			event.preventDefault();

			var name = $('#name').val();
			var alias = $('#alias').val();
			var about = $('#about').val();
			var c_day = $('#c_day').val();
			var c_month = $('#c_month').val();
			var c_year = $('#c_year').val();
			var settings_comments = $("#comments_off").is(':checked') ? 1 : 0;

			$.ajax({
				url: '/groups/groupedit',
				type: 'POST',
				dataType: 'json',
				data: {
					name: name,
					alias: alias,
					about: about,
					c_day: c_day,
					c_month: c_month,
					c_year: c_year,
					settings_comments: settings_comments,
					group: <?=$group_info['uid']?>
				},
				success: function (results) {
					if (results.status == 200) {
						window.location.replace("/"+alias);
					}else{
						message_info(results.message);
					}
				}
			});

		});

		$(function() {

			//populate our years select box
			for (var i = new Date().getFullYear(); i > 1900; i--){
				$('#c_year').append($('<option />').val(i).html(i));
			}
			$('#c_year').val(<?=$c_year?>);

			//populate our months select box
			var months = ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"];
			for (i = 0; i < 12; i++){
				$('#c_month').append($('<option />').val(i+1).html(months[i]));
			}
			$('#c_month').val(<?=$c_month?>);

			//populate our Days select box
			updateNumberOfDays();
			$('#c_day').val(<?=$c_day?>);

			//"listen" for change events
			$('#c_year, #c_month').change(function(){
				updateNumberOfDays();
			});

		});
	});

	function updateNumberOfDays(){
		var selected = $('#c_day').val();
		selected = selected != null ? selected : 1;
		$('#c_day').html('');
		var month = $('#c_month').val();
		var year = $('#c_year').val();
		var days = f_daysInMonth(month, year);

		for(var i=1; i < days+1 ; i++){
			$('#c_day').append($('<option />').val(i).html(i));
		}
		$('#c_day').val(selected <= days ? selected : 1);
	}

</script>