<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/settings.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/settings_more.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/friends.css');

$alias = mysql_escape_string(htmlspecialchars(strip_tags($_GET["alias"])));
empty($alias) && $this->redirect('/groups');

$connection = Yii::app()->db;
$group_info = $connection->createCommand("SELECT uid, name, birth, about, photo, alias, owner, settings_comments FROM {{usersinfo}} WHERE alias = :alias")->bindParam(":alias", $alias)->queryRow();
(empty($group_info) || $group_info['owner'] != Yii::app()->user->id) && $this->redirect('/groups');
$c_year = date('Y', strtotime($group_info['birth']));
$c_month = intval(date('m', strtotime($group_info['birth'])));
$c_day = date('d', strtotime($group_info['birth']));

$months = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
$my     = $connection->createCommand("SELECT u.uid, CONCAT(u.name, ' ', u.fio) as 'fio', u.photo, u.alias FROM {{usersinfo}} u WHERE u.uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
$my['status'] = 'владелец канала';

?>

<?php $this->widget('SideBarWidget', array(
		'my' => $my
)); ?>



<script>
	
	function groupscontactshow() {
		
		alert(1);
		
	}
	
	$(document).ready(function() {

		$('body').on('click', '.groupscontactdelete', function () {
			event.preventDefault();
			var elem = $(this);
			var uid = $(this).attr('data-id');

			BootstrapDialog.show({
				title: 'Сообщение',
				message: 'Удалить выбранный контакт?',
				animate: false,
				buttons: [
					{
						label: 'Подтвердить',
						cssClass: 'btn-success',
						action: function (dialogItself) {
							$.ajax({
								url: '/ajax/contactdelete',
								type: 'POST',
								dataType: 'json',
								data: {
									uid: uid,
									group_id: <?=$group_info['uid']?>
								},
								success: function (results) {
									if (results.status == 200) {
										elem.closest('.friends_block').remove();
									} else {
										error(results.message);
									}
								}
							});
							dialogItself.close();
						}
					},
					{
						label: 'Отмена',
						action: function (dialogItself) {
							dialogItself.close();
						}
					}]
			});
			return false;
		});
		
		$('body').on('click', '.tab', function () {
			var page = $(this).attr('rel');
			$('.tab').removeClass('active');
			$(this).addClass('active');

			$('.tab-block').hide();
			$('.'+page).show();
		});
		
		
		$('body').on('click', '.groups-contact-add', function () {
			
			BootstrapDialog.show({
			title: 'Добавление контакта',
			message: 'Добавить данный контакт и сделать его доступным всем пользователям ?',
			animate: false,
			buttons: [
				{
					label: 'Добавить',
					cssClass: 'btn-success',
					action: function (dialogRef) {
						
						$contact_link = $("input[name='contactlink']").val();
						$contact_title = $("input[name='contacttitle']").val();

						$.ajax({
						url: '/groups/contactnew',
						type: 'POST',
						dataType: 'json',
						data: {
							link: $contact_link,
							title: $contact_title,
							uid: "<?=$group_info["uid"];?>"
						},
						success: function (results) {
							if (results.status == 200) {
							
							$(".groupscontactlist").append('<div class="friends_block"><a href="'+results.user.alias+'" class="friends_block_avatar"><img src="http://'+results.user.photo+'_sm.jpg" onError=\'this.src="/images/no_avatar.jpg\';" alt="'+results.user.fio+'"></a><h3><a href="/'+results.user.alias+'">'+results.user.name + " " + results.user.fio + '</a></h3><div class="time status" data-online="">Должность: ' + $contact_title + '</div><a href="#" class="friends_block_btn groupscontactdelete" data-id="'+results.user.uid+'">удалить из контактов</a></div>');
							
							//$(".groupscontactform").reset();
							
							} else {
								
								alert(results.message);
								
							}
						}
					});
						
						dialogRef.close();
						
					}//
				},
				{
					label: 'Закрыть',
					action: function (dialogItself) {
						dialogItself.close();
					}
				}]
		});
		

		});
		
		
		
	});
	
</script>


<div class="col-sm-8 create_group">
	<section  class="create_group_in">
		<div class="create_group_header">
			
			<div class="tab active" rel="general-settings">
				Основные настройки
			</div>
			<div class="tab" rel="contacts-settings">
				Отображение контактов
			</div>
		
		</div>
		<div class="create_group_content general-settings tab-block" style="display: block;">
			<form name="" action="" method="">
				<div class="col-sm-6 col-sm-offset-3 col-xs-12 create_group_content_wrap">
					<div class="form-group">
						<label for="name">Название:</label>
						<input type="text" class="form-control" id="name" value="<?=html_entity_decode($group_info['name'])?>" placeholder="" required="required">
					</div>

					<div class="form-group">
						<label for="about">Описание:</label>
						<textarea class="form-control" id="about" placeholder=""><?=html_entity_decode($group_info['about'])?></textarea>
					</div>

					<div class="form-group">
						<label for="alias">Адрес страницы:</label>
						<input type="text" class="form-control" id="alias" value="<?=$group_info['alias']?>" placeholder="">
					</div>


					<div class="form-group">
						<label for="c_day">Дата основания:</label>
						<select class="cr_day day" id="c_day"></select>
						<select class="cr_month month" id="c_month"></select>
						<select class="cr_year year" id="c_year"></select>
					</div>

					<div class="create_group_content_checkbox">
						<input type="checkbox" id="comments_off" placeholder=" " name=" " class="checkbox comments_off" value="1" <?=$group_info['settings_comments'] == 1 ? 'checked="checked"' : ''?>>
						<label for="comments_off">
							Комментарии включены
						</label>
					</div>

					<div class="create_group_content_checkbox">
						<input type="checkbox" value=" " id="checkbox1" name=" " class="checkbox" checked>
						<label for="checkbox1">
							Закрытая группа
						</label>
					</div>

				</div>

				<div class="create_group_content_footer">
					<a href="#" class="create_group_btn group-edit-btn">Сохранить</a>
				</div>

			</form>
		</div>
		
		
		
		<div class="create_group_content contacts-settings tab-block settings friends_in" style="display: none;">
			
			<form name="" action="#" method="post" class="goal_form groupscontactform">
				<div class=" ">
					<div class="col-md-5 col-sm-5">
						<label for="name">Ссылка на страницу</label>
						<input type="text" placeholder="https://" id="name" class="form-control" name="contactlink" required>
					</div>
					<div class="col-md-5 col-sm-5">
						<label for="price">Должность</label>
						<input type="text" placeholder="Например: Администратор" id="price" name="contacttitle" class="form-control" required>

					</div>
					<div class="col-md-2 col-sm-2">
						<a href="#" class="button groups-contact-add">Добавить</a>
					</div>
				</div>
			</form>
			
			<?$users = $connection->createCommand("SELECT u.uid, u.name, u.fio, u.photo, u.alias, f.contact_title FROM {{usersinfo}} u INNER JOIN {{contact}} f ON f.uid = :uid AND f.contact_uid = u.uid AND f.type = 2 ORDER BY uid")
		->bindParam(":uid", $group_info["uid"])
		->queryAll();?>
		
		
			<div class="friends_content groupscontactlist" id="search-result" style="margin: 16px;">
			<?php foreach ($users as $user) { ?>
				<div class="friends_block">
					<a href="/<?=$user['alias']?>" class="friends_block_avatar"><img src="//<?= $user['photo'] ?>_sm.jpg" onError="this.src='/images/no_avatar.jpg';" alt="<?= $user['fio'] ?>"></a>
					<h3><a href="/<?=$user['alias']?>"><?= $user['name'].' '.$user['fio'] ?></a></h3>
					<div class="time status" data-online="">Должность: <?=$user['contact_title']?></div>
					<a href="#" class="friends_block_btn groupscontactdelete" data-id="<?= $user['uid'] ?>">удалить из контактов</a>
				</div>
			<?php } ?>
		</div>			
			
		</div>
		
		
	</section>
</div>

<script type="application/javascript">
	$('document').ready(function () {
		$('body').on('click', '.tab', function () {
			var page = $(this).attr('rel');
			$('.tab').removeClass('active');
			$(this).addClass('active');

			$('.tab-block').hide();
			$('.'+page).show();
		});

		$('body').on('click', '.group-edit-btn', function () {
			event.preventDefault();

			var name = $('#name').val();
			var alias = $('#alias').val();
			var about = $('#about').val();
			var c_day = $('#c_day').val();
			var c_month = $('#c_month').val();
			var c_year = $('#c_year').val();
			var settings_comments = $("#comments_off").is(':checked') ? 1 : 0;

			$.ajax({
				url: '/groups/groupedit',
				type: 'POST',
				dataType: 'json',
				data: {
					name: name,
					alias: alias,
					about: about,
					c_day: c_day,
					c_month: c_month,
					c_year: c_year,
					settings_comments: settings_comments,
					group: <?=$group_info['uid']?>
				},
				success: function (results) {
					if (results.status == 200) {
						window.location.replace("/"+alias);
					}else{
						message_info(results.message);
					}
				}
			});

		});

		$(function() {

			//populate our years select box
			for (var i = new Date().getFullYear(); i > 1900; i--){
				$('#c_year').append($('<option />').val(i).html(i));
			}
			$('#c_year').val(<?=$c_year?>);

			//populate our months select box
			var months = ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"];
			for (i = 0; i < 12; i++){
				$('#c_month').append($('<option />').val(i+1).html(months[i]));
			}
			$('#c_month').val(<?=$c_month?>);

			//populate our Days select box
			updateNumberOfDays();
			$('#c_day').val(<?=$c_day?>);

			//"listen" for change events
			$('#c_year, #c_month').change(function(){
				updateNumberOfDays();
			});

		});
	});

	function updateNumberOfDays(){
		var selected = $('#c_day').val();
		selected = selected != null ? selected : 1;
		$('#c_day').html('');
		var month = $('#c_month').val();
		var year = $('#c_year').val();
		var days = f_daysInMonth(month, year);

		for(var i=1; i < days+1 ; i++){
			$('#c_day').append($('<option />').val(i).html(i));
		}
		$('#c_day').val(selected <= days ? selected : 1);
	}

</script>