<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/group_settings.css');

$connection = Yii::app()->db;

$months = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
$my     = $connection->createCommand("SELECT u.uid, CONCAT(u.name, ' ', u.fio) as 'fio', u.photo, u.alias FROM {{usersinfo}} u WHERE u.uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
$my['status'] = 'владелец канала';
?>

<div class="col-xs-12  col-md-8">

	<div class="boxed profile_settings push-down-45">
		<div class="profile_settings_head">
			<!-- <a href="#" class=" tab active">Основные настройки</a> -->
			<a href="#" class=" tab active">Информация Канала</a>
		</div>
		<div class="profile_settings_basic profile_settings_form">
			<form class="form-horizontal">
				<div class="profile_settings_form_body">
					<div class="form-group error-summary" style="display: none;">
						<ul></ul>
					</div>
					<div class="form-group">
						<label for="name" class="col-sm-3 control-label">Название:</label>
						<div class="col-sm-6">
							<input type="text" class="form-control" id="name" placeholder="" required="required">
						</div>
					</div>
					<div class="form-group">
						<label for="alias" class="col-sm-3 control-label">Адрес страницы:</label>
						<div class="col-sm-6">
							<input type="text" class="form-control" id="alias" placeholder="">
						</div>
					</div>
					<div class="form-group">
						<label for="about" class="col-sm-3 control-label">Описание групы:</label>
						<div class="col-sm-6">
							<textarea class="form-control" id="about" placeholder=""></textarea>
						</div>
					</div>
					<div class="form-group">
						<label for="c_day" class="col-sm-3 control-label">Дата основания:</label>
						<div class="col-sm-6">
							<select class="form-control day" id="c_day"></select>
							<select class="form-control month" id="c_month"></select>
							<select class="form-control year" id="c_year"></select>
						</div>
					</div>
					<div class="form-group">
						<label for="settings_comments" class="col-sm-3 control-label">Обратная связь:</label>
						<div class="col-sm-6">
							<input type="checkbox" class="form-control comments_off" id="comments_off" placeholder=" " value="1" checked="checked">
							<label for="comments_off">Комментарии включены</label>
						</div>
					</div>
				</div>
				<div class="profile_settings_form_footer">
					<a href="#" class="dialogs_button group-new-btn">Создать</a>
				</div>
			</form>
		</div>
	</div>
</div>

<?php $this->widget('SideBarWidget', array(
	'my' => $my
)); ?>

<script type="application/javascript">
	$('document').ready(function () {
		$('body').on('click', '.tab', function () {
			var page = $(this).attr('rel');
			$('.tab').removeClass('active');
			$(this).addClass('active');

			$('.tab-block').hide();
			$('.'+page).show();
		});

		$('body').on('click', '.group-new-btn', function () {
			event.preventDefault();

			var name = $('#name').val();
			var alias = $('#alias').val();
			var about = $('#about').val();
			var c_day = $('#c_day').val();
			var c_month = $('#c_month').val();
			var c_year = $('#c_year').val();
			var settings_comments = $("#comments_off").is(':checked') ? 1 : 0;

			$.ajax({
				url: '/groups/groupnew',
				type: 'POST',
				dataType: 'json',
				data: {
					name: name,
					alias: alias,
					about: about,
					c_day: c_day,
					c_month: c_month,
					c_year: c_year,
					settings_comments: settings_comments
				},
				success: function (results) {
					if (results.status == 200) {
						window.location.replace("/"+results.group);
					}else{
						$('.error-summary ul').empty().append(results.message);
						$('.error-summary').show().focus();
					}
				}
			});

		});

		$(function() {

			//populate our years select box
			for (var i = new Date().getFullYear(); i > 1900; i--){
				$('#c_year').append($('<option />').val(i).html(i));
			}

			//populate our months select box
			var months = ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"];
			for (i = 0; i < 12; i++){
				$('#c_month').append($('<option />').val(i+1).html(months[i]));
			}

			//populate our Days select box
			updateNumberOfDays();

			//"listen" for change events
			$('#c_year, #c_month').change(function(){
				updateNumberOfDays();
			});

		});
	});

	function updateNumberOfDays(){
		var selected = $('#c_day').val();
		selected = selected != null ? selected : 1;
		$('#c_day').html('');
		var month = $('#c_month').val();
		var year = $('#c_year').val();
		var days = f_daysInMonth(month, year);

		for(var i=1; i < days+1 ; i++){
			$('#c_day').append($('<option />').val(i).html(i));
		}
		$('#c_day').val(selected <= days ? selected : 1);
	}

</script>