<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/main.css');


Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');

$connection = Yii::app()->db;

$page = isset($_GET['page']) ? intval($_GET['page']) : 1;
$limit = Yii::app()->params['users-per-page'];

$groups = $connection->createCommand("SELECT g.count_user, u.uid, u.name, u.photo, u.alias, u.about, (f.uid IS NOT NULL) AS subscribed FROM {{usersinfo}} u LEFT JOIN {{friends}} f ON f.uid = :uid AND f.fuid = u.uid INNER JOIN {{groups}} g ON g.cid = u.uid WHERE (u.type = 2 AND u.status = 1) ORDER BY g.count_user DESC LIMIT :limit OFFSET :offset")
	->bindParam(":uid", Yii::app()->user->id)
	->bindValue(":limit", $limit)
	->bindValue(":offset", ($page - 1) * $limit)
	->queryAll();
$totalRecords = $connection->createCommand('SELECT FOUND_ROWS()')->queryScalar();

$pages = new CPagination($totalRecords);
$pages->pageVar = 'page';
$pages->setPageSize($limit);

$cities = array();
?>

<div class="col-sm-4">
	<section class="group_search">
		<div class="group_aside_header">
			Поиск групп
		</div>
		<div class="group_search_content">
			<form name="" action="" method="">
				<div class=" ">
					<div class="form-group">
						<label for="search_query">Название:</label>
						<input type="text" class="form-control" id="search_query" placeholder=" ">
					</div>

					<div class="form-group">
						<label for="exampleSelect1">Тематика:</label>
						<select class="form-control" id="exampleSelect1">
							<option></option>
							<option></option>
							<option></option>
						</select>
					</div>

				</div>

				<div class="group_search_content_footer">
					<a href="/groups/new" class="group_search_btn">Создать группу</a>
				</div>
			</form>
		</div>
	</section>

	<section class="group_reccomended">
		<div class="group_aside_header">
			Рекомендованные группы:
		</div>
		<div class="group_reccomended_content">
<!--			<div class="group_reccomended_block">-->
<!--				<a href="#" class="group_reccomended_avatar"><img src="images/g_1.jpg" alt="logo"></a>-->
<!--				<h3><a href="#">Невероятная Финляндия</a></h3>-->
<!--				<div class="summary">Живописная страна</div>-->
<!--				<div class="followers">20 567 подписчиков</div>-->
<!--				<a href="#" class="group_block_btn">Подписаться</a>-->
<!--			</div>-->
		</div>
	</section>

</div>
<div class="col-sm-8 group">
	<section class="group_in">
		<div class="group_header">
			<a href="/groups" class="tab active">Группы</a>
			<a href="/groups/my" class="tab">Мои группы</a>
			<a href="/groups/settings" class="tab">Управление</a>
		</div>
		<div class="group_content" id="search-result">
			<?php foreach ($groups as $group) { ?>
				<div class="group_block">
					<a href="/<?=$group['alias']?>" class="group_block_avatar"><img src="//<?= $group['photo'] ?>_sm.jpg"
																					onError="this.src='/images/no_thumb.png';" alt="<?= $group['fio'] ?>"></a>
					<h3><a href="/<?=$group['alias']?>"><?= html_entity_decode($group['name'].' '.$group['fio']) ?></a></h3>
					<p class="summary"><?=html_entity_decode(f_replace($group['about']))?></p>
					<div class="followers"></div>
					<a href="#" class="group_block_btn <?= ($group['subscribed'] ? 'unsubscribe' : 'subscribe') ?>" data-id="<?= $group['uid'] ?>"><?= ($group['subscribed'] ? 'Отписаться' : 'Подписка') ?></a>
				</div>
			<?php } ?>
		</div>
	</section>
</div>

<script type="application/javascript">
	var processing = false;
	var page = <?= $page; ?>;
	var req = null;
	var timer = null;


	$(document).ready(function () {

		$(document).scroll(function () {
			groupSearch();
		});

		$('body').on('click', '.subscribe', function () {
			event.preventDefault();

			var obj = this;
			$.ajax({
				url: '/ajax/subscribe',
				type: 'POST',
				dataType: 'json',
				data: {
					uid: $(obj).data("id")
				},
				success: function (results) {
					if (results.status == 200) {
						$(obj).html('Отписаться').toggleClass('subscribe unsubscribe');
					}
				}
			});
		});

		$('body').on('click', '.unsubscribe', function () {
			event.preventDefault();

			var obj = this;
			$.ajax({
				url: '/ajax/unsubscribe',
				type: 'POST',
				dataType: 'json',
				data: {
					uid: $(obj).data("id")
				},
				success: function (results) {
					if (results.status == 200) {
						$(obj).html('Пописка').toggleClass('unsubscribe subscribe');
					}
				}
			});
		});

		$('#search_query').keyup(function () {
			if ($(this).val().length >= 3 || $(this).val().length == 0) {
				if (timer) {
					clearTimeout(timer); //cancel the previous timer.
					timer = null;
				}
				timer = setTimeout(
					function () {
						page = 1;
						groupSearch(true);
					}, 500);

			}
		});
	});

</script>