<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');

$connection = Yii::app()->db;

$months = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
$my     = $connection->createCommand("SELECT u.uid, u.skype, u.tel, u.city, CONCAT(u.name, ' ', u.fio) as 'fio', u.photo, u.alias FROM {{usersinfo}} u WHERE u.uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
$my['status'] = 'владелец канала';

?>

<?php $this->widget('SideBarWidget', array(
		'my' => $my
)); ?>

<div class="col-sm-8 create_group">
	<section  class="create_group_in">
		<div class="create_group_header">
			<div class="active">
				Создание группы
			</div>
		</div>
		<div class="create_group_content">
			<form name="" action="" method="">
				<div class="col-sm-6 col-sm-offset-3 col-xs-12 create_group_content_wrap">
					<div class="form-group">
						<label for="name">Название:</label>
						<input type="text" class="form-control" id="name" placeholder="" required="required">
					</div>

					<div class="form-group">
						<label for="about">Описание:</label>
						<textarea class="form-control" id="about" placeholder=""></textarea>
					</div>

					<div class="form-group">
						<label for="alias">Адрес страницы:</label>
						<input type="text" class="form-control" id="alias" placeholder="">
					</div>


					<div class="form-group">
						<label for="c_day">Дата основания:</label>
						<select class="cr_day day" id="c_day"></select>
						<select class="cr_month month" id="c_month"></select>
						<select class="cr_year year" id="c_year"></select>
					</div>

					<div class="create_group_content_checkbox">
						<input type="checkbox" id="comments_off" placeholder=" " name=" " class="checkbox comments_off" value="1" checked="checked">
						<label for="comments_off">
							Комментарии включены
						</label>
					</div>

					<div class="create_group_content_checkbox">
						<input type="checkbox" id="checkbox1" name=" " class="checkbox" checked>
						<label for="checkbox1">
							Закрытая группа
						</label>
					</div>

				</div>

				<div class="create_group_content_footer">
					<a href="#" class="create_group_btn group-new-btn">Сохранить</a>
				</div>

			</form>
		</div>
	</section>
</div>

<script type="application/javascript">
	$('document').ready(function () {
		$('body').on('keyup', '#alias', function (e) {
			var rv_name = /^[a-zA-Z]+$/;
			var str = $(this).val();

			if(!rv_name.test(str)){
				e.preventDefault();
				str = str.replace(/\W/g,"");
				$(this).val(str);
				error('<p>Недопустимый формат.</p>');
			}else{
				$('.error-summary').fadeOut(500, function() {
					$('.error-summary ul').empty();
				});
			}
		});

		$('body').on('click', '.tab', function () {
			var page = $(this).attr('rel');
			$('.tab').removeClass('active');
			$(this).addClass('active');

			$('.tab-block').hide();
			$('.'+page).show();
		});

		$('body').on('click', '.group-new-btn', function () {
			event.preventDefault();

			var name = $('#name').val();
			var alias = $('#alias').val();
			var about = $('#about').val();
			var c_day = $('#c_day').val();
			var c_month = $('#c_month').val();
			var c_year = $('#c_year').val();
			var settings_comments = $("#comments_off").is(':checked') ? 1 : 0;

			$.ajax({
				url: '/groups/groupnew',
				type: 'POST',
				dataType: 'json',
				data: {
					name: name,
					alias: alias,
					about: about,
					c_day: c_day,
					c_month: c_month,
					c_year: c_year,
					settings_comments: settings_comments
				},
				success: function (results) {
					if (results.status == 200) {
						window.location.replace("/"+results.group);
					}else{
						$('.error-summary ul').empty().append(results.message);
						$('.error-summary').show().focus();
					}
				}
			});

		});

		$(function() {

			//populate our years select box
			for (var i = new Date().getFullYear(); i > 1900; i--){
				$('#c_year').append($('<option />').val(i).html(i));
			}

			//populate our months select box
			var months = ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"];
			for (i = 0; i < 12; i++){
				$('#c_month').append($('<option />').val(i+1).html(months[i]));
			}

			//populate our Days select box
			updateNumberOfDays();

			//"listen" for change events
			$('#c_year, #c_month').change(function(){
				updateNumberOfDays();
			});

		});
	});

	function updateNumberOfDays(){
		var selected = $('#c_day').val();
		selected = selected != null ? selected : 1;
		$('#c_day').html('');
		var month = $('#c_month').val();
		var year = $('#c_year').val();
		var days = f_daysInMonth(month, year);

		for(var i=1; i < days+1 ; i++){
			$('#c_day').append($('<option />').val(i).html(i));
		}
		$('#c_day').val(selected <= days ? selected : 1);
	}

</script>