<?php

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/dialog.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/group_settings.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/popup-message.css');


$connection = Yii::app()->db;

$my = $connection->createCommand("SELECT uid, CONCAT(name, ' ', fio) as 'full_name', photo, sex, online FROM {{usersinfo}} WHERE uid = :uid")
	->bindParam(":uid", Yii::app()->user->id)
	->queryRow();
?>

<?php $this->widget('SideBarWidget', array(
		'my' => $my
)); ?>

<div class="col-sm-8 dialog">
	<section class="dialog_in">
		<div class="dialog_header">
			<a href="/im">
				<div class="dialogs active">
					Диалоги
				</div>
			</a>
		</div>

		<div class="dialogs_list">
			<div class="dialog_search">
				<input type="text" placeholder="Поиск сообщений...">
				<a href="#" class="favorites"><i class="fa fa-star"></i></a>
				<a href="#" class="write_message" id="choose-interlocutor-btn">Написать сообщение</a>
			</div>

			<div class="dialog_container_child"></div>
		</div>
	</section>
</div>

<script type="application/javascript">
	var processing = false;
	var page = 1;

	$(document).ready(function (e) {

		$('body').on('click', '.choose_interlocutor_in_container_list_block', function() {
			event.preventDefault();
			window.location.replace("/im/"+$(this).attr('rel'));
		});

		$('body').on('click', '.dialog-delete', function(){
			event.preventDefault();

			var elem = $(this);
			var id = $(this).data("id");
			var message = 'Все сообщения в диалоге будут удалены! Удалить данный диалог?<br>' +
			'<div class="search_search_form search_page" style="padding: 0; height: 25px;">' +

			'<div class="col-sm-6">' +
			'<input type="checkbox" class="form-control comments_off" id="user_ban" value="1">' +
			'<label for="user_ban">Заблокировать пользователя</label>' +
			'<br>' +
			'<input type="checkbox" class="form-control comments_off" id="user_spam" value="1">' +
			'<label for="user_spam">Пожаловаться на спам</label>' +
			'</div>' +
			'</div>' +
			'</div>';

			BootstrapDialog.show({
				title: 'Подтверджение',
				message: message,
				animate: false,
				buttons: [
					{
						label: 'Подтвердить',
						cssClass: 'btn-success',
						action: function (dialogItself) {
							var user_ban = dialogItself.getModalBody().find('#user_ban:checked').val();
							user_ban = user_ban != undefined ? user_ban : 0;
							$.ajax({
								url: '/messages/dialogdelete',
								type: 'POST',
								dataType: 'json',
								data: {
									id: id,
									user_ban: user_ban
								},
								success: function (results) {
									if (results.status == 200) {
										elem.closest('.dialog_block').remove();
									}else{
										BootstrapDialog.show({
											title: 'Ошибка',
											message: results.message,
											animate: false,
											type: BootstrapDialog.TYPE_DANGER,
											closable: true,
											draggable: false,
											buttonLabel: 'Закрыть',
											callback: function(result) {

											}
										});
									}
								}
							});
							dialogItself.close();
						}
					},
					{
						label: 'Отмена',
						action: function (dialogItself) {
							dialogItself.close();
						}
					}]
			});

			return false;
		});

		$('body').on('click', '#choose-interlocutor-btn', function () {
			event.preventDefault();

			var html = '';
			$.ajax({
				url: '/ajax/friendslist',
				type: 'POST',
				dataType: 'json',
				success: function (results) {
					if (results.status == 200 && results.friends) {

						html += '<div class="choose_interlocutor_search_form">';
						html += '<form>';
						html += '<input type="text" class="search" placeholder="Начните вводить имя друга">';
						html += '</form>';
						html += '</div>';

						html += '<div class="choose_interlocutor_in_container">';
						html += '<div class="choose_interlocutor_in_container_list">';
						html += '<p>Ваши друзья</p>';

						$.each(results.friends, function (key, friend) {
							var photo = friend.photo ? '//'+friend.photo+'_sm.jpg' : '/images/no_avatar.jpg';
							html += '<div class="choose_interlocutor_in_container_list_block" rel="'+friend.uid+'">';
							html += '<img src="'+ photo +'" onerror="this.src=\'/images/no_avatar.jpg\';" alt="'+friend.fio+'" width="35" height="35">';
							html += '<a href="/im/'+friend.uid+'">'+friend.fio+'</a>';
							html += '<i class="fa fa-plus"></i>';
							html += '</div>';
						});

						html += '</div>';
						html += '</div>';
						html += '</div>';

						BootstrapDialog.show({
							title: 'Выберите собеседника',
							message: html,
							cssClass: 'friends-dialog',
							animate: false,
							type: BootstrapDialog.TYPE_PRIMARY,
							closable: true,
							draggable: false,
							buttons: [
								{
									label: 'Закрыть',
									action: function (dialogItself) {
										dialogItself.close();
									}
								}]
						});
					}
				}
			});
		});

		$(document).scroll(_.debounce(function () {
			dialogHistory(page);
		}, 300));

		$('.dialog_container_child').emotions();


		dialogHistory(1, true);
	});

	function dialogHistory(p, forseLoad) {
		if (processing) return false;

		if (1 >= $('.dialog_container_child').scrollTop() || forseLoad) {
			processing = true;

			$.ajax({
				url: '/messages/dialoghistory',
				type: 'POST',
				dataType: 'json',
				data: {
					page: p
				},
				success: function (results) {
					if (results.status == 200) {
						processing = results.dialogs.length == 0;
						for (var i = 0; i < results.dialogs.length; i++) {
							$('.dialog_container_child').append(generateDialog(results.dialogs[i]));
						}
					} else {
						processing = true;
					}
				}
			});
			page = p + 1;
		}
	}

	function generateDialog(dialog) {
		var html = '';
		if (dialog.fuid == <?=Yii::app()->user->id?>) {
			html = sendDialogView(dialog);
		} else {
			html = inboxDialogView(dialog);
		}
		return html;
	}

	function inboxDialogView(dialog){
		var html = '';

		html +=

		'<div class="dialog_block dialog_block_income '+(dialog.is_readed == 0 ? 'not_read' : '')+'">' +
		'<i class="fa fa-times dialog-delete" data-id="'+dialog.uid+'"></i>' +
		'<a class="dialog_avatar" href="'+(dialog.alias != "" ? '/'+dialog.alias : '#')+'"><img src="//'+dialog.photo+'_sm.jpg" onerror="this.src=\'/images/no_avatar.jpg\';" alt="'+dialog.fio+'"></a>' +
		'<div>' +
		'<div>' +
		'<span class="time">'+f_dt(dialog.date)+'</span>' +
		'<a href="'+(dialog.alias != "" ? '/'+dialog.alias : '#')+'" class=" ">'+dialog.fio+'</a>' +
		'&nbsp;<span class="status">'+f_online_status(dialog.online)+'</span>' +
		'</div>' +
		'<a class="dialog-body" href="/im/'+dialog.uid+'"><p>'+$.emotions(he.decode(dialog.message))+'</p></a>' +
		'</div>' +
		'</div>';

		return html;

	}

	function sendDialogView(dialog){
		var html = '';

		html +=

		'<div class="dialog_block dialog_block_outcome '+(dialog.is_readed == 0 ? 'not_read' : '')+'">' +
		'<i class="fa fa-times dialog-delete" data-id="'+dialog.uid+'"></i>' +
		'<a class="dialog_avatar" href="/'+dialog.alias+'"><img src="//'+dialog.photo+'_sm.jpg" alt="'+dialog.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';"></a>' +
		'<div>' +
		'<div>' +
		'<span class="time">'+f_dt(dialog.date)+' </span>' +
		'<a href="/'+dialog.alias+'" class=" ">'+dialog.fio+'</a>' +
		'&nbsp;<span class="status">'+f_online_status(dialog.online)+'</span>' +
		'</div>' +
		'<div class="outcome_message">' +
		'<a class="dialog_avatar" href="/im/'+dialog.uid+'"><img src="//<?=$my['photo']?>_sm.jpg" alt="<?=$my['fio']?>" onerror="this.src=\'/images/no_avatar.jpg\';"></a>' +
		'<a class="dialog-body" href="/im/'+dialog.uid+'"><p>'+$.emotions(he.decode(dialog.message))+'</p></a>' +
		'</div>' +
		'</div>' +
		'</div>';

		return html;
	}


</script>