<?php

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');


Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/dialog.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/group_settings.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/popup-message.css');

$sel = intval($_GET['sel']);
$connection = Yii::app()->db;
//$msg_db = Yii::app()->msg_db;

$connection->createCommand("UPDATE {{messages}} SET is_readed = 1 WHERE fuid = :sel AND tuid = :uid AND is_readed = 0")
	->bindValue(":uid", Yii::app()->user->id)
	->bindParam(":sel", $sel)
	->query();

$my = $connection->createCommand("SELECT u.uid, CONCAT(u.name, ' ', u.fio) as 'fio', u.sex, u.online, u.photo, u.alias FROM {{usersinfo}} u WHERE u.uid = :uid")
	->bindParam(":uid", Yii::app()->user->id)
	->queryRow();

$friend = $connection->createCommand("SELECT u.uid, u.sex, CONCAT(u.name, ' ', u.fio) as 'fio', u.photo, u.alias, u.online FROM {{usersinfo}} u WHERE u.uid = :uid")
	->bindParam(":uid", $sel)
	->queryRow();
?>


<?php $this->widget('SideBarWidget', array(
		'my' => $my
)); ?>

<div class="col-sm-8 dialog">
	<section class="dialog_in">
		<div class="dialog_header">
			<a href="/im">
				<div class="dialogs">
					Диалоги
				</div>
			</a>
			<a href="/im">
				<div class="dialogs_watch active">
					Просмотр диалогов
				</div>
			</a>
		</div>

		<div class="dialogs_all_1">
			<div class="dialog_tab">
				<div class="tab active">
					<span><?= $friend['fio'] ?></span>
					<i class="fa fa-times"></i>
				</div>
			</div>

			<div class="dialog_content message_container_in"></div>

			<div class="dialog_send_message_form">
				<form method="" action="" name="">
					<a class="dialog_send_message_form_avatar" href="/<?=$my['alias'] ?>"><img src="//<?=$my['photo']?>_sm.jpg" alt="<?=$my['fio'] ?>" onerror="this.src='/images/no_avatar.jpg';"></a>
					<div class="message-content text" contentEditable="true"></div>
					<div class="smiles">
						<span class="smiles_btn"><img alt="smile" src="/images/smile.png"></span>
					</div>
					<div class="">
						<a class="dialog_send_message_form_btn" href="#" id="send">Отправить</a>
					</div>
				</form>
			</div>
		</div>

	</section>
</div>


<script type="application/javascript">
	var time_out;
	var interval_start = 10000;
	var my_photo = '<?= $my['photo'] ?>';
	var m_time = <?=time()?>;
	var page = 1;
	var processing = false;

	$(document).ready(function () {
		$('.message-content').on('keydown', function(e) {
			if (e.which == 13 && e.shiftKey == false) {
				$("#send").click();
			}
		});

		$('.message_container_in').scroll(_.debounce(function () {
			imHistory(page);
		}, 300));

		$('body').on('click', '.emotion_smile', function () {
			event.preventDefault();
			var id = $(this).data('id');
			$(this).closest('.comment_form').find('.message-content').append('(s:'+id+')').emotions();
		});

		$('body').on('mouseover', '.comment_form_adds .smile', function () {
			event.preventDefault();
			$('.emotion_wrap').fadeIn(200);
		});

		$('body').on('click', '.emotion_smile', function () {
			event.preventDefault();
			var id = $(this).data('id');
			$("#message-content").append('{s:'+id+'}').emotions();
		});

		$('body').on('mouseout', '.comment_form_adds .smile, .emotion_wrap', function () {
			event.preventDefault();

			var smiles = $(".emotion_wrap");

			setTimeout( function(){
				if (!$(smiles).is(':hover') && !$('.comment_form_adds .smile').is(':hover')) {
					smiles.fadeOut(200);
				}
			}  , 500 );

		});

		$("#send").click(function () {
			event.preventDefault();

			$.each( $(".message-content img.emotions"), function(){
				$(this).replaceWith('(s:'+$(this).data('smile')+')');
			});

			var text = $(".message-content").html();
			if(text != '' && text.length <= 1000){
				$.ajax({
					url: '/messages/sendmessage',
					type: 'POST',
					dataType: 'json',
					data: {
						text: text,
						id: <?= $friend['uid'] ?>
					},
					success: function (results) {
						if (results.status == 200) {
							var html = messageViewSend(<?=CJSON::encode($my)?>, results.message);
							$('.message_container_in').append(html);
							$(".message_container_in").animate({ scrollTop: $(".message_container_in")[0].scrollHeight}, 0);
							$(".message-content").html('');
						}else{
							message_info(results.message);
						}
					}
				});
			}else{
				if(text.length > 1000){
					BootstrapDialog.show({
						title: 'Предупреждение',
						message: 'Длина сообщения не должна превышать 1000 символов.',
						animate: false,
						type: BootstrapDialog.TYPE_WARNING,
						closable: true,
						draggable: false,
						buttons: [
							{
								label: 'Закрыть',
								action: function (dialogItself) {
									dialogItself.close();
								}
							}]
					});
				}
			}
		});

		$.when(imHistory(1, true)).done(function(){
			checkIm();
		});

		$(".message_container_in").emotions();
		$('.friend-status').empty().html(f_online_status(<?= $friend['online']?>));
	});

	function imHistory(p, forseLoad){
		if (processing) return false;

		if ((1 >= $('.message_container_in').scrollTop()) || forseLoad) {
			processing = true;

			$.ajax({
				url: '/ajax/imhistory',
				type: 'POST',
				dataType: 'json',
				data: {
					page: p,
					sel: <?=$sel?>,
					ts: <?=time()?>
				},
				success: function (results) {
					if (results.status == 200) {
						processing = results.messages.length == 0;
						for (var i = 0; i < results.messages.length; i++) {
							var firstMsg = $('.message_container_in .message:first');
							var scroll = firstMsg.length > 0 ? firstMsg.offset().top : 0;
							$('.message_container_in').prepend(generateMessage(results.messages[i]));
						}
						$('.message_container_in').scrollTop(scroll);

						if(forseLoad){
							$('.message_container_in').animate({
								scrollTop: $('.message_container_in').height()
							}, 0);
						}
					} else {
						processing = true;
					}
				}
			});
			page = p + 1;
		}
	}

	function checkIm() {
		time_out = setTimeout(
			function () {
				$.ajax({
					type: 'POST',
					url: '/messages/checkim',
					dataType: 'json',
					data: {
						uid: <?= $friend['uid'] ?>,
						m_time: m_time
					},
					success: function (results) {
						if (results.messages) {
							for (var i = 0; i < results.messages.length; i++) {
								$('.message_container_in').append(generateMessage(results.messages[i]));
								m_time = results.messages[i].date;
							}
							$(".message_container_in").animate({ scrollTop: $(".message_container_in")[0].scrollHeight}, 0);
							$('.friend-status').empty().html('Online');
							clearTimeout(time_out);
							interval_start = 10000;

//							var soundFx = $('#im');
//							soundFx[0].play();

							$.ajax({
								url: '/messages/messagereceived',
								type: 'POST',
								dataType: 'json',
								data: {
									id: <?= $friend['uid'] ?>
								}
							});
						}
						if(results.readed){
							$('.message_right_not_read').removeClass('message_right_not_read').addClass('message_right');
						}
						checkIm();
					}
				});
				if (interval_start <= 18000) {
					interval_start = interval_start + 100;
				}
			}, interval_start);

	}

	function messageViewSend(user, mess){
		var html = '';

		html +=

		'<div class="message '+(mess.is_readed == 1 ? '' : 'not_read')+'">' +
		'<i class="fa fa-times"></i>' +
		'<div class="message_avatar">' +
		'<a href="/'+user.alias+'"><img src="//'+user.photo+'_sm.jpg" alt="'+user.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';"></a>' +
		'<span class="status"></span>' +
		'</div>' +
		'<div>' +
		'<div>' +
		'<span class="time">'+moment.unix(mess.date).format("DD.MM.YY HH:mm")+'</span>' +
		'<a href="/'+user.alias+'" class=" ">'+user.fio+'</a>' +
		'</div>' +
		'<p>' + $.emotions(f_hsc(mess.message)) + '</p>' +
		'</div>' +
		'</div>';

		return html;
	}

	function messageViewIncome(user, mess){
		var html = '';

		html +=
			'<div class="message">' +
			'<i class="fa fa-times"></i>' +
			'<div class="message_avatar">' +
			'<a href="'+(user.alias != "" ? '/'+user.alias : '#')+'"><img src="//'+user.photo+'_sm.jpg" alt="'+user.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';"></a>' +
			'<span class="status"></span>' +
			'</div>' +
			'<div>' +
			'<div>' +
			'<span class="time">'+moment.unix(mess.date).format("DD.MM.YY HH:mm")+'</span>' +
			'<a href="'+(user.alias != "" ? '/'+user.alias : '#')+'" class=" ">'+user.fio+'</a>' +
			'</div>' +
			'<p>' + $.emotions(f_hsc(mess.message)) + '</p>' +
			'</div>' +
			'</div>';
		return html;
	}

	function generateMessage(mess) {
		var html = '';

		if (mess.fuid == <?=$sel?>) {
			html = messageViewIncome(<?=CJSON::encode($friend)?>, mess);
		} else {
			html = messageViewSend(<?=CJSON::encode($my)?>, mess);
		}
		return html;
	}

</script>