<?php

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/project_goods.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/p_projects_ex.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/modal.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/select2.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/filter.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/tampletes.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/group.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/elements.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/my_goods.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/invoice.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/wallet.css'); //Кошельки

$connection = Yii::app()->db;
$order_id = intval($_GET['id']);

if(Yii::app()->user->isGuest) $this->redirect('/');

$order = $connection->createCommand("SELECT * FROM {{orders}} WHERE id = :id AND uid = :uid AND status = 1")
	->bindParam(":uid", Yii::app()->user->id)
	->bindParam(":id", $order_id)
	->queryRow();
if(empty($order)) $this->redirect('/feed');

$good = $connection->createCommand("SELECT * FROM {{goods}} WHERE gid = :gid")
	->bindParam(":gid", $order['gid'])
	->queryRow();
if(empty($good)) $this->redirect('/feed');

$good_owner = $connection->createCommand("SELECT uid, CONCAT(name, ' ', fio) as 'full_name', tel, skype, country, city FROM {{usersinfo}} WHERE uid = :uid")
	->bindParam(":uid", $good['uid'])
	->queryRow();
if(empty($good_owner)) $this->redirect('/feed');

$my = $connection->createCommand("SELECT uid, CONCAT(name, ' ', fio) as 'full_name', tel, skype, photo, country, city, alias FROM {{usersinfo}} WHERE uid = :uid")
	->bindParam(":uid", Yii::app()->user->id)
	->queryRow();

if(!empty($my['country'])){
	$country = Loc::getCountryById($my['country']);
	$my['country_name_ru'] = $country['title'];
}
if(!empty($my['city'])){
	$city = Loc::getCityById($my['city']);
	$my['city_name_ru'] = $city['title'];
}
if(!empty($good_owner['country'])){
	$country = Loc::getCountryById($good_owner['country']);
	$good_owner['country_name_ru'] = $country['title'];
}
if(!empty($good_owner['city'])){
	$city = Loc::getCityById($good_owner['city']);
	$good_owner['city_name_ru'] = $city['title'];
}

$sum = $good['price']*$order['quantity'];
$sum_topay = $good['price']*$order['quantity'] - $order['discount_amount']*$order['quantity'];

$discount = $order['discount_amount']*$order['quantity'];

?>

<?php $this->widget('SideBarWidget', array(
	'my' => $my
)); ?>



<div class="col-sm-8 invoice">
	<div class="section invoice_section">
		<div class="row">
			<div class="col-md-4">
				<div class="invoice_section_header">
					Отправитель
				</div>
				<div class="invoice_section_content"></span>
					<span><?=$my['full_name']?></span> <span> <?=$my['country_name_ru']?><?= !empty($my['country']) && !empty($my['city']) ? ', ' : ''?><?=$my['city_name_ru']?></span>
				</div>
			</div>

			<div class="col-md-4">
				<div class="invoice_section_header">
					Получатель
				</div>
				<div class="invoice_section_content">
					<span><?=$good_owner['full_name']?></span> <span> <?=$good_owner['country_name_ru']?><?= !empty($good_owner['country']) && !empty($good_owner['city']) ? ', ' : ''?><?=$good_owner['city_name_ru']?></span> <span>Кошелек: 1111111  </span>
				</div>
			</div>

			<div class="col-md-4">
				<div class="invoice_section_header">
					Номер заказа
					<span><?=$order['id']?></span>
				</div>
				<div class="invoice_section_content">
					<div>
						<span>Дата оплаты:</span>
						<span><?=date("d-m-Y")?></span>
					</div>
					<div>
						<span>Оплатить до:</span>
						<span><?=date('d-m-Y', strtotime('+7 days'))?></span>
					</div>
				</div>
				<div class="invoice_section_sum">
					Сумма к оплате:<span><span class="invoice-total-sum"><?=$sum_topay?></span> <span>BP</span></span>
				</div>
			</div>

			<div class="col-md-8">
				<div class="invoice_section_header">
					Описание
				</div>
				<div class="invoice_section_dicr"><?=$good['text']?></div>
				<?php if($good['price'] > $order['amount']){ ?>
					<div class="invoice_section_dicr"><span class="alert">Внимание! С момента подачи заявки цена товара изменилась с <?=$order['amount']?> BP до <?=$good['price']?> BP</span></div>
				<?php } ?>
			</div>
		</div>

		<div class="invoice_section_table">
			<table class="table table-hover invoice_table">
				<thead>
				<tr>
					<th>Описание</th>
					<th>Кол-во</th>
					<th>Цена за ед.</th>
					<th>Скидка за ед.</th>
					<th>Цена со скидкой</th>
				</tr>
				</thead>
				<tbody>
				<tr>
					<td><?=$good['title']?></td>
					<td><?=$order['quantity']?></td>
					<td><?=$order['amount']?>$</td>
					<td class=" "><?=$order['discount_amount']?> BP</td>
					<td><?=$order['amount'] - $order['discount_amount']?> BP</td>
				</tr>
				</tbody>
			</table>

			<div class="table_sum">
				<div class=" ">
					Сумма:<span><span><?=$sum?></span> <span>BP</span></span>
				</div>
				<div class=" ">
					Скидка (<?=$order['discount_percent']*100?>%):<span><span><?=$discount?></span> <span>BP</span></span>
				</div>
				<div class=" ">
					Комиссия (0%):<span><span>0</span> <span>BP</span></span>
				</div>
				<div class="invoice_section_sum">
					Всего:<span><span><?=$sum_topay?></span> <span>BP</span></span>
				</div>
			</div>

			<div class="invoice_section_footer">
				<select id="wallets-my" class=""></select>
				<a rel="<?=$order['id']?>" class="button invoice-order-pay" href="#">Оплатить</a>
			</div>
		</div>
	</div>
</div>

<script type="application/javascript">

	$(document).ready(function () {
		getWallets();
	});

	function getWallets(){
		$.ajax({
			type: 'POST',
			url: '/wallet/getwalletsmy',
			dataType: 'json',
			success: function(results) {
				if(results.wallet != null){
					$('#wallets-my').append('<option rel="'+results.wallet.cash_now+'" value="'+results.wallet.id+'">Ативный бонус ('+round2(results.wallet.cash_now, "format")+' BP)</option>');
				}else{
					message_info('Просмотр данных временно запрещен.');
				}
			}
		});
	}

</script>