<?php
$connection = Yii::app()->db;

$info = $connection->createCommand("SELECT uid, alias, package FROM {{usersinfo}} WHERE uid = :uid AND status = 1 AND package > 0")
	->bindParam(":uid", Yii::app()->user->id)
	->queryRow();

$is_access = $connection->createCommand("SELECT r.id, r.uid, a.name FROM {{control_rules}} r INNER JOIN {{control_actions}} a ON a.id = r.action_id WHERE r.uid = :uid AND a.action = :action AND r.status = 1")
	->bindParam(":uid", Yii::app()->user->id)
	->bindParam(":action", Yii::app()->controller->action->id)
	->queryRow();

if (Yii::app()->user->isGuest || empty($info) || empty($is_access)) {
	header('Location: /' . $info["alias"]);
	Yii::app()->end();
}
?>
<!DOCTYPE html>
<html>
	<head>
		<title>Управление - <?=$is_access['name']?></title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=1024" initial-scale="1">

		<meta http-equiv="cleartype" content="on">
		<meta name="format-detection" content="telephone=no">
		<meta name="format-detection" content="address=no">

		<link href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap3-dialog/1.34.7/css/bootstrap-dialog.min.css" rel="stylesheet" type="text/css" />
		<link rel="stylesheet" href="/css/font-awesome.min.css">
		<link rel="stylesheet" href="/css/main.css">
		<link rel="stylesheet" href="/css/post.css" />
		<link rel="stylesheet" href="/css/comment.css" />
		<link rel="stylesheet" href="/css/aside.css" />
		<link rel="stylesheet" href="/css/style.css"/>
		<link rel="stylesheet" href="/css/modal.css"/>
		<link rel="stylesheet" href="/css/settings.css"/>
		<link href="/plugins/toastr/toastr.min.css" rel="stylesheet" type="text/css"/>
		<link rel="stylesheet" href="/css/elements.css"/>
		<link rel="stylesheet" href="/css/wallet.css"/>
		<link rel="stylesheet" href="/css/tampletes.css"/>
		<link rel="stylesheet" href="/css/bootstrap.css"/>
		<link rel="stylesheet" href="/css/bootstrap-dialog.min.css"/>
		<link rel="stylesheet" href="/css/font-awesome.min.css"/>
		<link rel="stylesheet" href="/css/main.css"/>
		<link rel="stylesheet" href="/css/select2.min.css"/>
		<link rel="stylesheet" href="/css/control.css"/>

		<script src="https://code.jquery.com/jquery-1.9.1.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.5/js/bootstrap.min.js"></script>
		<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap3-dialog/1.34.7/js/bootstrap-dialog.min.js"></script>

		<!--<link rel="stylesheet/less" type="text/css" href="less/new.less" />
		<script src="less.js" type="text/javascript"></script> -->

		<link rel="stylesheet" href="/css/queries.css" />
		<!--[if lt IE 9]>
			<script src="http://html5shiv.googlecode.com/svn/trunk/html5.js"></script>
		<![endif]-->

		<script src="/plugins/toastr/toastr.min.js"></script>
		<script src="/js/jquery.Jcrop.js"></script>
		<script src="/js/jquery.SimpleCropper.js"></script>
		<script src="/js/moment.min.js"></script>
		<script src="/js/jquery.emotions.js"></script>
		<script src="/js/jquery.visible.js"></script>
		<script src="/js/jquery.cookie.js"></script>
		<script src="/js/select2.full.js"></script>
		<script src="/js/jquery-ui.min.js"></script>
		<script src="/js/jquery.blockUI.js"></script>
		<script src="/js/readmore.js"></script>
		<script src="/js/linkify.min.js"></script>
		<script src="/js/linkify-jquery.min.js"></script>
		<script src="/js/jquery.glide.js"></script>
		<script src="/js/underscore.js"></script>
		<script src="/js/functions.js"></script>
		<script src="/js/post.js"></script>
		<script src="/js/market.js"></script>
		<script src="/js/settings.js"></script>
		<script src="/js/additional.js"></script>
		<script src="/js/accounting.min.js"></script>
		<script src="/js/countdown.js"></script>
		<script src="/js/bonus.js"></script>
		<script src="/js/he.js"></script>
	</head>
	<body style="min-width: 1024px">
		<header>
			<div class="wrap">
				<div class="container">
					<div class="row">
						<div class="col-sm-3">
							<a href="#" class="logo"><img src="/images/logo.png" alt="logo"></a>
						</div>
						<div class="col-sm-9 xs-hidden">
							<div class="header_menu">
								<span>
									<a href="/market"><img src="/images/header_menu.png" alt="logo"></a>
								</span>
							</div>
							<form name="search" action="/feed" method="POST"  class="form-inline">
								<div class="form-group">
									<label class="sr-only" for="exampleInputAmount">Что Вас итнересует?</label>
									<div class="input-group" style="border-right:1px solid #1a6389;">
										<input type="text" name="find" class="form-control" id="exampleInputAmount" placeholder="Что Вас итнересует?">
										<div class="input-group-addon" style="display: none;"><img src="/images/keyboard.png" alt="logo"></div>
									</div>
									<button type="submit" class="button">
										<i class="fa fa-search"></i>
									</button>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
			<div class="container">
				<div class="row">
					<div class="col-sm-12">
						<nav>
							<ul class="list-unstyled list-inline">
								<li class="nav nav-page-wall active">
									<a href="/feed">Главная</a>
								</li>
								<li class="nav nav-page-packages">
									<a href="/packages">Подписка</a>
								</li>
								<li class="nav nav-page-invite">
									<a href="/page/invite">Инвайты</a>
								</li>
								<li class="nav nav-page-users">
									<a href="/users">Пользователи</a>
								</li>
								<li class="nav nav-groups-index">
									<a href="/groups">Группы</a>
								</li>
								<li class="nav nav-market-index">
									<a href="/market">Товары</a>
								</li>
								<li class="nav nav-page-settings">
									<a href="/user/settings">Настройки</a>
								</li>
								<li>
									<a href="/logout">Выйти</a>
								</li>
							</ul>
						</nav>
					</div>
				</div>
			</div>
		</header>
		<div class="container">
			<div class="row">
				<div class="col-sm-12 settings" style="display: block;">
					<section  class="settings_in">
						<div class="settings_header">
							<?php

							$actions = $connection->createCommand("SELECT a.* FROM {{control_actions}} a INNER JOIN {{control_rules}} r ON a.id = r.action_id AND r.uid = :uid AND r.status = 1")
								->bindParam(":uid", Yii::app()->user->id)
								->queryAll();

							foreach($actions as $action){ ?>
								<a href="/control/<?=$action['action']?>">
									<div class="tab rel-<?=$action['action']?>">
										<?=$action['name']?>
									</div>
								</a>
							<?php } ?>

						</div>
						<div class="tab-block">
							<?php echo $content; ?>
						</div>
					</section>
				</div>
			</div>
		</div>
		<footer>
			<div class="container">
				<p>Все права защищены &copy; 2016</p>
			</div>
		</footer>
	</body>
<script type="application/javascript">
	$(document).ready(function(){
		$('.settings_header .tab').removeClass('active');
		$('.settings_header .rel-<?=Yii::app()->controller->action->id?>').addClass('active');
	})
</script>
</html>