<?php
/* @var $this MarketController */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/select2.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/jquery.Jcrop.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/project_goods.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/p_projects_ex.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/gr_search.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/add_good.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/wallet.css'); //Кошельки

$connection = Yii::app()->db;

$my = $connection->createCommand("SELECT uid, marital_status, CONCAT(name, ' ', fio) AS 'full_name', tel, sex, skype, city, interests, activities, about, photo, alias, status, online FROM {{usersinfo}} WHERE uid = :uid")
	->bindParam(":uid", Yii::app()->user->id)
	->queryRow();
?>

<?php $this->widget('SideBarWidget', array(
	'my' => $my
)); ?>

<div class="col-sm-8 add_good">
	<section class="add_good_block">
		<div class="add_good_header">
			<div class="active">
				Добавление товара
			</div>
		</div>

		<div class="add_good_in">
			<a class="add_good_img" href="#" onclick="$('#good_photo').click();" data-photo="">
				<span class="upload_photo_span">Загрузить фотографию</span>
			</a>
			<form id="goodPhotoForm" action="#" method="POST" enctype="multipart/form-data" style="display: block;">
				<input class="file" type="file" size="28"
				       onchange="uploadGoodPhoto($(this).get(0).files[0]);" name="good_photo"
				       id="good_photo" style="visibility: hidden; position: absolute;">
			</form>

			<div class="add_good_form">
				<form name="good_form" id="good-form" action="/market/add" method="post">
					<div class="form-group">
						<label for="good_category">Категория*</label>
						<select id="good_category" class="form-control post-category" style="display: none;" required></select>
					</div>
					<div class="form-group">
						<label for="title">Название товара/услуги*</label>
						<input type="text" placeholder="Введите название" id="title" class="form-control" required>
					</div>
					<div class="form-group">
						<label for="text">Полное описание*</label>
						<textarea placeholder="Полное описание" id="text" class="exampletext form-control" required></textarea>
					</div>
					<div class="form-group">
						<label for="type">Определите тип вашего объявления*</label>
						<select id="type" class="form-control" required>
							<option value="1" selected="selected">Товар</option>
							<option value="2">Услуга</option>
						</select>
					</div>
					<div class="form-group">
						<label for="condition">Состояние*</label>
						<select id="condition" class="form-control" required>
							<option value="1" selected="selected">Новое</option>
							<option value="2">б/у</option>
						</select>
					</div>
<!--					<div class="form-group">-->
<!--						<label for="price">Цена в долларах*</label>-->
<!--						<input type="text" placeholder=" " id="price" class="form-control number_only" required>-->
<!--					</div>-->
<!--					<div class="form-group">-->
<!--						<label for="discount">Скидка (от 10%)*</label>-->
<!--						<input type="text" placeholder="10%" id="discount" class="form-control number_only" required>-->
<!--					</div>-->
					<div class="form-group">
						<label for="discount_price">Полная стоимость (USD)*</label>
						<input type="text" placeholder="Полная стоимость" id="discount_price" class="form-control number_only" required>
					</div>
					<div class="form-group">
						<label for="delivery">Оплата и доставка*</label>
						<textarea placeholder="Перечислите се условия оплаты и доставки" id="delivery" class="form-control exampletext2" required></textarea>
					</div>
					<div class="form-group">
						<label for="country">Страна*</label>
						<select class="form-control js-data-ajax-country" id="country" required>
							<option value="0" title="Не выбрана">Не выбрана</option>
						</select>
					</div>
					<div class="form-group">
						<label for="city">Город</label>
						<select class="form-control js-data-ajax-city" id="city">
							<option value="0" title="Не выбран">Не выбран</option>
						</select>
					</div>

					<input type="submit" class="button good-add" value="Отправить">
				</form>
			</div>
		</div>
	</section>
</div>
<script type="application/javascript">
	$(document).ready(function () {
		$(document).ready(function() {

			$('body').on('change', '#country', function () {
				$('#city').val(-1);
				$('#select2-city-container').html('Выберите город...');
			});

			$(".js-data-ajax-city").select2({
				ajax: {
					url: "/ajax/cities",
					type: 'POST',
					dataType: 'json',
					delay: 250,
					data: function (params) {
						return {
							q: params.term,
							id: $('#country').val()
						};
					},
					processResults: function (data, params) {
						params.page = params.page || 1;
						return {
							results: data.cities,
							pagination: {
								more: (params.page * 30) < data.total_count
							}
						};
					},
					cache: true
				},
				escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
				minimumInputLength: 2,
				templateResult: formatRepo, // omitted for brevity, see the source of this page
				templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
			});

			$('body').on('submit', '#good-form', function () {
				event.preventDefault();

				var err = '';

				var category = $('#good_category').val();
				var title = $('#title').val();
				var text = $('#text').val();
				var type = $('#type').val();
				var condition = $('#condition').val();
//				var price = $('#price').val();
//				var discount = $('#discount').val();
				var discount_price = $('#discount_price').val();
				var delivery = $('#delivery').val();
				var country = $('#country').val();
				var city = $('#city').val();
				var photo = $('.add_good_img').attr('data-photo');

				if(category <= 0){
					err += '<p>Необходимо указать категорию.</p>';
				}
				if(title == ''){
					err += '<p>Необходимо указать название товара/услуги.</p>';
				}
				if(title.length > 250){
					err += '<p>Название товара/услуги не может превышать 250 символов.</p>';
				}
				if(text == ''){
					err += '<p>Необходимо указать полное описание.</p>';
				}
				if(text.length > 5000){
					err += '<p>Полное описание не может превышать 5000 символов.</p>';
				}
				if(!(type == 1 || type == 2)){
					err += '<p>Необходимо указать тип вашего объявления.</p>';
				}
				if(!(condition == 1 || condition == 2)){
					err += '<p>Необходимо указать cостояние.</p>';
				}
//				if((price <= 0) || !/^([0-9]+([.][0-9]{2})?)$/g.test(price)){
//					err += '<p>Поле "Цена" указано неверно.</p>';
//				}
//				if(discount < 10){
//					err += '<p>Минимальная скидка 10%</p>';
//				}
//				if(discount > 100){
//					err += '<p>Максимальная скидка 100%</p>';
//				}
				if((discount_price <= 0) || !/^([0-9]+([.][0-9]{1,2})?)$/g.test(discount_price)){
					err += '<p>Поле "Полная стоимость" указано неверно.</p>';
				}
				if(delivery == ''){
					err += '<p>Необходимо указать оплату и доставку.</p>';
				}
				if(country <= 0){
					err += '<p>Необходимо указать страну.</p>';
				}
				if(photo == ''){
					err += '<p>Необходимо загрузить изображение.</p>';
				}

				if (err == '') {
					$.ajax({
						url: '/market/goodadd',
						type: 'POST',
						dataType: 'json',
						data: {
							category: category,
							title: title,
							text: text,
							type: type,
							condition: condition,
//							price: price,
//							discount: discount,
							discount_price: discount_price,
							delivery: delivery,
							country: country,
							city: city,
							photo: photo
						},
						success: function (results) {
							if (results.status == 200 && results.good) {
								window.location.replace("/market/"+results.good.gid);
							} else {
								error(results.message);
							}
						}
					});
				} else {
					error(err);
					return false;
				}

				return false;
			});

//			$('.number_only').bind("change keyup input click", function() {
//				if (this.value.match(/[^0-9]/g)) {
//					this.value = this.value.replace(/[^0-9]/g, '');
//				}
//			});

			$('#discount').bind("change keyup input click", function() {
				var value = $(this).val();
				if(value < 10) $(this).val(10);
				if(value > 100) $(this).val(100);
			});

			$('#cash').bind("change keyup input click", function() {
				var value = $(this).val();
				if(value < 0) $(this).val(0);
				if(value > 50) $(this).val(50);
			});
		});

		getPostCategories();
	});
</script>