<?php

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/project_goods.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/p_projects_ex.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/modal.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/select2.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/filter.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/tampletes.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/group.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/elements.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/my_goods.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/invoice.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . ' /css/wallet.css'); //Кошельки

$connection = Yii::app()->db;
$merchant_id = intval($_GET['id']);

if(Yii::app()->user->isGuest){
    Yii::app()->request->cookies['redirect_page'] = new CHttpCookie('redirect_page', '/merchant/'.$merchant_id);
    $this->redirect('/login');
}

unset(Yii::app()->request->cookies['redirect_page']);

$merchant = $connection->createCommand("SELECT * FROM {{merchant}} WHERE id = :id AND uid = :uid AND status = 0")
    ->bindParam(":uid", Yii::app()->user->id)
    ->bindParam(":id", $merchant_id)
    ->queryRow();

$start_date = strtotime(date('Y-m-01 00:00:00'));
$month_amount = $connection->createCommand("SELECT COALESCE(SUM(amount),0) FROM {{utransactions2}} WHERE uid = :uid AND status = 1 AND type = 0 AND action = 41 AND date > :start_date AND date < :end_date")
    ->bindParam(":uid", Yii::app()->user->id)
    ->bindParam(":start_date", $start_date)
    ->bindParam(":end_date", time())
    ->queryScalar();
    
$user_from = $connection->createCommand("SELECT verify FROM {{usersinfo}} WHERE uid = :uid AND type = 1 AND status = 1")->bindParam(":uid", Yii::app()->user->id)->queryRow();

$percent = Merchant::getTax($month_amount+$merchant['pay_amount']);
if($user_from["verify"] == 1)
    $percent = 0;

if(empty($merchant) || $percent < 0) {
	$this->redirect('/feed');
	return;
}

$merchant_system = $connection->createCommand("SELECT * FROM {{merchant_system}} WHERE id = :id")
    ->bindParam(":id", $merchant['merchant'])
    ->queryRow();
if(empty($merchant_system)) {
	$this->redirect('/feed');
	return;
}

$my = $connection->createCommand("SELECT uid, CONCAT(name, ' ', fio) as 'full_name', tel, skype, photo, country, city, alias FROM {{usersinfo}} WHERE uid = :uid")
    ->bindParam(":uid", Yii::app()->user->id)
    ->queryRow();

if(!empty($my['country'])){
    $country = Loc::getCountryById($my['country']);
    $my['country_name_ru'] = $country['title'];
}
if(!empty($my['city'])){
    $city = Loc::getCityById($my['city']);
    $my['city_name_ru'] = $city['title'];
}
?>

<?php $this->widget('SideBarWidget', array(
    'my' => $my
)); ?>

<div class="col-sm-8 invoice">
    <div class="section invoice_section">
        <div class="row">
            <div class="col-md-4">
                <div class="invoice_section_header">
                    Отправитель
                </div>
                <div class="invoice_section_content"></span>
                    <span><?=$my['full_name']?></span> <span> <?=$my['country_name_ru']?><?= !empty($my['country']) && !empty($my['city']) ? ', ' : ''?><?=$my['city_name_ru']?></span>
                </div>
            </div>

            <div class="col-md-4">
                <div class="invoice_section_header">
                    Получатель
                </div>
                <div class="invoice_section_content">
                    <span><?=$merchant_system['name']?></span> <span></span> <span>Кошелек: </span>
                </div>
            </div>

            <div class="col-md-4">
                <div class="invoice_section_header">
                    Номер заказа
                    <span><?=$merchant['id']?></span>
                </div>
                <div class="invoice_section_content">
                    <div>
                        <span>Дата оплаты:</span>
                        <span><?=date("d-m-Y")?></span>
                    </div>
                    <div>
                        <span>Оплатить до:</span>
                        <span><?=date('d-m-Y', strtotime('+7 days'))?></span>
                    </div>
                </div>
                <div class="invoice_section_sum">
                    Сумма к оплате:<span><span class="merchant-total-sum"><?=$merchant['pay_amount']?></span> <span>USD</span></span>
                </div>
            </div>

            <div class="col-md-8">
                <div class="invoice_section_header">
                    Описание
                </div>
                <div class="invoice_section_dicr">Операции с активными бонусами</div>
            </div>
        </div>

        <div class="invoice_section_table">
            <table class="table table-hover invoice_table">
                <thead>
                <tr>
                    <th>Описание</th>
                    <th>Кол-во</th>
                    <th>Цена за ед.</th>
                    <th>Стоимость</th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td><?=$merchant['pay_description']?></td>
                    <td>1</td>
                    <td></td>
                    <td><?=$merchant['pay_amount']?></td>
                </tr>
                </tbody>
            </table>

            <div class="table_sum">
                <div class=" ">
                    Сумма:<span><span><?=$merchant['pay_amount']?></span> <span>USD</span></span>
                </div>
                <div class=" ">
                    Комиссия (<?=$percent?>%):<span><span><?=round(($percent*$merchant['pay_amount'])/100, 2)?></span> <span>USD</span></span>
                </div>
                <div class="invoice_section_sum">
                    Всего:<span><span><?=round((($percent*$merchant['pay_amount'])/100)+$merchant['pay_amount'], 2)?></span> <span>USD</span></span>
                </div>
            </div>

            <div class="invoice_section_footer">
                <select id="wallets-my" class=""></select>
                <a rel="<?=$merchant['id']?>" class="button merchant-start-pay" href="#">Оплатить</a>
                <a class="button-cancel" href="<?=$merchant_system['url']?>">Отмена</a>
            </div>
        </div>
    </div>
</div>

<script type="application/javascript">

    $(document).ready(function () {
        getWallets();

        $('body').on('click', '.merchant-start-pay', function () {
            var bonus = parseFloat($('option:selected', '#wallets-my').attr('rel'));
            var merchant_id = $(this).attr('rel');
            var err = '';

            var amount = parseFloat($('.merchant-total-sum').html());

            if (amount < 1 || amount > bonus) {
                err += '<p>На вашем счету недостаточно средств для выполнения операции.</p>';
            }

            if (err == '') {
                BootstrapDialog.show({
                    title: 'Информационное сообщение',
                    message: 'Вы подтверждаете оплату?',
                    animate: false,
                    buttons: [
                        {
                            label: 'Подтвердить',
                            cssClass: 'btn-success',
                            action: function (dialogItself) {
                                $.ajax({
                                    url: '/merchant/setmerchantstartpay',
                                    type: 'POST',
                                    dataType: 'json',
                                    data: {
                                        merchant_id: merchant_id
                                    },
                                    success: function (results) {
                                        if (results.status == 200 && results.redirect != '') {
                                            BootstrapDialog.show({
                                                title: 'Информационное сообщение',
                                                message: results.message,
                                                animate: true,
                                                closable: true,
                                                buttons: [
                                                    {
                                                        label: 'Закрыть',
                                                        action: function (dialogItself) {
                                                            window.location.replace(results.redirect);
                                                        }
                                                    }]
                                            });
                                            setTimeout(
                                                function () {
                                                    window.location.replace(results.redirect);
                                                }, 5000);
                                        } else {
                                            message_info(results.message);
                                        }
                                    }
                                });
                                dialogItself.close();
                            }
                        },
                        {
                            label: 'Отмена',
                            action: function (dialogItself) {
                                dialogItself.close();
                            }
                        }]
                });
            } else {
                message_info(err);
                return false;
            }
        });
    });

    function getWallets(){
        $.ajax({
            type: 'POST',
            url: '/wallet/getwalletsmy',
            dataType: 'json',
            success: function(results) {
                if(results.wallet != null){
                    $('#wallets-my').append('<option rel="'+results.wallet.cash_now+'" value="'+results.wallet.id+'">Ативный бонус ('+round2(results.wallet.cash_now, "format")+' BP)</option>');
                }else{
                    message_info('Просмотр данных временно запрещен.');
                }
            }
        });
    }

</script>