<?php

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/group.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/friends.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/select2.min.css');

$connection = Yii::app()->db;

$subscribers_count = $connection->createCommand("SELECT COUNT(*) FROM {{friends}} WHERE fuid = :uid AND status = 0")->bindParam(":uid", Yii::app()->user->id)->queryScalar();

$alias = mysql_escape_string(htmlspecialchars(strip_tags($_POST["alias"])));
$user_info = !empty($alias) ? $connection->createCommand("SELECT uid, alias, CONCAT(name, ' ', fio) as fio FROM {{usersinfo}} WHERE alias = :alias")->bindParam(":alias", $alias)->queryRow() : $connection->createCommand("SELECT * FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
?>

<div class="col-sm-4">
    <section class="friends_search">
        <div class="friends_search_header">
            Поиск друзей
        </div>
        <div class="friends_search_content">
            <form name="" action="" method="">
                <div class=" ">
                    <div class="form-group">
                        <label for="search_query">Имя:</label>
                        <input type="text" class="form-control" id="search_query" placeholder=" ">
                    </div>

                    <div class="form-group">
                        <label for="country">Страна:</label>
                        <select class="form-control js-data-ajax-country" id="country">
                            <option value="0" title="Не выбрана">Не выбрана</option>
                        </select>
                    </div>

                    <div class="form-group" style="display: none">
                        <label for="city">Город:</label>
                        <select class="form-control js-data-ajax-city" id="city">
                            <option value="-1" title="Не выбран">Не выбран</option>
                        </select>
                    </div>

                    <div class="form-group">
                        <label>Возраст:</label>
                        <select class="age_from" id="age-from">
                            <option value="-1">От</option>
                            <?php for ($i = 14; $i < 81; $i++) { ?>
                                <option value="<?= $i ?>">от <?= $i ?></option>
                            <?php } ?>
                        </select>

                        <select class="age_till" id="age-to">
                            <option value="-1">До</option>
                            <?php for ($i = 14; $i < 81; $i++) { ?>
                                <option value="<?= $i ?>">до <?= $i ?></option>
                            <?php } ?>
                        </select>
                    </div>

                    <div class="form-group">
                        <label for="sex">Пол:</label>
                        <select class="form-control" id="sex">
                            <option value="1">Женский</option>
                            <option value="2">Мужской</option>
                            <option value="0" selected>Любой</option>
                        </select>
                    </div>

                    <div class="form-group marital-status" style="display: none;">
                        <label for="marital_status">Семейное положение:</label>
                        <select class="form-control" id="marital_status">
                            <option value="-1" selected>Любое</option>
                        </select>
                    </div>
                </div>
            </form>
        </div>
    </section>
</div>
<div class="col-sm-8 friends">
    <section class="friends_in">
        <div class="friends_header">
            <?php if($user_info['uid'] == Yii::app()->user->id){ ?>
                <a href="/users" class="tab">Пользователи</a>
                <a href="/friends" class="tab active">Мои друзья</a>
                <a href="/subscribers" class="tab">Входящие заявки <?=!empty($subscribers_count) ? '(+'.$subscribers_count.')' : ''?></a>
                <a href="/subscribersmy" class="tab">Исходящие заявки</a>
                <a href="/blacklist" class="tab">Чёрный список</a>
            <?php }else{ ?>
                <a href="/friends?alias=<?=$alias?>" class="tab active">Друзья пользователя <?=$user_info['fio']?></a>
            <?php } ?>
        </div>
        <div class="friends_content" id="search-result">

        </div>
    </section>
</div>

<script type="application/javascript">
    var processing = false;
    var page = 1;

    $(document).ready(function () {

        $(document).scroll(function () {
            myFriendsFilter(page);
        });

        $('select#age-from').change(function () {
            var age_from = $(this).val();
            var html = '';
            var age_to = $('#age-to').val();
            $('#age-to').empty();
            html += '<option value="-1">До</option>';
            for (var i = age_from > 0 ? age_from : 14; i < 81; i++) {
                html += '<option value="' + i + '">до ' + i + '</option>';
            }
            $('#age-to').append(html).val(age_to);
            page = 1;
            myFriendsFilter(1, true);
        });

        $('select#age-to').change(function () {
            var age_to = $(this).val();
            var html = '';
            var age_from = $('#age-from').val();
            $('#age-from').empty();
            html += '<option value="-1">От</option>';
            for (var i = 14; i <= (age_to > 0 ? age_to : 80); i++) {
                html += '<option value="' + i + '">от ' + i + '</option>';
            }
            $('#age-from').append(html).val(age_from);
            page = 1;
            myFriendsFilter(1, true);
        });

        $('#city, #marital_status, #sex').change(function () {
            myFriendsFilter(1, true);
        });

        $('#country').change(function () {
            var country = $(this);

            $.when(myFriendsFilter(1, true)).done(function () {
                if (country.val() && country.val() > 0) {
                    $('#city').empty();
                    $('#select2-city-container').html('');
                    $('#city').closest('.form-group').show(200);

                    $.ajax({
                        url: '/ajax/cities',
                        type: 'POST',
                        dataType: 'json',
                        data: {
                            id: country.val()
                        },
                        success: function (results) {
                            if (results.status == 200 && results.cities) {
                                var text = '';
                                text += '<option value="-1">Выбор города</option>';
                                $.each(results.cities, function (key, city) {
                                    text += '<option value="' + city.city_id + '">' + city.city_name_ru + '</option>';
                                });
                                $('#city').append(text);
                            }
                        }
                    });

                    $('.city-block').show(200);
                } else {
                    $('.city-block').hide(200);
                    $('#city').closest('.form-group').hide(200);
                }
            });
        });

        $('#search_query').on('keyup', function(e) {
            e.preventDefault();
            e.stopPropagation();
            if(e.which !== 0 || $(this).val() == '' || e.which == 8){
                var text = $(this).val();
                if( (text != '' && text.length >= 3) || text == ''){
                    myFriendsFilter(1, true);
                }
            }
        });

        $('body').on('click', '.friend-delete', function () {
            event.preventDefault();
            var elem = $(this);
            var uid = $(this).attr('data-uid');

            BootstrapDialog.show({
                title: 'Подтверждение',
                message: 'Удалить пользователя из друзей?',
                animate: false,
                buttons: [
                    {
                        label: 'Подтвердить',
                        cssClass: 'btn-success',
                        action: function (dialogItself) {

                            $.ajax({
                                url: '/user/frienddelete',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    uid: uid
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        $(elem).closest('.friends_block').remove();
                                    } else {
                                        message_info(results.message);
                                    }
                                }
                            });
                            dialogItself.close();
                        }
                    },
                    {
                        label: 'Отмена',
                        action: function (dialogItself) {
                            dialogItself.close();
                        }
                    }]
            });
        });

        $(".js-data-ajax-city").select2({
            ajax: {
                url: "/ajax/cities",
                type: 'POST',
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        q: params.term,
                        id: $('#country').val()
                    };
                },
                processResults: function (data, params) {
                    params.page = params.page || 1;
                    return {
                        results: data.cities,
                        pagination: {
                            more: (params.page * 30) < data.total_count
                        }
                    };
                },
                cache: true
            },
            escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
            minimumInputLength: 2,
            templateResult: formatRepo, // omitted for brevity, see the source of this page
            templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
        });

        myFriendsFilter(1, true);
    });

    function myFriendsFilter(p, forseLoad) {
        if (processing && !forseLoad) return false;

        var req = null;
        if (($(window).scrollTop() >= $(document).height() - $(window).height() - 700) || forseLoad) {
            processing = true;

            var country = $('#country').val();
            var city = $('#city').val();
            var sex = $('#sex').val();
            var marital_status = $('#marital_status').val();
            var age_from = $('#age-from').val();
            var age_to = $('#age-to').val();
            var search_query = $('#search_query').val();

            if(search_query != '' && search_query.length <= 2) {
                return false;
            }

            if (req != null) req.abort();
            if (forseLoad) $('#search-result').empty();
                req = $.ajax({
                    url: '/user/myfriendsfilter',
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        page: p,
                        country: country,
                        city: city,
                        sex: sex,
                        marital_status: marital_status,
                        age_from: age_from,
                        age_to: age_to,
                        search_query: search_query,
                        alias: '<?=$user_info['alias']?>'
                    },
                    success: function (results) {
                        if (results.status == 200) {
                            processing = results.users.length == 0;

                            if (results.users) {
                                $.each(results.users, function (key, val) {
                                    var html =  '<div class="friends_block">' +
                                    '<a href="/' + val.alias + '" class="friends_block_avatar">' +
                                    '<img src="http://' + val.photo + '_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';">' +
                                    '</a>' +
                                    '<h3>' +
                                    '<a href="/' + val.alias + '">' + val.name + ' ' + val.fio + '</a>' +
                                    '</h3>' +
                                    '<div class="time status" data-online="' + f_online_status(val.online) + '"></div>';
                                    <?php if($user_info['uid'] == Yii::app()->user->id){ ?>
                                        html += '<a href="#" class="friends_block_btn friend-delete" data-uid="' + val.uid + '">Убрать из друзей</a>';
                                    <?php } ?>

                                    html += '</div>';
                                    $('#search-result').append(html);
                                });
                            }
                            $('#search-result').show(200);
                        } else {
                            processing = true;
                        }
                    }
                });
            page = p + 1;
        }
    }
</script>