<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/answers.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/comments.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/style.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/answers.css');

$connection = Yii::app()->db;

$notifications = $connection->createCommand("SELECT COUNT(*) FROM {{events}} WHERE uid = :uid AND status = 0 AND (type = 4 OR type = 5 OR type = 6 OR type = 7)")
	->bindParam(":uid", Yii::app()->user->id)
	->queryScalar();

$connection->createCommand("UPDATE {{events}} SET status = 1 WHERE uid = :uid AND (type = 2 OR type = 3)")
	->bindParam(":uid", Yii::app()->user->id)
	->query();

$my = $connection->createCommand("SELECT u.uid, u.online, u.sex, CONCAT(u.name, ' ', u.fio) as 'full_name', u.tel, u.skype, u.city, u.interests, u.activities, u.about, u.photo, u.alias FROM {{usersinfo}} u WHERE u.uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
?>

<?php $this->widget('SideBarWidget', array(
	'my' => $my
)); ?>

<div class="col-sm-8 answers">
	<section class="answers_in">
		<div class="answers_header">
			<a href="#" class="tab active" rel="notifications_all">Все уведомления</a>
			<a href="#" class="tab" rel="notifications_answers">Ответы и комментарии<?=(!empty($notifications) ? ' (+'.$notifications.')' : '')?></a>
		</div>
		<div class="answers_content answers_body tab-block notifications_all" style="display: block;">
			<div class="notifications_container"></div>
		</div>
		<div class="answers_content answers_body tab-block notifications_answers" style="display: none;">
			<div class="answers_container"></div>
		</div>
	</section>
</div>

<script type="application/javascript">

var processingNotification = false;
var processingAnswer = false;
var pageNotification = 1;
var pageAnswer = 1;

$(document).ready(function () {

    $('body').on('click', '.friend-add', function () {
        event.preventDefault();
        var elem = $(this);
        var uid = $(this).attr('data-uid');

        BootstrapDialog.show({
            title: 'Подтверждение',
            message: 'Добавить пользователя в друзья?',
            animate: false,
            buttons: [
                {
                    label: 'Подтвердить',
                    cssClass: 'btn-success',
                    action: function (dialogItself) {

                        $.ajax({
                            url: '/user/friendadd',
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                uid: uid
                            },
                            success: function (results) {
                                if (results.status == 200) {
                                    $(elem).closest('.answers_block').remove();
                                } else {
                                    message_info(results.message);
                                }
                            }
                        });
                        dialogItself.close();
                    }
                },
                {
                    label: 'Отмена',
                    action: function (dialogItself) {
                        dialogItself.close();
                    }
                }]
        });
    });

    $('body').on('click', '.friend-leave-in-subscribers', function () {
        event.preventDefault();
        var elem = $(this);
        var uid = $(this).attr('data-uid');

        BootstrapDialog.show({
            title: 'Подтверждение',
            message: 'Оставить пользователя в подписчиках?',
            animate: false,
            buttons: [
                {
                    label: 'Подтвердить',
                    cssClass: 'btn-success',
                    action: function (dialogItself) {

                        $.ajax({
                            url: '/user/friendleavesubscribed',
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                uid: uid
                            },
                            success: function (results) {
                                if (results.status == 200) {
                                    $(elem).closest('.answers_block').remove();
                                } else {
                                    message_info(results.message);
                                }
                            }
                        });
                        dialogItself.close();
                    }
                },
                {
                    label: 'Отмена',
                    action: function (dialogItself) {
                        dialogItself.close();
                    }
                }]
        });
    });

    $('body').on('click', '.friend-cancel', function () {
        event.preventDefault();
        var elem = $(this);
        var uid = $(this).attr('data-uid');

        BootstrapDialog.show({
            title: 'Подтверждение',
            message: 'Отменить заявку пользователя на добавление Вас в друзья?',
            animate: false,
            buttons: [
                {
                    label: 'Подтвердить',
                    cssClass: 'btn-success',
                    action: function (dialogItself) {

                        $.ajax({
                            url: '/user/friendcancel',
                            type: 'POST',
                            dataType: 'json',
                            data: {
                                uid: uid
                            },
                            success: function (results) {
                                if (results.status == 200) {
                                    $(elem).closest('.answers_block').remove();
                                } else {
                                    message_info(results.message);
                                }
                            }
                        });
                        dialogItself.close();
                    }
                },
                {
                    label: 'Отмена',
                    action: function (dialogItself) {
                        dialogItself.close();
                    }
                }]
        });
    });

	$(document).scroll(_.debounce(function () {
		var rel = $('.tab.active').attr('rel');
		if(rel == 'notifications_all'){
			getNextNotifiction(pageNotification);
		}else{
			getNextAnswer(pageAnswer);
		}

	}, 300));

	$('body').on('click', '.emotion_smile', function () {
		event.preventDefault();
		var id = $(this).data('id');
		$(this).closest('.comment_form').find('.message-content').append('(s:'+id+')').emotions();
	});

	$('body').on('click', '.answers_block_comment', function () {
		var id = $(this).attr('data-id');
		var name = $(this).attr('data-name');

		$('.messages_footer').hide();
		$('#replay_'+id).toggle().find('.message-content').html(name+',&nbsp;').focus;
		f_caret(document.getElementById('reply_field_'+id));
	});

	$('body').on('click', '.tab', function () {
		var rel = $(this).attr('rel');
		$('.tab').removeClass('active');
		$(this).addClass('active');

		$('.tab-block').hide();
		$('.'+rel).show();
		if(rel == 'notifications_answers'){
			getNextAnswer(pageAnswer, true);
		}
	});

	getNextNotifiction(1, true);
	getSubscribers(<?=$my['uid']?>);
	getGroups(<?=$my['uid']?>);
});

function getNextNotifiction(p, forseLoad) {
	if (processingNotification) return false;

	if (($(window).scrollTop() >= $(document).height() - $(window).height() - 700) || forseLoad) {
		processingNotification = true;

		$.ajax({
			url: '/ajax/notificationgetnext',
			type: 'POST',
			dataType: 'json',
			data: {
				page: p
			},
			success: function (results) {
				if (results.status == 200) {
					processingNotification = results.notifications.length == 0;
					for (var i = 0; i < results.notifications.length; i++) {
						$('.notifications_container').before(generateNotification(results.notifications[i]));
					}
				} else {
					processingNotification = true;
				}
			}
		});
		pageNotification = p + 1;
	}
}

function getNextAnswer(p, forseLoad) {
	if (processingAnswer) return false;

	if (($(window).scrollTop() >= $(document).height() - $(window).height() - 700) || forseLoad) {
		processingAnswer = true;

		$.ajax({
			url: '/ajax/answersgetnext',
			type: 'POST',
			dataType: 'json',
			data: {
				page: p
			},
			success: function (results) {
				if (results.status == 200) {
					processingAnswer = results.answers.length == 0;
					for (var i = 0; i < results.answers.length; i++) {
						$('.answers_container').before(generateAnswer(results.answers[i]));
					}
				} else {
					processingAnswer = true;
				}
			}
		});
		pageAnswer = p + 1;
	}
}

function generateNotification(notification) {
	var html = '';

	switch (notification.type){

		case '2':{
			html +=
				'<div class="answers_block">' +
					'<a href="/'+notification.alias+'" class="answers_block_avatar">' +
						'<img src="//'+notification.photo+'_sm.jpg" alt="'+notification.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';">' +
					'</a>' +
					'<p>' +
						'<a href="/'+notification.alias+'" class="answers_block_name">'+notification.fio+'</a> '+(notification.sex == 1 ? 'поделилась' : 'поделился')+' вашей <a href="/<?=$my['alias']?>/note/'+notification.post_id+'" style="color: #bf0c0e;">записью</a>' +
					'</p>' +
					'<div class="time">'+f_dt(notification.date)+'</div>' +
					'<div class="repost"></div>' +
				'</div>';
			break;
		}
		case '3':{
			html +=
				'<div class="answers_block">' +
					'<a href="/'+notification.alias+'" class="answers_block_avatar">' +
						'<img src="//'+notification.photo+'_sm.jpg" alt="'+notification.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';">' +
				'</a>' +
				'<p>' +
					'<a href="/'+notification.alias+'" class="answers_block_name">'+notification.fio+'</a> '+(notification.sex == 1 ? 'подписалась' : 'подписался')+' на Ваши обновления</p>' +
					'<div class="time">'+f_dt(notification.date)+'</div>' +
					'<div class="add"></div>' +
				'</div>';
			break;
		}
        case '8':{
            html +=
                '<div class="answers_block">' +
                '<a href="/'+notification.alias+'" class="answers_block_avatar">' +
                '<img src="//'+notification.photo+'_sm.jpg" alt="'+notification.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';">' +
                '</a>' +
                '<p>' +
                'Заявка на добавления Вас в друзья от пользователя <a href="/'+notification.alias+'" class="answers_block_name">'+notification.fio+'</a>' +
                '<div class="time">'+f_dt(notification.date)+'</div>' +
                '<div class="add"></div>' +
                '<a data-uid="'+notification.uid+'" class="button friend-add" href="#" data-ajax="1" style="margin: -10px 0 0 12px; float: left; display: block;">Добавить в друзья</a>' +
                '<a data-uid="'+notification.uid+'" class="friend-leave-in-subscribers" href="#" data-ajax="1" style="margin: -6px 0 0 15px; float: left; display: block; font-size: 13px;">Оставить в подписчиках</a>' +
                '<a data-uid="'+notification.uid+'" class="friend-cancel" href="#" data-ajax="1" style="margin: -5px 0 0 15px; float: left; display: block; font-size: 13px;">Отменить</a>' +
                '</div>';
            break;
        }
	}
	return html;
}

function generateAnswer(answer) {
	var html = '';

	switch (answer.type){
		case '4':{
			html +=
				'<div class="answers_block">' +
					'<a href="/'+answer.alias+'" class="answers_block_avatar">' +
						'<img src="//'+answer.photo+'_sm.jpg" alt="'+answer.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';">' +
					'</a>' +
					'<p>' +
						'<a href="/'+answer.alias+'" class="answers_block_name">'+answer.fio+'</a> '+(answer.sex == 1 ? ' оставила' : ' оставил')+ ' комментарий к Вашей <a href="/<?=$my['alias']?>/note/'+answer.post_id+'" style="color: #bf0c0e;">записи</a>' +
					'</p>' +
					'<div class="time">'+f_dt(answer.date)+'</div>' +
					'<div class="comment"></div>' +
				'</div>';
			break;
		}
		case '5':{
			html +=
				'<div class="answers_block">' +
				'<a href="/'+answer.alias+'" class="answers_block_avatar">' +
				'<img src="//'+answer.photo+'_sm.jpg" alt="'+answer.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';">' +
				'</a>' +
				'<p>' +
				'<a href="/'+answer.alias+'" class="answers_block_name">'+answer.fio+'</a> в ответ на Ваш комментарий <a href="/<?=$my['alias']?>?post='+answer.post_id+'">'+$.emotions(answer.text)+'</a>' +
				'</p>' +
				'<div class="time">'+f_dt(answer.date)+'</div>' +
				'<div class="answer"></div>' +
				'</div>';

			break;
		}

		case '6':{
			html +=
				'<div class="answers_block">' +
				'<a href="/'+answer.alias+'" class="answers_block_avatar">' +
				'<img src="//'+answer.photo+'_sm.jpg" alt="'+answer.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';">' +
				'</a>' +
				'<p>' +
				'<a href="/'+answer.alias+'" class="answers_block_name">'+answer.fio+'</a> '+(answer.sex == 1 ? ' оставила' : ' оставил')+ ' комментарий к Вашему <a href="/market/'+answer.post_id+'?t=3">товару</a>' +
				'</p>' +
				'<div class="time">'+f_dt(answer.date)+'</div>' +
				'<div class="comment"></div>' +
				'</div>';
			break;
		}
		case '7':{
			html +=
				'<div class="answers_block">' +
				'<a href="/'+answer.alias+'" class="answers_block_avatar">' +
				'<img src="//'+answer.photo+'_sm.jpg" alt="'+answer.fio+'" onerror="this.src=\'/images/no_avatar.jpg\';">' +
				'</a>' +
				'<p>' +
				'<a href="/'+answer.alias+'" class="answers_block_name">'+answer.fio+'</a> в ответ на Ваш комментарий <a href="/market/'+answer.post_id+'?t=3">'+$.emotions(answer.text)+'</a>' +
				'</p>' +
				'<div class="time">'+f_dt(answer.date)+'</div>' +
				'<div class="answer"></div>' +
				'</div>';

			break;
		}
	}

    html +=
    '<div class="messages_footer" id="replay_'+answer.id+'" style="display: none;">' +
        '<div class="row">' +
            '<div class="col-sm-2 img messages-avatar">' +
                '<img src="//<?=$my['photo'].'_sm.jpg'?>" alt="<?= $my['fio'] ?>" onerror="this.src=\'/images/no_avatar.jpg\';">' +
			'</div>' +
			'<div class="col-sm-8 ">' +
				'<div class="comment_form">' +
					'<form>' +
						'<div class="comment_form_text">' +
							'<div class="comment_form_adds">' +
								'<div class="smile">' +
									'<i class="fa fa-smile-o" style="font-size: 18px;"></i>' +
									'<div class="emotion_wrap">' +
										'<div class="emotion_cont">' +
											'<div class="emotion_tabs">' +
												'<a href="#" class="emotion_sprite shop"></a>' +
												'<a href="#" class="emotion_sprite all active"></a>' +
												'<a href="#" class="emotion_sprite last"></a>' +
												'<div class="emotion_tabs_cont">' +
													'<a href="#" class="emotion_sprite arrow_l"></a>' +
													'<div class="emotion_tabs_cont_in"></div>' +
													'<a href="#" class="emotion_sprite arrow_r"></a>' +
												'</div>' +
											'</div>' +
											'<div class="emotion_list">';
											    for(var i = 1; i <= 44; i++){
													html += '<a href="#" class="emotion_smile" data-id="'+i+'"><img src="/images/smile-images/smile'+i+'.jpg"></a>';
												}
											html +=
											'</div>' +
										'</div>' +
										'<div class="emotion_sprite emotion_pointer"></div>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="message-content" id="reply_field_'+answer.id+'" contentEditable="true">'+answer.name+',&nbsp;</div>' +
						'</div>' +
						'<a href="#" class="dialogs_button" id="send" onclick="wallSendReplay('+answer.post_id+','+answer.id+','+answer.comment_id+',this)">Отправить</a>' +
					'</form>' +
				'</div>' +
			'</div>' +
		'</div>' +
	'</div>';
	return html;
}

function wallSendReplay(post_id, answer_id, comment_id, elem) {
	event.preventDefault();

	$.each( $("#reply_field_"+answer_id+" img.emotions"), function(){
		$(this).replaceWith('(s:'+$(this).data('smile')+')');
	});

	var text = $('#reply_field_' + answer_id).html();

	if (text != '' && text.length <= 500) {
		$.ajax({
			url: '/ajax/comment',
			type: 'POST',
			dataType: 'json',
			data: {
				text: text,
				post_id: post_id,
				answer_id: comment_id
			},
			success: function (results) {
				if (results.status == 200) {
					$('#reply_field_' + answer_id).html('');
					$('#replay_' + answer_id).toggle();
				}
			}
		});
	}else{
		if(text.length > 500){
			BootstrapDialog.show({
				title: 'Предупреждение',
				message: 'Длина сообщения не должна превышать 500 символов.',
				animate: false,
				type: BootstrapDialog.TYPE_WARNING,
				closable: true,
				draggable: false,
				buttons: [
					{
						label: 'Закрыть',
						action: function (dialogItself) {
							dialogItself.close();
						}
					}]
			});
		}
	}
}

</script>