<?php

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/gr_search.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/group.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/friends.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/select2.min.css');

$connection = Yii::app()->db;

$alias = mysql_escape_string(htmlspecialchars(strip_tags($_GET["alias"])));
$user_info = !empty($alias) ? $connection->createCommand("SELECT uid, alias, CONCAT(name, ' ', fio) as fio FROM {{usersinfo}} WHERE alias = :alias")->bindParam(":alias", $alias)->queryRow() : $connection->createCommand("SELECT * FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
$my = $connection->createCommand("SELECT uid, CONCAT(name, ' ', fio) as 'fio', about, photo, alias FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
?>

<?php $this->widget('SideBarWidget', array(
    'my' => $my
)); ?>

<div class="col-sm-8 friends">
    <section class="friends_in">
        <div class="friends_header">
            <?php if($user_info['uid'] == Yii::app()->user->id){ ?>
                <a href="/recommend" class="tab active">Я рекомендую</a>
            <?php }else{ ?>
                <a href="/recommend?alias=<?=$alias?>" class="tab active"><?=$user_info['fio']?> рекомендует</a>
            <?php } ?>
        </div>
        <div class="friends_content" id="search-result">

        </div>
    </section>
</div>

<script type="application/javascript">
    var processing = false;
    var page = 1;

    $(document).ready(function () {
        $(document).scroll(function () {
            recommendFilter(page);
        });

        $('body').on('click', '.recommend-delete', function () {
            event.preventDefault();
            var elem = $(this);
            var id = $(this).attr('data-id');

            BootstrapDialog.show({
                title: 'Подтверждение',
                message: 'Удалить рекомендацию?',
                animate: false,
                buttons: [
                    {
                        label: 'Подтвердить',
                        cssClass: 'btn-success',
                        action: function (dialogItself) {

                            $.ajax({
                                url: '/goods/recommenddelete',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    id: id
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        $(elem).closest('.friends_block').remove();
                                    } else {
                                        message_info(results.message);
                                    }
                                }
                            });
                            dialogItself.close();
                        }
                    },
                    {
                        label: 'Отмена',
                        action: function (dialogItself) {
                            dialogItself.close();
                        }
                    }]
            });
        });

        recommendFilter(1, true);
    });

    function recommendFilter(p, forseLoad) {
        if (processing && !forseLoad) return false;

        var req = null;
        if (($(window).scrollTop() >= $(document).height() - $(window).height() - 700) || forseLoad) {
            processing = true;

            if (req != null) req.abort();
            if (forseLoad) $('#search-result').empty();
                req = $.ajax({
                    url: '/goods/recommendfilter',
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        alias: "<?=$alias?>",
                        page: page
                    },
                    success: function (results) {
                        if (results.status == 200) {
                            processing = results.recommends.length == 0;

                            if (results.recommends) {
                                $.each(results.recommends, function (key, val) {
                                    var html =  '<div class="friends_block">' +
                                    '<a href="' + val.url + '?rx=<?=$user_info['uid']?>" class="friends_block_avatar">' +
                                    '<img src="http://' + val.img + '_md.jpg" onError="this.src=\'/images/no_thumb.png\';">' +
                                    '</a>' +
                                    '<h3>' +
                                    '<a href="' + val.url + '?rx=<?=$user_info['uid']?>">' + f_replace(he.decode(val.title)) + '</a>' +
                                    '</h3>' +
                                    '<div class="time status" style="margin-right: 90px; max-height: 43px;">'+f_replace(he.decode(val.desc))+'</div>';
                                    <?php if($user_info['uid'] == Yii::app()->user->id){ ?>
                                        html += '<a href="#" class="friends_block_btn recommend-delete" data-id="' + val.id + '">Удалить</a>';
                                    <?php } ?>

                                    html += '</div>';
                                    $('#search-result').append(html);
                                });
                            }
                            $('#search-result').show(200);
                        } else {
                            processing = true;
                        }
                    }
                });
            page = p + 1;
        }
    }
</script>