<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/select2.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/friends.css');

$connection = Yii::app()->db;

$subscribers_count = $connection->createCommand("SELECT COUNT(*) FROM {{friends}} WHERE fuid = :uid AND status = 0")->bindParam(":uid", Yii::app()->user->id)->queryScalar();

$page = isset($_GET['page']) ? intval($_GET['page']) : 1;
$limit = Yii::app()->params['users-per-page'];

$users = $connection->createCommand("SELECT SQL_CALC_FOUND_ROWS u.uid, u.name, u.fio, u.status, u.photo, u.country, u.online, u.sex, u.alias, f.status as friend FROM {{usersinfo}} u INNER JOIN {{friends}} f ON f.fuid = :uid AND f.uid = u.uid AND f.status IN (0, 1) WHERE u.uid <> :uid AND u.type = 1 ORDER BY uid DESC LIMIT :limit OFFSET :offset")
		->bindParam(":uid", Yii::app()->user->id)
		->bindValue(":limit", $limit)
		->bindValue(":offset", ($page - 1) * $limit)
		->queryAll();
$totalRecords = $connection->createCommand('SELECT FOUND_ROWS()')->queryScalar();

$pages = new CPagination($totalRecords);
$pages->pageVar = 'page';
$pages->setPageSize($limit);

$cities = array();
?>

<div class="col-sm-4">
	<section class="friends_search">
		<div class="friends_search_header">
			Поиск друзей
		</div>
		<div class="friends_search_content">
			<form name="" action="" method="">
				<div class=" ">
					<div class="form-group">
						<label for="search_query">Имя:</label>
						<input type="text" class="form-control" id="search_query" placeholder=" ">
					</div>

					<div class="form-group">
						<label for="country">Страна:</label>
						<select class="form-control js-data-ajax-country" id="country">
							<option value="0" title="Не выбрана">Не выбрана</option>
						</select>
					</div>

					<div class="form-group" style="display: none">
						<label for="city">Город:</label>
						<select class="form-control js-data-ajax-city" id="city">
							<option value="0" title="Не выбран">Не выбран</option>
						</select>
					</div>

					<div class="form-group">
						<label>Возраст:</label>
						<select class="age_from" id="age-from">
							<option value="-1">От</option>
							<?php for ($i = 14; $i < 81; $i++) { ?>
								<option value="<?= $i ?>">от <?= $i ?></option>
							<?php } ?>
						</select>

						<select class="age_till" id="age-to">
							<option value="-1">До</option>
							<?php for ($i = 14; $i < 81; $i++) { ?>
								<option value="<?= $i ?>">до <?= $i ?></option>
							<?php } ?>
						</select>
					</div>

					<div class="form-group">
						<label for="sex">Пол:</label>
						<select class="form-control" id="sex">
							<option value="1">Женский</option>
							<option value="2">Мужской</option>
							<option value="0" selected>Любой</option>
						</select>
					</div>

					<div class="form-group marital-status" style="display: none;">
						<label for="marital_status">Семейное положение:</label>
						<select class="form-control" id="marital_status"></select>
					</div>
				</div>
			</form>
		</div>
	</section>
</div>
<div class="col-sm-8 friends">
	<section class="friends_in">
		<div class="friends_header">
            <a href="/users" class="tab">Пользователи</a>
            <a href="/friends" class="tab">Мои друзья</a>
            <a href="/subscribers" class="tab active">Входящие заявки <?=!empty($subscribers_count) ? '(+<span class="subscribers_count" style="color: #fff;">'.$subscribers_count.'</span>)' : ''?></a>
            <a href="/subscribersmy" class="tab">Исходящие заявки</a>
            <a href="/blacklist" class="tab">Чёрный список</a>
		</div>
		<div class="friends_content" id="search-result">
		</div>
	</section>
</div>

<script type="application/javascript">
	var processing = false;
	var page = <?= $page; ?>;
	var req = null;
	var timer = null;

    function subscribersSearch(filter, act, uid) {
        if (processing && !filter)
            return false;

        var req;
        if (($(window).scrollTop() >= $(document).height() - $(window).height() - 700) || filter) {
            processing = true;
            page = filter ? 1 : page + 1;

            var data = {};
            act = act != null ? act : 0;
            var country = $('#country').val();
            var city = $('#city').val();
            var sex = $('#sex').val();
            var marital_status = $('#marital_status').val();
            var age_from = $('#age-from').val();
            var age_to = $('#age-to').val();
            var search_query = $('#search_query').val();

            country > 0 && (data['country'] = country);
            city > 0 && (data['city'] = city);
            sex > 0 && (data['sex'] = sex);
            marital_status > 0 && (data['marital_status'] = marital_status);
            age_from > 0 && (data['age_from'] = age_from);
            age_to > 0 && (data['age_to'] = age_to);
            search_query.length > 2 && (data['search_query'] = search_query);
            uid != null && (data['uid'] = uid);
            data['page'] = page;
            data['act'] = act;

            if (req != null) req.abort();
            req = $.ajax({
                url: '/ajax/usearch',
                type: 'POST',
                dataType: 'json',
                data: data,
                success: function (results) {
                    if ((results.status == 200 && results.users) || filter) {
                        $('#search-results-total').html(results.total);
                        processing = false;
                        var html = '';

                        if (results.users) {
                            $.each(results.users, function (key, user) {
                                var friend = '';
                                var btn = '';

                                switch (parseInt(user.friend)){
                                    case 0:{
                                        btn += '<a data-uid="'+user.uid+'" class="friends_block_btn friend-add" href="#" data-ajax="1" style="margin-right: 248px;">Добавить в друзья</a>';
                                        btn += '<a data-uid="'+user.uid+'" class="friends_block_btn friend-leave-in-subscribers" href="#" data-ajax="1" style="margin-right: 110px;">В подписчики</a>';
                                        btn += '<a data-uid="'+user.uid+'" class="friends_block_btn friend-cancel" href="#" data-ajax="1">Отменить</a>';
                                        break;
                                    }
                                    case 1:{
                                        btn += '<a data-uid="'+user.uid+'" class="friends_block_btn friend-add" href="#" data-ajax="1" style="margin-right: 110px;">Добавить в друзья</a>';
                                        btn += '<a data-uid="'+user.uid+'" class="friends_block_btn friend-cancel" href="#" data-ajax="1">Отменить</a>';
                                        break;
                                    }
                                    default : break;
                                }
                                html +=
                                    '<div class="friends_block">' +
                                    '<a href="/' + user.alias + '" class="friends_block_avatar">' +
                                    '<img src="http://' + user.photo + '_sm.jpg" onError="this.src=\'/images/no_avatar.jpg\';">' +
                                    '</a>' +
                                    '<h3>' +
                                    '<a href="/' + user.alias + '">' + user.name + ' ' + user.fio + '</a>' +
                                    '</h3>' +
                                    '<div class="time status" data-online="' + f_online_status(user.online) + '"></div>' + btn + '</a>' +
                                    '</div>';
                            });
                        }
                        if (page == 1) {
                            $('#search-result').empty();
                        }
                        $('#search-result').append(html);
                    } else {
                        processing = true;
                        $('.cm-pagination').remove();
                    }
                },
                complete: function () {
                    req = null;
                }
            });
        }
    }

	$(document).ready(function () {

        subscribersSearch(true, 2);

        $('body').on('click', '.friend-leave-in-subscribers', function () {
            event.preventDefault();
            var elem = $(this);
            var uid = $(this).attr('data-uid');

            BootstrapDialog.show({
                title: 'Подтверждение',
                message: 'Оставить пользователя в подписчиках?',
                animate: false,
                buttons: [
                    {
                        label: 'Подтвердить',
                        cssClass: 'btn-success',
                        action: function (dialogItself) {

                            $.ajax({
                                url: '/user/friendleavesubscribed',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    uid: uid
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        $(elem).closest('.friends_block').find('.friend-add').css('margin-right', '110px');
                                        $(elem).remove();
                                        $('.subscribers_count').html(parseInt($('.subscribers_count').html()-1));
                                    } else {
                                        message_info(results.message);
                                    }
                                }
                            });
                            dialogItself.close();
                        }
                    },
                    {
                        label: 'Отмена',
                        action: function (dialogItself) {
                            dialogItself.close();
                        }
                    }]
            });
        });

        $('body').on('click', '.friend-add', function () {
            event.preventDefault();
            var elem = $(this);
            var uid = $(this).attr('data-uid');

            BootstrapDialog.show({
                title: 'Подтверждение',
                message: 'Добавить пользователя в друзья?',
                animate: false,
                buttons: [
                    {
                        label: 'Подтвердить',
                        cssClass: 'btn-success',
                        action: function (dialogItself) {

                            $.ajax({
                                url: '/user/friendadd',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    uid: uid
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        $(elem).closest('.friends_block').remove();
                                        $('.subscribers_count').html(parseInt($('.subscribers_count').html()-1));
                                    } else {
                                        message_info(results.message);
                                    }
                                }
                            });
                            dialogItself.close();
                        }
                    },
                    {
                        label: 'Отмена',
                        action: function (dialogItself) {
                            dialogItself.close();
                        }
                    }]
            });
        });

        $('body').on('click', '.friend-cancel', function () {
            event.preventDefault();
            var elem = $(this);
            var uid = $(this).attr('data-uid');

            BootstrapDialog.show({
                title: 'Подтверждение',
                message: 'Отменить заявку пользователя на добавление Вас в друзья?',
                animate: false,
                buttons: [
                    {
                        label: 'Подтвердить',
                        cssClass: 'btn-success',
                        action: function (dialogItself) {

                            $.ajax({
                                url: '/user/friendcancel',
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    uid: uid
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        $(elem).closest('.friends_block').remove();
                                        $('.subscribers_count').html(parseInt($('.subscribers_count').html()-1));
                                    } else {
                                        message_info(results.message);
                                    }
                                }
                            });
                            dialogItself.close();
                        }
                    },
                    {
                        label: 'Отмена',
                        action: function (dialogItself) {
                            dialogItself.close();
                        }
                    }]
            });
        });

		$(document).scroll(function () {
            subscribersSearch(false, 2);
		});

		$('#country').on('change', function() {
			if(this.value && this.value > 0){
				$('#city').empty();
				$('#select2-city-container').html('');
				$('#city').closest('.form-group').show(200);
			}else{
				$('#city').closest('.form-group').hide(200);
			}
		});

		$('body').on('click', '.subscribe', function () {
			event.preventDefault();

			var obj = this;
			$.ajax({
				url: '/ajax/subscribe',
				type: 'POST',
				dataType: 'json',
				data: {
					uid: $(obj).data("id")
				},
				success: function (results) {
					if (results.status == 200) {
						$(obj).html('Отписаться').toggleClass('subscribe unsubscribe');
					}
				}
			});
		});

		$('body').on('click', '.unsubscribe', function () {
			event.preventDefault();

			var obj = this;
			$.ajax({
				url: '/ajax/unsubscribe',
				type: 'POST',
				dataType: 'json',
				data: {
					uid: $(obj).data("id")
				},
				success: function (results) {
					if (results.status == 200) {
						$(obj).html('Подписка').toggleClass('unsubscribe subscribe');
					}
				}
			});
		});

		$('#country').change(function () {
			page = 1;
			var country = $(this);

			$.when(subscribersSearch(true, 2)).done(function () {
				if (country.val() && country.val() > 0) {
					$('#city').empty();

					$.ajax({
						url: '/ajax/cities',
						type: 'POST',
						dataType: 'json',
						data: {
							id: country.val()
						},
						success: function (results) {
							if (results.status == 200 && results.cities) {
								var text = '';
								text += '<option value="-1">Выбор города</option>';
								$.each(results.cities, function (key, city) {
									text += '<option value="' + city.city_id + '">' + city.city_name_ru + '</option>';
								});
								$('#city').append(text);
							}
						}
					});

					$('.city-block').show(200);
				} else {
					$('.city-block').hide(200);
				}

			});
		});

		$('#city, #marital_status, #sex').change(function () {
			page = 1;
            subscribersSearch(true, 2);
		});

		$('input:radio.radio_input').change(function () {
			page = 1;
            subscribersSearch(true, 2);
		});

		$('select#age-from').change(function () {
			var age_from = $(this).val();
			var html = '';
			var age_to = $('#age-to').val();
			$('#age-to').empty();
			html += '<option value="-1">До</option>';
			for (var i = age_from > 0 ? age_from : 14; i < 81; i++) {
				html += '<option value="' + i + '">до ' + i + '</option>';
			}
			$('#age-to').append(html).val(age_to);
			page = 1;
            subscribersSearch(true, 2);
		});

		$('select#age-to').change(function () {
			var age_to = $(this).val();
			var html = '';
			var age_from = $('#age-from').val();
			$('#age-from').empty();
			html += '<option value="-1">От</option>';
			for (var i = 14; i <= (age_to > 0 ? age_to : 80); i++) {
				html += '<option value="' + i + '">от ' + i + '</option>';
			}
			$('#age-from').append(html).val(age_from);
			page = 1;
            subscribersSearch(true, 2);
		});

		$('#search_query').keyup(function () {
			if ($(this).val().length >= 3 || $(this).val().length == 0) {
				if (timer) {
					clearTimeout(timer); //cancel the previous timer.
					timer = null;
				}
				timer = setTimeout(
						function () {
							page = 1;
                            subscribersSearch(true, 2);
						}, 500);

			}
		});

		$( ".status" ).each(function(){
			var t = $(this).attr('data-online');
			$(this).empty().html(f_online_status(t));
		});

		function formatRepoCountry (repo) {
			var term = $('.select2-container input').val();
			if(repo.title && repo.title.indexOf(term) >= 0){
				var res = repo.title.replace(term, "<b>"+term+"</b>");
				return '<div class="select2-results-text-option">'+res+'</div>';
			}
		}

		function formatRepo (repo) {
			if(repo.title){
				var term = $('.select2-container input').val();
				var res = repo.title.replace(term, "<b>"+term+"</b>");
				return '<div class="select2-results-text-option">'+res+'</div>';
			}
			if(repo.text) return '<div>'+repo.text+'</div>';
		}

		function formatRepoSelection (repo) {
			return repo.title;
		}

		$(".js-data-ajax-country").select2({
			ajax: {
				url: "/ajax/countries",
				type: 'POST',
				dataType: 'json',
				delay: 250,
				data: function (params) {
					return {
						q: params.term
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results: data.countries,
						pagination: {
							more: (params.page * 30) < data.total_count
						}
					};
				},
				cache: true
			},
			escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
			minimumInputLength: 2,
			templateResult: formatRepoCountry, // omitted for brevity, see the source of this page
			templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
		});

		$(".js-data-ajax-city").select2({
			ajax: {
				url: "/ajax/cities",
				type: 'POST',
				dataType: 'json',
				delay: 250,
				data: function (params) {
					return {
						q: params.term,
						id: $('#country').val()
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results: data.cities,
						pagination: {
							more: (params.page * 30) < data.total_count
						}
					};
				},
				cache: true
			},
			escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
			minimumInputLength: 2,
			templateResult: formatRepo, // omitted for brevity, see the source of this page
			templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
		});
	});

</script>