<link rel="stylesheet" type="text/css" href="/css/invitation2.css">
<?php

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . 'https://fonts.googleapis.com/css?family=Lato:400,700');

$connection = Yii::app()->db;

$my = $connection->createCommand("SELECT uid, name, fio, status, count_users, photo, package, alias FROM {{usersinfo}} WHERE uid = :uid")
	->bindParam(":uid", Yii::app()->user->id)
	->queryRow();

$status = '';
$color = '';
if ($my['status'] >= 0 && $my['count_users'] > 0) {
	$status = '(' . $my['count_users'] . ')';
	$color = 'style="color: green;"';
} elseif ($my['status'] == 0) {
	$status = '✓';
	$color = 'style="color: green;"';
}

$package_name = 'нет подписки';
switch($my['package']) {
	case 1:
		$package_name = "Trial";
		break;
	case 2:
		$package_name = "Mini";
		break;
	case 3:
		$package_name = "Lite";
		break;
	case 4:
		$package_name = "Medium";
		break;
	case 5:
		$package_name = "Standart";
		break;
	case 6:
		$package_name = "Super";
		break;
	case 7:
		$package_name = "Pro";
		break;
	case 8:
		$package_name = "Mega";
		break;
	case 9:
		$package_name = "Ultra";
		break;
	case 10:
		$package_name = "Vip";
		break;

}
$package_name = 'Подписка: ' . $package_name;
?>


<div class="col-sm-10 col-sm-offset-1 invitation">
	<section class="invitation_block section">
		<div class="invitation_header">
			
			<a href="/page/invite"><div>
				 Мои инвайты
			</div></a>
			
			<div class="active">
				Моя команда
			</div>
		</div>

		<div class="invitation_in">
			<p> </p>

			<div class="invitation_container">
				<div id="invitation_1" role="tab" class="panel-heading invitation_container_user">
					<a aria-controls="collapseThree_2" aria-expanded="false" href="#collapseThree_2" data-parent="#accordion" data-toggle="collapse" role="button" class="collapsed">
						<i class="fa fa-angle-down" data-id="<?=$my['uid']?>"></i>
						<i class="fa fa-angle-up"></i>
					</a>
					<span class="user_cont">
						<a class="avatar" target="_blank" href="/<?=$my['alias']?>"><img src="//<?=$my['photo']?>_sm.jpg" alt="<?=$my['name'].' '.$my['fio']?>" onerror="this.src='/images/no_avatar.jpg';"></a>
						<a target="_blank" href="/<?=$my['alias']?>" class="<?= $color ?>"><?=$my['name'].' '.$my['fio']?> <?=$status?></a>
						<span><?=$package_name?></span>
					</span>
					<span class="invitation_controls">
						<a target="_blank" href="/<?=$my['alias']?>"><img alt="logo" src="/images/home.png"></a>
<!--						<a href="#"><img alt="logo" src="/images/delete.png"></a>-->
					</span>
				</div>
				<div aria-labelledby="invitation_1" role="tabpanel" class="panel-collapse collapse invitation_container_sub" id="collapseThree_2" aria-expanded="false">
					<div class="panel-body">

					</div>
				</div>
			</div>
		</div>
	</section>
</div>


<script type="application/javascript">
	$(document).ready(function () {

		$('body').on('click', '.fa-angle-down', function () {
			var uid = $(this).attr('data-id');
			var elem = $(this);

			$.ajax({
				url: '/user/getmemberinvestors',
				type: 'POST',
				dataType: 'json',
				data: {
					uid: uid
				},
				success: function (results) {
					if (results.status == 200) {
						if (results.members) {
							var html = '';
							for (var i = 0; i < results.members.length; i++) {
								var level = '';
								var color = '';
								var btn = '';
								var package_name = 'Подписка: ' + userpackage(results.members[i].package);

								results.members[i].level = parseInt(results.members[i].level);
								if (results.members[i].level >= 0 && results.members[i].count_users > 0) {
									level = '(' + results.members[i].count_users + ')';
									color = 'style="color: green;"';
									btn += '<a aria-controls="collapseThree_<?=$my['uid']?>_'+results.members[i].uid+'" href="#collapseThree_<?=$my['uid']?>_'+results.members[i].uid+'" aria-expanded="false" data-parent="#accordion" data-toggle="collapse" role="button" class="collapsed"><i class="fa fa-angle-down" data-id="'+results.members[i].uid+'"></i><i class="fa fa-angle-up"></i></a>';
								} else {
									if (results.members[i].level >= 0) {
										level = '(✓)';
										color = 'style="color: green;"';
									}
									btn += '<a class="control-space"></a>';
								}

								html += '<div class="invitation_container">';
								html += '<div id="invitation_<?=$my['uid']?>_'+results.members[i].uid+'" role="tab" class="panel-heading invitation_container_user">';
								html +=  btn;
								html += '<span class="user_cont">';
								html += '<a class="avatar" target="_blank" href="/'+results.members[i].alias+'"><img src="http://' + results.members[i].photo + '_sm.jpg" alt="' + results.members[i].name + results.members[i].fio + '" onError="this.src=\'/images/no_avatar.jpg\';"></a>';
								html += '<a target="_blank" href="/'+results.members[i].alias+'">' + results.members[i].name + ' ' + results.members[i].fio + ' ' + level + '</a>';
								html += '<span>'+package_name+'</span>';
								html += '</span>';
								html += '<span class="invitation_controls">';
								html += '<a target="_blank" href="/'+results.members[i].alias+'"><img alt="logo" src="/images/home.png"></a>';
//								html += '<a href="#"><img alt="logo" src="/images/delete.png"></a>';
								html += '</span>';
								html += '</div>';
								html += '<div aria-labelledby="invitation_<?=$my['uid']?>_'+results.members[i].uid+'" id="collapseThree_<?=$my['uid']?>_'+results.members[i].uid+'" role="tabpanel" class="panel-collapse collapse invitation_container_sub" aria-expanded="false">';
								html += '<div class="panel-body">';
								html += '</div>';
								html += '</div>';
								html += '</div>';
							}

							elem.closest('.invitation_container').find('.panel-body').empty().append(html);
						}
					} else {
						message_info(results.message);
					}
				}
			});
		});
	});
</script>