<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/select2.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/settings.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/queries.css');

$connection = Yii::app()->db;

$my_info = $connection->createCommand("SELECT uid, name, fio, birth, CONCAT(name, ' ', fio) AS full_name, sex, marital_status, country, city, tel, skype, interests, activities, about, photo, alias, status, online FROM {{usersinfo}} WHERE uid = :uid")->bindParam(":uid", Yii::app()->user->id)->queryRow();
if(!empty($my_info['country'])){
	$country = Loc::getCountryById($my_info['country']);
	$my_info['country_name_ru'] = $country['title'];
}
if(!empty($my_info['city'])){
	$city = Loc::getCityById($my_info['city']);
	$my_info['city_name_ru'] = $city['title'];
}

$bYear = date('Y', strtotime($my_info['birth']));
$bMonth = intval(date('m', strtotime($my_info['birth'])));
$bDay = date('d', strtotime($my_info['birth']));

$months = array (1 => "Январь", 2 => "Февраль", 3 => "Март", 4 => "Апрель", 5 => "Май", 6 => "Июнь", 7 => "Июль", 8 => "Август", 9 => "Сентябрь", 10 => "Октябрь", 11 => "Ноябрь", 12 => "Декабрь");
?>

<?php $this->widget('SideBarWidget', array(
	'my' => $my_info
)); ?>


<div class="col-sm-8 settings" style="display: block;">
	<section  class="settings_in">
		<div class="settings_header">
			<div class="tab active" rel="general-settings">
				Основное
			</div>
			<div class="tab" rel="contacts-settings">
				Контактная информация
			</div>
<!--			<div class="tab" rel="private-settings">-->
<!--				Личная информация-->
<!--			</div>-->
			<div class="tab" rel="private-goals">
				Мои цели
			</div>
		</div>
		<div class="general-settings tab-block" style="display: block;">
			<form name="" action="" method="">
				<div class="col-sm-6 col-sm-offset-3 col-xs-12 settings_content_wrap">
					<div class="form-group">
						<label for="username">Имя:</label>
						<input type="text" class="form-control" id="username" placeholder=" " value="<?= $my_info['name'] ?>" disabled>
					</div>
					<div class="form-group">
						<label for="fio">Фамилия:</label>
						<input type="text" class="form-control" id="fio" placeholder=" " value="<?= $my_info['fio'] ?>" disabled>
					</div>
					<div class="form-group">
						<label for="sex">Пол:</label>
						<select class="form-control" id="sex">
							<option value="0">Не выбрано</option>
							<option value="1" <?= $my_info['sex'] == 1 ? 'selected="selected"' : '' ?>>женский</option>
							<option value="2" <?= $my_info['sex'] == 2 ? 'selected="selected"' : '' ?>>мужской</option>
						</select>
					</div>

					<div class="form-group">
						<label for="marital_status">Семейное положение:</label>
						<select class="form-control" id="marital_status"></select>
					</div>

					<div class="form-group">
						<label for="bday">День рождения:</label>
						<select class="birth_day" id="bday"></select>
						<select class="birth_month" id="bmonth"></select>
						<select class="birth_year" id="byear"></select>
					</div>
				</div>
				<div class="settings_content_footer">
					<a href="#" class="settings_btn" onclick="editBasicInfo(this);">Сохранить</a>
				</div>
			</form>
		</div>
		<div class="contacts-settings tab-block" style="display: none;">
			<form name="" action="" method="">
				<div class="col-sm-6 col-sm-offset-3 col-xs-12 settings_content_wrap">
					<div class="form-group">
						<label for="country">Страна:</label>
						<select class="form-control js-data-ajax-country" id="country" style="display: none;">
							<?php if(!empty($my_info['country'])){ ?>
								<option value="<?=$my_info['country']?>" title="<?=$my_info['country_name_ru']?>"><?=$my_info['country_name_ru']?></option>
							<?php } ?>
						</select>
					</div>

					<div class="form-group">
						<label for="city">Город:</label>
						<select class="form-control js-data-ajax-city" id="city" style="display: none;">
							<?php if(!empty($my_info['city'])){ ?>
								<option value="<?=$my_info['city']?>" title="<?=$my_info['city_name_ru']?>"><?=$my_info['city_name_ru']?></option>
							<?php } ?>
						</select>
					</div>

					<div class="form-group">
						<label for="username">Номер телефона:</label>
						<input type="text" class="form-control" id="tel" placeholder=" " value="<?= $my_info['tel'] ?>">
					</div>

					<div class="form-group">
						<label for="username">Skype:</label>
						<input type="text" class="form-control" id="skype" placeholder=" " value="<?= $my_info['skype'] ?>">
					</div>
				</div>

				<div class="settings_content_footer">
					<a href="#" class="settings_btn" onclick="editContactInfo(this);">Сохранить</a>
				</div>
			</form>
		</div>
		<div class="private-settings tab-block" style="display: none;">
			<form name="" action="" method="">
				<div class="col-sm-6 col-sm-offset-3 col-xs-12 settings_content_wrap">
					<div class="form-group">
						<label for="username">Интересы:</label>
						<textarea class="form-control" id="interests" placeholder=" "><?= $my_info['interests'] ?></textarea>
					</div>

					<div class="form-group">
						<label for="username">Деятельность:</label>
						<textarea class="form-control" id="activities" placeholder=" "><?= $my_info['activities'] ?></textarea>
					</div>

					<div class="form-group">
						<label for="username">О себе:</label>
						<textarea class="form-control" id="about" placeholder=" "><?= $my_info['about'] ?></textarea>
					</div>
				</div>
				<div class="settings_content_footer">
					<a href="#" class="settings_btn" onclick="editPersonalInfo(this);">Сохранить</a>
				</div>
			</form>
		</div>
		<div class="private-goals tab-block settings_content" style="display: none;" data-load="0">
			<p></p>

			<form name="" action="#" method="post" class="goal_form">
				<div class=" ">
					<div class="col-md-7 col-sm-5">
						<label for="goal-name">Название цели</label>
						<input type="text" placeholder=" " id="goal-name" class="form-control">
					</div>
					<div class="col-md-3 col-sm-4">
						<label for="goal-price">Необходимая сумма</label>
						<input type="text" placeholder=" " id="goal-price" class="form-control">

					</div>
					<div class="col-md-2 col-sm-3">
						<a href="#" class="button goal-add">Добавить</a>
					</div>
				</div>
			</form>

			<div class="goals-wrapper">
				<table class="table table-hover goals-table">
					<thead>
					<tr>
						<th>№</th>
						<th>Название</th>
						<th>Цена</th>
						<th>Выполнено</th>
						<th></th>
					</tr>
					</thead>
					<tbody></tbody>
				</table>
			</div>

			<div class="progress_wrap">
				<p>Выполнено на <span>0%</span></p>
				<div class="row_progress ">
					<div class="row_progress_in" style="width: 0%;">

					</div>
				</div>
			</div>
		</div>
	</section>
</div>
<script type="application/javascript">
var male_status = ['Не выбрано','Не женат','Встречаюсь','Помолвлен','Женат','Влюблён','Всё сложно','В активном поиске'];
var female_status = ['Не выбрано','Не замужем','Встречаюсь','Помолвлена','Замужем','Влюблёна','Всё сложно','В активном поиске'];

$('document').ready(function () {

	$(".js-data-ajax-city").select2({
		ajax: {
			url: "/ajax/cities",
			type: 'POST',
			dataType: 'json',
			delay: 250,
			data: function (params) {
				return {
					q: params.term,
					id: $('#country').val()
				};
			},
			processResults: function (data, params) {
				params.page = params.page || 1;
				return {
					results: data.cities,
					pagination: {
						more: (params.page * 30) < data.total_count
					}
				};
			},
			cache: true
		},
		escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
		minimumInputLength: 2,
		templateResult: formatRepo, // omitted for brevity, see the source of this page
		templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
	});

	$('#sex').on('change', function() {
		var val = $(this).val();
		updateMaritalStatus(val, 0);
	});

	$('body').on('keyup', '#username, #fio', function (e) {
		var rv_name = /^[а-яА-Я]+$/;
		var str = $(this).val();

		if(!rv_name.test(str)){
			e.preventDefault();
			str = str.replace(/[^а-яА-Я]/g,"");
			$(this).val(str);
			error('<p>Недопустимый формат.</p>');
		}else{
			$('.error-summary').fadeOut(500, function() {
				$('.error-summary ul').empty();
			});
		}
	});

	$('#tel').bind("change keyup input click", function() {
		if (this.value.match(/[^0-9]/g)) {
			this.value = this.value.replace(/[^0-9]/g, '');
		}
	});

	$('body').on('click', '.tab', function () {
		var page = $(this).attr('rel');
		$('.tab').removeClass('active');
		$(this).addClass('active');

		$('.tab-block').hide();
		$('.'+page).show();
	});

	$('#country').on('change', function() {
		if(this.value && this.value > 0){
			$('#city').empty();

			$.ajax({
				url: '/ajax/cities',
				type: 'POST',
				dataType: 'json',
				data: {
					id: this.value
				},
				success: function (results) {
					if (results.status == 200 && results.cities) {
						var text = '';
						text += '<option value="-1"> </option>';
						$.each( results.cities, function( key, city ) {
							text += '<option value="'+city.city_id+'">'+city.city_name_ru+'</option>';
						});
						$('#city').append(text);
					}
				}
			});
		}
	});

	$(function() {

		//populate our years select box
		for (var i = new Date().getFullYear()-14; i > 1900; i--){
			$('#byear').append($('<option />').val(i).html(i));
		}
		$('#byear').val(<?= $bYear ?>);

		//populate our months select box
		var months = ["Январь", "Февраль", "Март", "Апрель", "Май", "Июнь", "Июль", "Август", "Сентябрь", "Октябрь", "Ноябрь", "Декабрь"];
		for (i = 0; i < 12; i++){
			$('#bmonth').append($('<option />').val(i+1).html(months[i]));
		}
		$('#bmonth').val(<?= $bMonth ?>);

		//populate our Days select box
		updateNumberOfDays();
		$('#bday').val(<?= $bDay ?>);

		//"listen" for change events
		$('#byear, #bmonth').change(function(){
			updateNumberOfDays();
		});

	});
});


function editContactInfo(obj){
	event.preventDefault();
	var err = '';

	var country = $('#country').val();
	var city = $('#city').val();
	var tel = $('#tel').val();
	var skype = $('#skype').val();


	var skype_rule = /^\w+(\.\w+)?$/;
	if(skype != '' && !skype_rule.test(skype)){
		err += '<p>Skype указано неверно.</p>';
	}
	if(err == ''){
		$.ajax({
			url: '/ajax/editcontactinfo',
			type: 'POST',
			dataType: 'json',
			data: {
				country: country,
				city: city,
				tel: tel,
				skype: skype
			},
			success: function (results) {
				if (results.status == 200) {
					success('Настройки успешно сохранены!');
				}
			}
		});
	}else{
		error(err);
	}
}

function editPersonalInfo(obj){
	event.preventDefault();

	var interests = $('#interests').val();
	var activities = $('#activities').val();
	var about = $('#about').val();

	$.ajax({
		url: '/ajax/editpersonalinfo',
		type: 'POST',
		dataType: 'json',
		data: {
			interests: interests,
			activities: activities,
			about: about
		},
		success: function (results) {
			if (results.status == 200) {
				success('Настройки успешно сохранены!');
			}
		}
	});
}

function editBasicInfo(obj){
	event.preventDefault();

	var sex = $('#sex').val();
	var marital_status = $('#marital_status').val();
	var bday = $('#bday').val();
	var bmonth = $('#bmonth').val();
	var byear = $('#byear').val();

	$.ajax({
		url: '/ajax/editbasicinfo',
		type: 'POST',
		dataType: 'json',
		data: {
			sex: sex,
			marital_status: marital_status,
			bday: bday,
			bmonth: bmonth,
			byear: byear
		},
		success: function (results) {
			if (results.status == 200) {
				success('Настройки успешно сохранены!');
			}
		}
	});
}

function updateMaritalStatus(sex, status){
	if(sex == 1 || sex == 2){
		$('#marital_status option').remove();
		var html = '';
		for(var i = 0; i <= 7; i++){
			if(sex == 1){
				html += '<option value="'+i+'">'+female_status[i]+'</option>';
			}else{
				if(sex == 2){
					html += '<option value="'+i+'">'+male_status[i]+'</option>';
				}
			}
		}
		$('#marital_status').append(html).val(status);
		$('#marital_status').closest('.form-group').show(200);
	}else{
		$('#marital_status').closest('.form-group').hide(200);
	}
}

//function to update the days based on the current values of month and year
function updateNumberOfDays(){
	var selected = $('#bday').val();
	$('#bday').html('');
	month = $('#bmonth').val();
	year = $('#byear').val();
	days = daysInMonth(month, year);

	for(var i=1; i < days+1 ; i++){
		$('#bday').append($('<option />').val(i).html(i));
	}
	$('#bday').val(selected <= days ? selected : 1);
}

//helper function
function daysInMonth(month, year) {
	return new Date(year, month, 0).getDate();
}

updateMaritalStatus(<?=$my_info['sex']?>, <?=$my_info['marital_status']?>);
</script>