<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/main.css');


Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/select2.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl.'/css/friends.css');

$connection = Yii::app()->db;

$subscribers_count = $connection->createCommand("SELECT COUNT(*) FROM {{friends}} WHERE fuid = :uid AND status = 0")->bindParam(":uid", Yii::app()->user->id)->queryScalar();

$page = isset($_GET['page']) ? intval($_GET['page']) : 1;
$limit = Yii::app()->params['users-per-page'];

$users = $connection->createCommand("SELECT SQL_CALC_FOUND_ROWS u.uid, u.name, u.fio, u.status, u.photo, u.country, u.online, u.alias, (f.id IS NOT NULL) AS friend FROM {{usersinfo}} u LEFT JOIN {{friends}} f ON f.uid = :uid AND f.fuid = u.uid WHERE u.uid <> :uid AND u.type = 1 AND u.status = 1 ORDER BY uid DESC LIMIT :limit OFFSET :offset")
		->bindParam(":uid", Yii::app()->user->id)
		->bindValue(":limit", $limit)
		->bindValue(":offset", ($page - 1) * $limit)
		->queryAll();
$totalRecords = $connection->createCommand('SELECT FOUND_ROWS()')->queryScalar();

$pages = new CPagination($totalRecords);
$pages->pageVar = 'page';
$pages->setPageSize($limit);

$cities = array();
?>

<div class="col-sm-4">
	<section class="friends_search">
		<div class="friends_search_header">
			Поиск друзей
		</div>
		<div class="friends_search_content">
			<form name="" action="" method="">
				<div class=" ">
					<div class="form-group">
						<label for="search_query">Имя:</label>
						<input type="text" class="form-control" id="search_query" placeholder=" ">
					</div>

					<div class="form-group">
						<label for="country">Страна:</label>
						<select class="form-control js-data-ajax-country" id="country">
							<option value="0" title="Не выбрана">Не выбрана</option>
						</select>
					</div>

					<div class="form-group" style="display: none">
						<label for="city">Город:</label>
						<select class="form-control js-data-ajax-city" id="city">
							<option value="0" title="Не выбран">Не выбран</option>
						</select>
					</div>

					<div class="form-group">
						<label>Возраст:</label>
						<select class="age_from" id="age-from">
							<option value="-1">От</option>
							<?php for ($i = 14; $i < 81; $i++) { ?>
								<option value="<?= $i ?>">от <?= $i ?></option>
							<?php } ?>
						</select>

						<select class="age_till" id="age-to">
							<option value="-1">До</option>
							<?php for ($i = 14; $i < 81; $i++) { ?>
								<option value="<?= $i ?>">до <?= $i ?></option>
							<?php } ?>
						</select>
					</div>

					<div class="form-group">
						<label for="sex">Пол:</label>
						<select class="form-control" id="sex">
							<option value="1">Женский</option>
							<option value="2">Мужской</option>
							<option value="0" selected>Любой</option>
						</select>
					</div>

					<div class="form-group marital-status" style="display: none;">
						<label for="marital_status">Семейное положение:</label>
						<select class="form-control" id="marital_status"></select>
					</div>
				</div>
			</form>
		</div>
	</section>
</div>
<div class="col-sm-8 friends">
	<section class="friends_in">
		<div class="friends_header">
			<a href="/users" class="tab active">Пользователи</a>
            <a href="/friends" class="tab">Мои друзья</a>
            <a href="/subscribers" class="tab">Входящие заявки <?=!empty($subscribers_count) ? '(+'.$subscribers_count.')' : ''?></a>
			<a href="/subscribersmy" class="tab">Исходящие заявки</a>
			<a href="/blacklist" class="tab">Чёрный список</a>
		</div>
		<div class="friends_content" id="search-result">
			<?php foreach ($users as $user) { ?>
				<div class="friends_block">
					<a href="/<?=$user['alias']?>" class="friends_block_avatar"><img src="//<?= $user['photo'] ?>_sm.jpg" onError="this.src='/images/no_avatar.jpg';" alt="<?= $user['fio'] ?>"></a>
					<h3><a href="/<?=$user['alias']?>"><?= $user['name'].' '.$user['fio'] ?></a></h3>
					<div class="time status" data-online="<?=$user['online']?>"></div>
					<a href="#" class="friends_block_btn <?= !empty($user['friend']) ? 'unsubscribe' : 'subscribe' ?>" data-id="<?= $user['uid'] ?>"><?= !empty($user['friend']) ? 'Убрать из друзей' : 'Добавить в друзья' ?></a>
				</div>
			<?php } ?>
		</div>
	</section>
</div>

<script type="application/javascript">
	var processing = false;
	var page = <?= $page; ?>;
	var req = null;
	var timer = null;

	$(document).ready(function () {

		$(document).scroll(function () {
			userSearch();
		});

		$('#country').on('change', function() {
			if(this.value && this.value > 0){
				$('#city').empty();
				$('#select2-city-container').html('');
				$('#city').closest('.form-group').show(200);
			}else{
				$('#city').closest('.form-group').hide(200);
			}
		});

		$('body').on('click', '.subscribe', function () {
			event.preventDefault();

			var obj = this;
			$.ajax({
				url: '/ajax/subscribe',
				type: 'POST',
				dataType: 'json',
				data: {
					uid: $(obj).data("id")
				},
				success: function (results) {
					if (results.status == 200) {
						$(obj).html('Убрать из друзей').toggleClass('subscribe unsubscribe');
					}
				}
			});
		});

		$('body').on('click', '.unsubscribe', function () {
			event.preventDefault();

			var obj = this;
			$.ajax({
				url: '/ajax/unsubscribe',
				type: 'POST',
				dataType: 'json',
				data: {
					uid: $(obj).data("id")
				},
				success: function (results) {
					if (results.status == 200) {
						$(obj).html('Добавить в друзья').toggleClass('unsubscribe subscribe');
					}
				}
			});
		});

		$('#country').change(function () {
			page = 1;
			var country = $(this);

			$.when(userSearch(true)).done(function () {
				if (country.val() && country.val() > 0) {
					$('#city').empty();

					$.ajax({
						url: '/ajax/cities',
						type: 'POST',
						dataType: 'json',
						data: {
							id: country.val()
						},
						success: function (results) {
							if (results.status == 200 && results.cities) {
								var text = '';
								text += '<option value="-1">Выбор города</option>';
								$.each(results.cities, function (key, city) {
									text += '<option value="' + city.city_id + '">' + city.city_name_ru + '</option>';
								});
								$('#city').append(text);
							}
						}
					});

					$('.city-block').show(200);
				} else {
					$('.city-block').hide(200);
				}

			});
		});

		$('#city, #marital_status, #sex').change(function () {
			page = 1;
			userSearch(true);
		});

		$('input:radio.radio_input').change(function () {
			page = 1;
			userSearch(true);
		});

		$('select#age-from').change(function () {
			var age_from = $(this).val();
			var html = '';
			var age_to = $('#age-to').val();
			$('#age-to').empty();
			html += '<option value="-1">До</option>';
			for (var i = age_from > 0 ? age_from : 14; i < 81; i++) {
				html += '<option value="' + i + '">до ' + i + '</option>';
			}
			$('#age-to').append(html).val(age_to);
			page = 1;
			userSearch(true);
		});

		$('select#age-to').change(function () {
			var age_to = $(this).val();
			var html = '';
			var age_from = $('#age-from').val();
			$('#age-from').empty();
			html += '<option value="-1">От</option>';
			for (var i = 14; i <= (age_to > 0 ? age_to : 80); i++) {
				html += '<option value="' + i + '">от ' + i + '</option>';
			}
			$('#age-from').append(html).val(age_from);
			page = 1;
			userSearch(true);
		});

		$('#search_query').keyup(function () {
			if ($(this).val().length >= 3 || $(this).val().length == 0) {
				if (timer) {
					clearTimeout(timer); //cancel the previous timer.
					timer = null;
				}
				timer = setTimeout(
						function () {
							page = 1;
							userSearch(true);
						}, 500);

			}
		});

		$( ".status" ).each(function(){
			var t = $(this).attr('data-online');
			$(this).empty().html(f_online_status(t));
		});

		function formatRepoCountry (repo) {
			var term = $('.select2-container input').val();
			if(repo.title && repo.title.indexOf(term) >= 0){
				var res = repo.title.replace(term, "<b>"+term+"</b>");
				return '<div class="select2-results-text-option">'+res+'</div>';
			}
		}

		function formatRepo (repo) {
			if(repo.title){
				var term = $('.select2-container input').val();
				var res = repo.title.replace(term, "<b>"+term+"</b>");
				return '<div class="select2-results-text-option">'+res+'</div>';
			}
			if(repo.text) return '<div>'+repo.text+'</div>';
		}

		function formatRepoSelection (repo) {
			return repo.title;
		}

		$(".js-data-ajax-country").select2({
			ajax: {
				url: "/ajax/countries",
				type: 'POST',
				dataType: 'json',
				delay: 250,
				data: function (params) {
					return {
						q: params.term
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results: data.countries,
						pagination: {
							more: (params.page * 30) < data.total_count
						}
					};
				},
				cache: true
			},
			escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
			minimumInputLength: 2,
			templateResult: formatRepoCountry, // omitted for brevity, see the source of this page
			templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
		});

		$(".js-data-ajax-city").select2({
			ajax: {
				url: "/ajax/cities",
				type: 'POST',
				dataType: 'json',
				delay: 250,
				data: function (params) {
					return {
						q: params.term,
						id: $('#country').val()
					};
				},
				processResults: function (data, params) {
					params.page = params.page || 1;
					return {
						results: data.cities,
						pagination: {
							more: (params.page * 30) < data.total_count
						}
					};
				},
				cache: true
			},
			escapeMarkup: function (markup) { return markup; }, // let our custom formatter work
			minimumInputLength: 2,
			templateResult: formatRepo, // omitted for brevity, see the source of this page
			templateSelection: formatRepoSelection // omitted for brevity, see the source of this page
		});
	});

</script>