<?php
/* @var $my */

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/bootstrap-dialog.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/font-awesome.min.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/main.css');

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/post2.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/group.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/video.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/comments.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/smiles.m.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/queries.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/invitation.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . 'https://fonts.googleapis.com/css?family=Lato:400,700');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/gr_search.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/gr_create.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/css/tampletes.css');

$connection = Yii::app()->db;

$my = $connection->createCommand("SELECT uid, marital_status, CONCAT(name, ' ', fio) AS 'full_name', tel, sex, skype, city, interests, activities, about, photo, alias, status, online FROM {{usersinfo}} WHERE uid = :uid")
    ->bindParam(":uid", Yii::app()->user->id)
    ->queryRow();
?>

<?php $this->widget('SideBarWidget', array(
    'my' => $my
)); ?>

<!-- Ваучеры -->
<div class="col-sm-8 invitation">
    <section class="invitation_block section">
        <div class="invitation_header">
            <div class="active">
                Ваши ваучеры
            </div>
        </div>

        <div class="invitation_in">
            <p></p>

            <div class="activeinvitses">
                <h4>Используемые ваучеры</h4>

                <table class="table table-hover table-template voucher-codes-table-active">
                    <thead>
                    <tr>
                        <th>Пользователь</th>
                        <th>Ваучер</th>
                        <th>Пакет</th>
                        <th>Стоимость</th>
                        <th>Действия</th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
                <br>
                <h4>Свободные ваучеры</h4>

                <table class="table table-hover table-template voucher-codes-table">
                    <thead>
                    <tr>
                        <th>Пользователь</th>
                        <th>Ваучер</th>
                        <th>Пакет</th>
                        <th>Сумма</th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
                <br>
            </div>
    </section>
</div>

<script type="application/javascript">

    function getUserVoucher() {

        $(".voucher-codes-table tbody").fadeOut(300);

        $.ajax({
            type: 'POST',
            url: '/voucher/getuservoucher',
            dataType: 'json',
            data: {},
            success: function (results) {
                var html = '';
                if (results.status == 200) {
                    if (results.voucher.length > 0) {
                        $.each(results.voucher, function (key, val) {
                            var type = parseInt(val.type);

                            html += '<tr rel="'+val.id+'">';
                            html += '<td class="user-voucher-active">Ваучер не занят</td>';
                            html += '<td>'+val.voucher+'</td>';
                            html += '<td>'+(type == 1 ? userpackage(val.package) : 'пополнение')+'</td>';
                            html += '<td>'+val.amount+'</td>';
                            html += '</tr>';
                        });
                    } else {
                        html += '<tr><td colspan="5">У Вас нет доступных ваучеров.</td></tr>';
                    }

                    $(".voucher-codes-table tbody").html(html);

                    //==============================================================

                    html = '';

                    if (results.voucheractive.length > 0) {
                        $.each(results.voucheractive, function (key, val) {
                            var type = parseInt(val.type);
                            var btn = '';

                            if(val.status == 0){
                                btn += '<a href="#" class="element el_small el_red btn_voucher_activate" title="Активировать" uid="' + val.uid_activate + '" data-type="' + val.type + '" rel="' + val.id + '" user="' + val.user_name + ' ' + val.user_fio + '"><img src="/images/icons/light.png"></a> ';
                            }

                            html +=
                                '<tr rel="' + val.id + '">' +
                                    '<td class="user-invite-active">' +
                                        '<span class="img">' +
                                            '<a href="/' + val.user_alias + '" target="_blank">' +
                                                '<img src="//' + val.user_photo + '_sm.jpg" alt="" onerror="this.src=\'/images/no_avatar.jpg\';">' +
                                            '</a>' +
                                        '</span>' +
                                        '<span>' +
                                            '<a href="/' + val.user_alias + '" target="_blank">' + val.user_name + ' ' + val.user_fio + '</a>' +
                                                '<span>Подписка: ' + userpackage(val.user_package) + '</span>' +
                                        '</span>' +
                                    '</td>' +
                                    '<td>' + val.voucher + '</td>' +
                                    '<td>'+(type == 1 ? userpackage(val.package) : 'пополнение')+'</td>' +
                                    '<td>' + val.amount + '</td>' +
                                    '<td>' + btn + '</td>' +
                                '</tr>';

                        });

                    } else {
                        html += '<tr><td colspan="5">Ваши ваучеры еще никто не использовал.</td></tr>';
                    }

                    $(".voucher-codes-table-active tbody").html(html);

                }
            }
        });
        $(".voucher-codes-table tbody").fadeIn(500);
    }

    $(document).ready(function () {
        $('body').on('click', '.btn_voucher_activate', function () {
            var elem = $(this);
            var voucher_id = $(this).attr('rel');
            var voucher_type = parseInt($(this).attr('data-type'));

            BootstrapDialog.show({
                title: 'Сообщение',
                message: 'Вы уверены?',
                animate: false,
                buttons: [
                    {
                        label: 'Подтвердить',
                        cssClass: 'btn-success',
                        action: function (dialogItself) {
                            $.ajax({
                                url: (voucher_type == 1 ? '/voucher/setvoucheractivate' : '/voucher/setvoucherpotentialactivatenew'),
                                type: 'POST',
                                dataType: 'json',
                                data: {
                                    voucher: voucher_id
                                },
                                success: function (results) {
                                    if (results.status == 200) {
                                        message_info(results.message);
                                        dialogItself.close();
                                        $(elem).remove();
                                    } else {
                                        message_info(results.message);
                                    }
                                }
                            });
                            dialogItself.close();
                        }
                    },
                    {
                        label: 'Отмена',
                        action: function (dialogItself) {
                            dialogItself.close();
                        }
                    }]
            });
        });

        getUserVoucher();
    });

</script>